<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# accumulator

```go
import "github.com/coinbase/kryptology/pkg/accumulator"
```

## Index

- [type Accumulator](<#type-accumulator>)
  - [func (acc *Accumulator) Add(key *SecretKey, e Element) (*Accumulator, error)](<#func-accumulator-add>)
  - [func (acc *Accumulator) AddElements(key *SecretKey, m []Element) (*Accumulator, error)](<#func-accumulator-addelements>)
  - [func (acc Accumulator) MarshalBinary() ([]byte, error)](<#func-accumulator-marshalbinary>)
  - [func (acc *Accumulator) New(curve *curves.PairingCurve) (*Accumulator, error)](<#func-accumulator-new>)
  - [func (acc *Accumulator) Remove(key *SecretKey, e Element) (*Accumulator, error)](<#func-accumulator-remove>)
  - [func (acc *Accumulator) UnmarshalBinary(data []byte) error](<#func-accumulator-unmarshalbinary>)
  - [func (acc *Accumulator) Update(key *SecretKey, additions []Element, deletions []Element) (*Accumulator, []Coefficient, error)](<#func-accumulator-update>)
  - [func (acc *Accumulator) WithElements(curve *curves.PairingCurve, key *SecretKey, m []Element) (*Accumulator, error)](<#func-accumulator-withelements>)
- [type Coefficient](<#type-coefficient>)
- [type Delta](<#type-delta>)
  - [func (d *Delta) MarshalBinary() ([]byte, error)](<#func-delta-marshalbinary>)
  - [func (d *Delta) UnmarshalBinary(data []byte) error](<#func-delta-unmarshalbinary>)
- [type Element](<#type-element>)
- [type MembershipProof](<#type-membershipproof>)
  - [func (mp *MembershipProof) Finalize(acc *Accumulator, pp *ProofParams, pk *PublicKey, challenge curves.Scalar) *MembershipProofFinal](<#func-membershipproof-finalize>)
  - [func (mp MembershipProof) MarshalBinary() ([]byte, error)](<#func-membershipproof-marshalbinary>)
  - [func (mp *MembershipProof) UnmarshalBinary(data []byte) error](<#func-membershipproof-unmarshalbinary>)
- [type MembershipProofCommitting](<#type-membershipproofcommitting>)
  - [func (mpc *MembershipProofCommitting) GenProof(c curves.Scalar) *MembershipProof](<#func-membershipproofcommitting-genproof>)
  - [func (mpc MembershipProofCommitting) GetChallengeBytes() []byte](<#func-membershipproofcommitting-getchallengebytes>)
  - [func (mpc *MembershipProofCommitting) New(witness *MembershipWitness, acc *Accumulator, pp *ProofParams, pk *PublicKey) (*MembershipProofCommitting, error)](<#func-membershipproofcommitting-new>)
- [type MembershipProofFinal](<#type-membershipprooffinal>)
  - [func (m MembershipProofFinal) GetChallenge(curve *curves.PairingCurve) curves.Scalar](<#func-membershipprooffinal-getchallenge>)
- [type MembershipWitness](<#type-membershipwitness>)
  - [func (mw *MembershipWitness) ApplyDelta(delta *Delta) (*MembershipWitness, error)](<#func-membershipwitness-applydelta>)
  - [func (mw *MembershipWitness) BatchUpdate(additions []Element, deletions []Element, coefficients []Coefficient) (*MembershipWitness, error)](<#func-membershipwitness-batchupdate>)
  - [func (mw MembershipWitness) MarshalBinary() ([]byte, error)](<#func-membershipwitness-marshalbinary>)
  - [func (mw *MembershipWitness) MultiBatchUpdate(A [][]Element, D [][]Element, C [][]Coefficient) (*MembershipWitness, error)](<#func-membershipwitness-multibatchupdate>)
  - [func (mw *MembershipWitness) New(y Element, acc *Accumulator, sk *SecretKey) (*MembershipWitness, error)](<#func-membershipwitness-new>)
  - [func (mw *MembershipWitness) UnmarshalBinary(data []byte) error](<#func-membershipwitness-unmarshalbinary>)
  - [func (mw MembershipWitness) Verify(pk *PublicKey, acc *Accumulator) error](<#func-membershipwitness-verify>)
- [type ProofParams](<#type-proofparams>)
  - [func (p *ProofParams) MarshalBinary() ([]byte, error)](<#func-proofparams-marshalbinary>)
  - [func (p *ProofParams) New(curve *curves.PairingCurve, pk *PublicKey, entropy []byte) (*ProofParams, error)](<#func-proofparams-new>)
  - [func (p *ProofParams) UnmarshalBinary(data []byte) error](<#func-proofparams-unmarshalbinary>)
- [type PublicKey](<#type-publickey>)
  - [func (pk PublicKey) MarshalBinary() ([]byte, error)](<#func-publickey-marshalbinary>)
  - [func (pk *PublicKey) UnmarshalBinary(data []byte) error](<#func-publickey-unmarshalbinary>)
- [type SecretKey](<#type-secretkey>)
  - [func (sk SecretKey) BatchAdditions(additions []Element) (Element, error)](<#func-secretkey-batchadditions>)
  - [func (sk SecretKey) BatchDeletions(deletions []Element) (Element, error)](<#func-secretkey-batchdeletions>)
  - [func (sk SecretKey) CreateCoefficients(additions []Element, deletions []Element) ([]Element, error)](<#func-secretkey-createcoefficients>)
  - [func (sk SecretKey) GetPublicKey(curve *curves.PairingCurve) (*PublicKey, error)](<#func-secretkey-getpublickey>)
  - [func (sk SecretKey) MarshalBinary() ([]byte, error)](<#func-secretkey-marshalbinary>)
  - [func (sk *SecretKey) New(curve *curves.PairingCurve, seed []byte) (*SecretKey, error)](<#func-secretkey-new>)
  - [func (sk *SecretKey) UnmarshalBinary(data []byte) error](<#func-secretkey-unmarshalbinary>)


## type [Accumulator](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L26-L28>)

Accumulator is a point

```go
type Accumulator struct {
    // contains filtered or unexported fields
}
```

### func \(\*Accumulator\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L73>)

```go
func (acc *Accumulator) Add(key *SecretKey, e Element) (*Accumulator, error)
```

Add accumulates a single element into the accumulator V' = \(y \+ alpha\) \* V

### func \(\*Accumulator\) [AddElements](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L59>)

```go
func (acc *Accumulator) AddElements(key *SecretKey, m []Element) (*Accumulator, error)
```

AddElements accumulates a set of elements into the accumulator\.

### func \(Accumulator\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L135>)

```go
func (acc Accumulator) MarshalBinary() ([]byte, error)
```

MarshalBinary converts Accumulator to bytes

### func \(\*Accumulator\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L31>)

```go
func (acc *Accumulator) New(curve *curves.PairingCurve) (*Accumulator, error)
```

New creates a new accumulator\.

### func \(\*Accumulator\) [Remove](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L84>)

```go
func (acc *Accumulator) Remove(key *SecretKey, e Element) (*Accumulator, error)
```

Remove removes a single element from accumulator if it exists V' = 1/\(y\+alpha\) \*  V

### func \(\*Accumulator\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L147>)

```go
func (acc *Accumulator) UnmarshalBinary(data []byte) error
```

UnmarshalBinary sets Accumulator from bytes

### func \(\*Accumulator\) [Update](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L99>)

```go
func (acc *Accumulator) Update(key *SecretKey, additions []Element, deletions []Element) (*Accumulator, []Coefficient, error)
```

Update performs a batch addition and deletion as described on page 7\, section 3 in https://eprint.iacr.org/2020/777.pdf

### func \(\*Accumulator\) [WithElements](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L45>)

```go
func (acc *Accumulator) WithElements(curve *curves.PairingCurve, key *SecretKey, m []Element) (*Accumulator, error)
```

WithElements initializes a new accumulator prefilled with entries Each member is assumed to be hashed V = prod\(y \+ α\) \* V0\, for all y∈ Y\_V

## type [Coefficient](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L23>)

Coefficient is a point

```go
type Coefficient curves.Point
```

## type [Delta](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L164-L167>)

Delta contains values d and p\, where d should be the division dA\(y\)/dD\(y\) on some value y p should be equal to 1/dD \* \<Gamma\_y\, Omega\>

```go
type Delta struct {
    // contains filtered or unexported fields
}
```

### func \(\*Delta\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L170>)

```go
func (d *Delta) MarshalBinary() ([]byte, error)
```

MarshalBinary converts Delta into bytes

### func \(\*Delta\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L185>)

```go
func (d *Delta) UnmarshalBinary(data []byte) error
```

UnmarshalBinary converts data into Delta

## type [Element](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/accumulator.go#L20>)

```go
type Element curves.Scalar
```

## type [MembershipProof](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L307-L316>)

MembershipProof contains values in the proof to be verified

```go
type MembershipProof struct {
    // contains filtered or unexported fields
}
```

### func \(\*MembershipProof\) [Finalize](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L319>)

```go
func (mp *MembershipProof) Finalize(acc *Accumulator, pp *ProofParams, pk *PublicKey, challenge curves.Scalar) *MembershipProofFinal
```

Finalize computes values in the proof to be verified\.

### func \(MembershipProof\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L399>)

```go
func (mp MembershipProof) MarshalBinary() ([]byte, error)
```

MarshalBinary converts MembershipProof to bytes

### func \(\*MembershipProof\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L415>)

```go
func (mp *MembershipProof) UnmarshalBinary(data []byte) error
```

UnmarshalBinary converts bytes to MembershipProof

## type [MembershipProofCommitting](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L102-L125>)

MembershipProofCommitting contains value computed in Proof of knowledge and Blinding phases as described in section 7 of https://eprint.iacr.org/2020/777.pdf

```go
type MembershipProofCommitting struct {
    // contains filtered or unexported fields
}
```

### func \(\*MembershipProofCommitting\) [GenProof](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L263>)

```go
func (mpc *MembershipProofCommitting) GenProof(c curves.Scalar) *MembershipProof
```

GenProof computes the s values for Fiat\-Shamir and return the actual proof to be sent to the verifier given the challenge c\.

### func \(MembershipProofCommitting\) [GetChallengeBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L248>)

```go
func (mpc MembershipProofCommitting) GetChallengeBytes() []byte
```

GetChallenge returns bytes that need to be hashed for generating challenge\. V || Ec || T\_sigma || T\_rho || R\_E || R\_sigma || R\_rho || R\_delta\_sigma || R\_delta\_rho

### func \(\*MembershipProofCommitting\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L128-L133>)

```go
func (mpc *MembershipProofCommitting) New(witness *MembershipWitness, acc *Accumulator, pp *ProofParams, pk *PublicKey) (*MembershipProofCommitting, error)
```

New initiates values of MembershipProofCommitting

## type [MembershipProofFinal](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L474-L484>)

MembershipProofFinal contains values that are input to Fiat\-Shamir Heuristic

```go
type MembershipProofFinal struct {
    // contains filtered or unexported fields
}
```

### func \(MembershipProofFinal\) [GetChallenge](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L487>)

```go
func (m MembershipProofFinal) GetChallenge(curve *curves.PairingCurve) curves.Scalar
```

GetChallenge computes Fiat\-Shamir Heuristic taking input values of MembershipProofFinal

## type [MembershipWitness](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L16-L19>)

MembershipWitness contains the witness c and the value y respect to the accumulator state\.

```go
type MembershipWitness struct {
    // contains filtered or unexported fields
}
```

### func \(\*MembershipWitness\) [ApplyDelta](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L78>)

```go
func (mw *MembershipWitness) ApplyDelta(delta *Delta) (*MembershipWitness, error)
```

ApplyDelta returns C' = dA\(y\)/dD\(y\)\*C \+ 1/dD\(y\) \* \<Gamma\_y\, Omega\> according to the witness update protocol described in section 4 of https://eprint.iacr.org/2020/777.pdf

### func \(\*MembershipWitness\) [BatchUpdate](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L89>)

```go
func (mw *MembershipWitness) BatchUpdate(additions []Element, deletions []Element, coefficients []Coefficient) (*MembershipWitness, error)
```

BatchUpdate performs batch update as described in section 4

### func \(MembershipWitness\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L115>)

```go
func (mw MembershipWitness) MarshalBinary() ([]byte, error)
```

MarshalBinary converts a membership witness to bytes

### func \(\*MembershipWitness\) [MultiBatchUpdate](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L102>)

```go
func (mw *MembershipWitness) MultiBatchUpdate(A [][]Element, D [][]Element, C [][]Coefficient) (*MembershipWitness, error)
```

MultiBatchUpdate performs multi\-batch update using epoch as described in section 4\.2

### func \(\*MembershipWitness\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L22>)

```go
func (mw *MembershipWitness) New(y Element, acc *Accumulator, sk *SecretKey) (*MembershipWitness, error)
```

New creates a new membership witness

### func \(\*MembershipWitness\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L129>)

```go
func (mw *MembershipWitness) UnmarshalBinary(data []byte) error
```

UnmarshalBinary converts bytes into MembershipWitness

### func \(MembershipWitness\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/witness.go#L44>)

```go
func (mw MembershipWitness) Verify(pk *PublicKey, acc *Accumulator) error
```

Verify the MembershipWitness mw is a valid witness as per section 4 in \<https://eprint.iacr.org/2020/777\>

## type [ProofParams](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L30-L32>)

ProofParams contains four distinct public generators of G1 \- X\, Y\, Z

```go
type ProofParams struct {
    // contains filtered or unexported fields
}
```

### func \(\*ProofParams\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L55>)

```go
func (p *ProofParams) MarshalBinary() ([]byte, error)
```

MarshalBinary converts ProofParams to bytes

### func \(\*ProofParams\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L35>)

```go
func (p *ProofParams) New(curve *curves.PairingCurve, pk *PublicKey, entropy []byte) (*ProofParams, error)
```

New samples X\, Y\, Z\, K

### func \(\*ProofParams\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/proof.go#L69>)

```go
func (p *ProofParams) UnmarshalBinary(data []byte) error
```

UnmarshalBinary converts bytes to ProofParams

## type [PublicKey](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L204-L206>)

PublicKey is the public key of accumulator\, it should be sk \* generator of G2

```go
type PublicKey struct {
    // contains filtered or unexported fields
}
```

### func \(PublicKey\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L209>)

```go
func (pk PublicKey) MarshalBinary() ([]byte, error)
```

MarshalBinary converts PublicKey to bytes

### func \(\*PublicKey\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L221>)

```go
func (pk *PublicKey) UnmarshalBinary(data []byte) error
```

UnmarshalBinary sets PublicKey from bytes

## type [SecretKey](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L16-L18>)

SecretKey is the secret alpha only held by the accumulator manager\.

```go
type SecretKey struct {
    // contains filtered or unexported fields
}
```

### func \(SecretKey\) [BatchAdditions](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L69>)

```go
func (sk SecretKey) BatchAdditions(additions []Element) (Element, error)
```

BatchAdditions computes product\(y \+ sk\) for y in additions and output the product

### func \(SecretKey\) [BatchDeletions](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L87>)

```go
func (sk SecretKey) BatchDeletions(deletions []Element) (Element, error)
```

BatchDeletions computes 1/product\(y \+ sk\) for y in deletions and output it

### func \(SecretKey\) [CreateCoefficients](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L101>)

```go
func (sk SecretKey) CreateCoefficients(additions []Element, deletions []Element) ([]Element, error)
```

CreateCoefficients creates the Batch Polynomial coefficients See page 7 of https://eprint.iacr.org/2020/777.pdf

### func \(SecretKey\) [GetPublicKey](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L27>)

```go
func (sk SecretKey) GetPublicKey(curve *curves.PairingCurve) (*PublicKey, error)
```

GetPublicKey creates a public key from SecretKey sk

### func \(SecretKey\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L36>)

```go
func (sk SecretKey) MarshalBinary() ([]byte, error)
```

MarshalBinary converts SecretKey to bytes

### func \(\*SecretKey\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L21>)

```go
func (sk *SecretKey) New(curve *curves.PairingCurve, seed []byte) (*SecretKey, error)
```

New creates a new secret key from the seed\.

### func \(\*SecretKey\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/accumulator/key.go#L48>)

```go
func (sk *SecretKey) UnmarshalBinary(data []byte) error
```

UnmarshalBinary sets SecretKey from bytes



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
