<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# frost

```go
import "github.com/coinbase/kryptology/pkg/dkg/frost"
```

## Index

- [type DkgParticipant](<#type-dkgparticipant>)
  - [func NewDkgParticipant(id, threshold uint32, ctx string, curve *curves.Curve, otherParticipants ...uint32) (*DkgParticipant, error)](<#func-newdkgparticipant>)
  - [func (dp *DkgParticipant) Round1(secret []byte) (*Round1Bcast, Round1P2PSend, error)](<#func-dkgparticipant-round1>)
  - [func (dp *DkgParticipant) Round2(bcast map[uint32]*Round1Bcast, p2psend map[uint32]*sharing.ShamirShare) (*Round2Bcast, error)](<#func-dkgparticipant-round2>)
- [type Round1Bcast](<#type-round1bcast>)
- [type Round1P2PSend](<#type-round1p2psend>)
- [type Round1Result](<#type-round1result>)
  - [func (result *Round1Result) Decode(input []byte) error](<#func-round1result-decode>)
  - [func (result *Round1Result) Encode() ([]byte, error)](<#func-round1result-encode>)
- [type Round2Bcast](<#type-round2bcast>)


## type [DkgParticipant](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/participant.go#L17-L29>)

```go
type DkgParticipant struct {
    Curve *curves.Curve

    Id              uint32
    SkShare         curves.Scalar
    VerificationKey curves.Point
    VkShare         curves.Point
    // contains filtered or unexported fields
}
```

### func [NewDkgParticipant](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/participant.go#L37>)

```go
func NewDkgParticipant(id, threshold uint32, ctx string, curve *curves.Curve, otherParticipants ...uint32) (*DkgParticipant, error)
```

### func \(\*DkgParticipant\) [Round1](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/dkg_round1.go#L30>)

```go
func (dp *DkgParticipant) Round1(secret []byte) (*Round1Bcast, Round1P2PSend, error)
```

Round1 implements dkg round 1 of FROST

### func \(\*DkgParticipant\) [Round2](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/dkg_round2.go#L24>)

```go
func (dp *DkgParticipant) Round2(bcast map[uint32]*Round1Bcast, p2psend map[uint32]*sharing.ShamirShare) (*Round2Bcast, error)
```

Round2 implements dkg round 2 of FROST

## type [Round1Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/dkg_round1.go#L20-L23>)

Round1Bcast are values that are broadcast to all other participants after round1 completes

```go
type Round1Bcast struct {
    Verifiers *sharing.FeldmanVerifier
    Wi, Ci    curves.Scalar
}
```

## type [Round1P2PSend](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/dkg_round1.go#L27>)

Round1P2PSend are values that are P2PSend to all other participants after round1 completes

```go
type Round1P2PSend = map[uint32]*sharing.ShamirShare
```

## type [Round1Result](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/dkg_round1.go#L28-L31>)

```go
type Round1Result struct {
    Broadcast *Round1Bcast
    P2P       *sharing.ShamirShare
}
```

### func \(\*Round1Result\) [Decode](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/dkg_round1.go#L44>)

```go
func (result *Round1Result) Decode(input []byte) error
```

### func \(\*Round1Result\) [Encode](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/dkg_round1.go#L33>)

```go
func (result *Round1Result) Encode() ([]byte, error)
```

## type [Round2Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/dkg/frost/dkg_round2.go#L18-L21>)

Round2Bcast are values that are broadcast to all other participants after round2 completes

```go
type Round2Bcast struct {
    VerificationKey curves.Point
    VkShare         curves.Point
}
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
