<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# sharing

```go
import "github.com/coinbase/kryptology/pkg/sharing"
```

## Index

- [type Feldman](<#type-feldman>)
  - [func NewFeldman(threshold, limit uint32, curve *curves.Curve) (*Feldman, error)](<#func-newfeldman>)
  - [func (f Feldman) Combine(shares ...*ShamirShare) (curves.Scalar, error)](<#func-feldman-combine>)
  - [func (f Feldman) CombinePoints(shares ...*ShamirShare) (curves.Point, error)](<#func-feldman-combinepoints>)
  - [func (f Feldman) LagrangeCoeffs(shares map[uint32]*ShamirShare) (map[uint32]curves.Scalar, error)](<#func-feldman-lagrangecoeffs>)
  - [func (f Feldman) Split(secret curves.Scalar, reader io.Reader) (*FeldmanVerifier, []*ShamirShare, error)](<#func-feldman-split>)
- [type FeldmanVerifier](<#type-feldmanverifier>)
  - [func (v FeldmanVerifier) Verify(share *ShamirShare) error](<#func-feldmanverifier-verify>)
- [type Pedersen](<#type-pedersen>)
  - [func NewPedersen(threshold, limit uint32, generator curves.Point) (*Pedersen, error)](<#func-newpedersen>)
  - [func (pd Pedersen) Combine(shares ...*ShamirShare) (curves.Scalar, error)](<#func-pedersen-combine>)
  - [func (pd Pedersen) CombinePoints(shares ...*ShamirShare) (curves.Point, error)](<#func-pedersen-combinepoints>)
  - [func (pd Pedersen) LagrangeCoeffs(shares map[uint32]*ShamirShare) (map[uint32]curves.Scalar, error)](<#func-pedersen-lagrangecoeffs>)
  - [func (pd Pedersen) Split(secret curves.Scalar, reader io.Reader) (*PedersenResult, error)](<#func-pedersen-split>)
- [type PedersenResult](<#type-pedersenresult>)
- [type PedersenVerifier](<#type-pedersenverifier>)
  - [func (pv PedersenVerifier) Verify(share, blindShare *ShamirShare) error](<#func-pedersenverifier-verify>)
- [type Polynomial](<#type-polynomial>)
  - [func (p Polynomial) Evaluate(x curves.Scalar) curves.Scalar](<#func-polynomial-evaluate>)
  - [func (p *Polynomial) Init(intercept curves.Scalar, degree uint32, reader io.Reader) *Polynomial](<#func-polynomial-init>)
- [type Shamir](<#type-shamir>)
  - [func NewShamir(threshold, limit uint32, curve *curves.Curve) (*Shamir, error)](<#func-newshamir>)
  - [func (s Shamir) Combine(shares ...*ShamirShare) (curves.Scalar, error)](<#func-shamir-combine>)
  - [func (s Shamir) CombinePoints(shares ...*ShamirShare) (curves.Point, error)](<#func-shamir-combinepoints>)
  - [func (s Shamir) LagrangeCoeffs(identities []uint32) (map[uint32]curves.Scalar, error)](<#func-shamir-lagrangecoeffs>)
  - [func (s Shamir) Split(secret curves.Scalar, reader io.Reader) ([]*ShamirShare, error)](<#func-shamir-split>)
- [type ShamirShare](<#type-shamirshare>)
  - [func (ss ShamirShare) Bytes() []byte](<#func-shamirshare-bytes>)
  - [func (ss ShamirShare) Validate(curve *curves.Curve) error](<#func-shamirshare-validate>)


## type [Feldman](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/feldman.go#L43-L46>)

```go
type Feldman struct {
    Threshold, Limit uint32
    Curve            *curves.Curve
}
```

### func [NewFeldman](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/feldman.go#L48>)

```go
func NewFeldman(threshold, limit uint32, curve *curves.Curve) (*Feldman, error)
```

### func \(Feldman\) [Combine](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/feldman.go#L91>)

```go
func (f Feldman) Combine(shares ...*ShamirShare) (curves.Scalar, error)
```

### func \(Feldman\) [CombinePoints](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/feldman.go#L100>)

```go
func (f Feldman) CombinePoints(shares ...*ShamirShare) (curves.Point, error)
```

### func \(Feldman\) [LagrangeCoeffs](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/feldman.go#L82>)

```go
func (f Feldman) LagrangeCoeffs(shares map[uint32]*ShamirShare) (map[uint32]curves.Scalar, error)
```

### func \(Feldman\) [Split](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/feldman.go#L64>)

```go
func (f Feldman) Split(secret curves.Scalar, reader io.Reader) (*FeldmanVerifier, []*ShamirShare, error)
```

## type [FeldmanVerifier](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/feldman.go#L15-L17>)

```go
type FeldmanVerifier struct {
    Commitments []curves.Point
}
```

### func \(FeldmanVerifier\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/feldman.go#L19>)

```go
func (v FeldmanVerifier) Verify(share *ShamirShare) error
```

## type [Pedersen](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L16-L20>)

Pedersen Verifiable Secret Sharing Scheme

```go
type Pedersen struct {
    // contains filtered or unexported fields
}
```

### func [NewPedersen](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L67>)

```go
func NewPedersen(threshold, limit uint32, generator curves.Point) (*Pedersen, error)
```

NewPedersen creates a new pedersen VSS

### func \(Pedersen\) [Combine](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L131>)

```go
func (pd Pedersen) Combine(shares ...*ShamirShare) (curves.Scalar, error)
```

### func \(Pedersen\) [CombinePoints](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L140>)

```go
func (pd Pedersen) CombinePoints(shares ...*ShamirShare) (curves.Point, error)
```

### func \(Pedersen\) [LagrangeCoeffs](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L122>)

```go
func (pd Pedersen) LagrangeCoeffs(shares map[uint32]*ShamirShare) (map[uint32]curves.Scalar, error)
```

### func \(Pedersen\) [Split](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L91>)

```go
func (pd Pedersen) Split(secret curves.Scalar, reader io.Reader) (*PedersenResult, error)
```

Split creates the verifiers\, blinding and shares

## type [PedersenResult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L59-L64>)

PedersenResult contains all the data from calling Split

```go
type PedersenResult struct {
    Blinding                     curves.Scalar
    BlindingShares, SecretShares []*ShamirShare
    FeldmanVerifier              *FeldmanVerifier
    PedersenVerifier             *PedersenVerifier
}
```

## type [PedersenVerifier](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L22-L25>)

```go
type PedersenVerifier struct {
    Generator   curves.Point
    Commitments []curves.Point
}
```

### func \(PedersenVerifier\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/pedersen.go#L27>)

```go
func (pv PedersenVerifier) Verify(share, blindShare *ShamirShare) error
```

## type [Polynomial](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/polynomial.go#L14-L16>)

```go
type Polynomial struct {
    Coefficients []curves.Scalar
}
```

### func \(Polynomial\) [Evaluate](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/polynomial.go#L27>)

```go
func (p Polynomial) Evaluate(x curves.Scalar) curves.Scalar
```

### func \(\*Polynomial\) [Init](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/polynomial.go#L18>)

```go
func (p *Polynomial) Init(intercept curves.Scalar, degree uint32, reader io.Reader) *Polynomial
```

## type [Shamir](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L41-L44>)

```go
type Shamir struct {
    // contains filtered or unexported fields
}
```

### func [NewShamir](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L46>)

```go
func NewShamir(threshold, limit uint32, curve *curves.Curve) (*Shamir, error)
```

### func \(Shamir\) [Combine](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L109>)

```go
func (s Shamir) Combine(shares ...*ShamirShare) (curves.Scalar, error)
```

### func \(Shamir\) [CombinePoints](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L135>)

```go
func (s Shamir) CombinePoints(shares ...*ShamirShare) (curves.Point, error)
```

### func \(Shamir\) [LagrangeCoeffs](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L83>)

```go
func (s Shamir) LagrangeCoeffs(shares map[uint32]*ShamirShare) (map[uint32]curves.Scalar, error)
```

### func \(Shamir\) [Split](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L62>)

```go
func (s Shamir) Split(secret curves.Scalar, reader io.Reader) ([]*ShamirShare, error)
```

## type [ShamirShare](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L16-L19>)

```go
type ShamirShare struct {
    Id    uint32 `json:"identifier"`
    Value []byte `json:"value"`
}
```

### func \(ShamirShare\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L35>)

```go
func (ss ShamirShare) Bytes() []byte
```

### func \(ShamirShare\) [Validate](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/shamir.go#L21>)

```go
func (ss ShamirShare) Validate(curve *curves.Curve) error
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
