<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# v1

```go
import "github.com/coinbase/kryptology/pkg/sharing/v1"
```

## Index

- [func K256GeneratorFromHashedBytes(bytes []byte) (x, y *big.Int, err error)](<#func-k256generatorfromhashedbytes>)
- [type Bls12381G1Curve](<#type-bls12381g1curve>)
  - [func Bls12381G1() *Bls12381G1Curve](<#func-bls12381g1>)
  - [func Bls12381G2() *Bls12381G1Curve](<#func-bls12381g2>)
  - [func (curve *Bls12381G1Curve) Add(x1, y1, x2, y2 *big.Int) (*big.Int, *big.Int)](<#func-bls12381g1curve-add>)
  - [func (curve *Bls12381G1Curve) CompressedBytesFromBigInts(x, y *big.Int) ([]byte, error)](<#func-bls12381g1curve-compressedbytesfrombigints>)
  - [func (curve *Bls12381G1Curve) Double(x1, y1 *big.Int) (*big.Int, *big.Int)](<#func-bls12381g1curve-double>)
  - [func (curve *Bls12381G1Curve) Hash(msg []byte) (*big.Int, *big.Int)](<#func-bls12381g1curve-hash>)
  - [func (curve *Bls12381G1Curve) IsOnCurve(x, y *big.Int) bool](<#func-bls12381g1curve-isoncurve>)
  - [func (curve *Bls12381G1Curve) Params() *elliptic.CurveParams](<#func-bls12381g1curve-params>)
  - [func (curve *Bls12381G1Curve) ScalarBaseMult(k []byte) (*big.Int, *big.Int)](<#func-bls12381g1curve-scalarbasemult>)
  - [func (curve *Bls12381G1Curve) ScalarMult(Bx, By *big.Int, k []byte) (*big.Int, *big.Int)](<#func-bls12381g1curve-scalarmult>)
- [type Bls12381G2Curve](<#type-bls12381g2curve>)
  - [func (curve *Bls12381G2Curve) Add(x1, y1, x2, y2 *big.Int) (*big.Int, *big.Int)](<#func-bls12381g2curve-add>)
  - [func (curve *Bls12381G2Curve) CompressedBytesFromBigInts(x, y *big.Int) ([]byte, error)](<#func-bls12381g2curve-compressedbytesfrombigints>)
  - [func (curve *Bls12381G2Curve) Double(x1, y1 *big.Int) (*big.Int, *big.Int)](<#func-bls12381g2curve-double>)
  - [func (curve *Bls12381G2Curve) Hash(msg []byte) (*big.Int, *big.Int)](<#func-bls12381g2curve-hash>)
  - [func (curve *Bls12381G2Curve) IsOnCurve(x, y *big.Int) bool](<#func-bls12381g2curve-isoncurve>)
  - [func (curve *Bls12381G2Curve) Params() *elliptic.CurveParams](<#func-bls12381g2curve-params>)
  - [func (curve *Bls12381G2Curve) ScalarBaseMult(k []byte) (*big.Int, *big.Int)](<#func-bls12381g2curve-scalarbasemult>)
  - [func (curve *Bls12381G2Curve) ScalarMult(Bx, By *big.Int, k []byte) (*big.Int, *big.Int)](<#func-bls12381g2curve-scalarmult>)
- [type Ed25519Curve](<#type-ed25519curve>)
  - [func Ed25519() *Ed25519Curve](<#func-ed25519>)
  - [func (curve *Ed25519Curve) Add(x1, y1, x2, y2 *big.Int) (*big.Int, *big.Int)](<#func-ed25519curve-add>)
  - [func (curve *Ed25519Curve) Double(x1, y1 *big.Int) (*big.Int, *big.Int)](<#func-ed25519curve-double>)
  - [func (curve *Ed25519Curve) Hash(msg []byte) (*big.Int, *big.Int)](<#func-ed25519curve-hash>)
  - [func (curve *Ed25519Curve) IsOnCurve(x, y *big.Int) bool](<#func-ed25519curve-isoncurve>)
  - [func (curve *Ed25519Curve) Neg(Bx, By *big.Int) (*big.Int, *big.Int)](<#func-ed25519curve-neg>)
  - [func (curve *Ed25519Curve) Params() *elliptic.CurveParams](<#func-ed25519curve-params>)
  - [func (curve *Ed25519Curve) ScalarBaseMult(k []byte) (*big.Int, *big.Int)](<#func-ed25519curve-scalarbasemult>)
  - [func (curve *Ed25519Curve) ScalarMult(Bx, By *big.Int, k []byte) (*big.Int, *big.Int)](<#func-ed25519curve-scalarmult>)
- [type Feldman](<#type-feldman>)
  - [func NewFeldman(threshold, limit uint32, curve elliptic.Curve) (*Feldman, error)](<#func-newfeldman>)
  - [func (f Feldman) Combine(shares ...*ShamirShare) ([]byte, error)](<#func-feldman-combine>)
  - [func (f Feldman) Split(secret []byte) ([]*ShareVerifier, []*ShamirShare, error)](<#func-feldman-split>)
  - [func (f Feldman) Verify(share *ShamirShare, verifiers []*ShareVerifier) (bool, error)](<#func-feldman-verify>)
- [type FeldmanResult](<#type-feldmanresult>)
- [type Pedersen](<#type-pedersen>)
  - [func NewPedersen(threshold, limit uint32, generator *curves.EcPoint) (*Pedersen, error)](<#func-newpedersen>)
  - [func (pd Pedersen) Combine(shares ...*ShamirShare) ([]byte, error)](<#func-pedersen-combine>)
  - [func (pd Pedersen) Split(secret []byte) (*PedersenResult, error)](<#func-pedersen-split>)
  - [func (pd Pedersen) Verify(share *ShamirShare, blinding *ShamirShare, blindedverifiers []*ShareVerifier) (bool, error)](<#func-pedersen-verify>)
- [type PedersenResult](<#type-pedersenresult>)
- [type Shamir](<#type-shamir>)
  - [func NewShamir(threshold, limit int, field *curves.Field) (*Shamir, error)](<#func-newshamir>)
  - [func (s *Shamir) Combine(shares ...*ShamirShare) ([]byte, error)](<#func-shamir-combine>)
  - [func (s Shamir) ComputeL(shares ...*ShamirShare) ([]*curves.Element, error)](<#func-shamir-computel>)
  - [func (s *Shamir) GetSharesAndPolynomial(secret []byte) ([]*ShamirShare, *polynomial, error)](<#func-shamir-getsharesandpolynomial>)
  - [func (s *Shamir) Interpolate(xCoordinates, yCoordinates []*curves.Element) (*curves.Element, error)](<#func-shamir-interpolate>)
  - [func (s *Shamir) Split(secret []byte) ([]*ShamirShare, error)](<#func-shamir-split>)
- [type ShamirShare](<#type-shamirshare>)
  - [func NewShamirShare(x uint32, y []byte, f *curves.Field) *ShamirShare](<#func-newshamirshare>)
  - [func (s ShamirShare) Add(other *ShamirShare) *ShamirShare](<#func-shamirshare-add>)
  - [func (s ShamirShare) Bytes() []byte](<#func-shamirshare-bytes>)
- [type ShareVerifier](<#type-shareverifier>)


## func [K256GeneratorFromHashedBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/pedersen.go#L168>)

```go
func K256GeneratorFromHashedBytes(bytes []byte) (x, y *big.Int, err error)
```

K256GeneratorFromHashedBytes computes a generator whose discrete log is unknown from a bytes sequence

## type [Bls12381G1Curve](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L25-L27>)

```go
type Bls12381G1Curve struct {
    *elliptic.CurveParams
}
```

### func [Bls12381G1](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L40>)

```go
func Bls12381G1() *Bls12381G1Curve
```

### func [Bls12381G2](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L40>)

```go
func Bls12381G2() *Bls12381G1Curve
```

### func \(\*Bls12381G1Curve\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L81>)

```go
func (curve *Bls12381G1Curve) Add(x1, y1, x2, y2 *big.Int) (*big.Int, *big.Int)
```

### func \(\*Bls12381G1Curve\) [CompressedBytesFromBigInts](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L137>)

```go
func (curve *Bls12381G1Curve) CompressedBytesFromBigInts(x, y *big.Int) ([]byte, error)
```

CompressedBytesFromBigInts takes x and y coordinates and converts them to the BLS compressed point form

### func \(\*Bls12381G1Curve\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L95>)

```go
func (curve *Bls12381G1Curve) Double(x1, y1 *big.Int) (*big.Int, *big.Int)
```

### func \(\*Bls12381G1Curve\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L128>)

```go
func (curve *Bls12381G1Curve) Hash(msg []byte) (*big.Int, *big.Int)
```

Hash an arbitrary byte sequence to a G1 point according to the hash\-to\-curve standard

### func \(\*Bls12381G1Curve\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L76>)

```go
func (curve *Bls12381G1Curve) IsOnCurve(x, y *big.Int) bool
```

### func \(\*Bls12381G1Curve\) [Params](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L72>)

```go
func (curve *Bls12381G1Curve) Params() *elliptic.CurveParams
```

### func \(\*Bls12381G1Curve\) [ScalarBaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L117>)

```go
func (curve *Bls12381G1Curve) ScalarBaseMult(k []byte) (*big.Int, *big.Int)
```

### func \(\*Bls12381G1Curve\) [ScalarMult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g1curve.go#L104>)

```go
func (curve *Bls12381G1Curve) ScalarMult(Bx, By *big.Int, k []byte) (*big.Int, *big.Int)
```

## type [Bls12381G2Curve](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L25-L27>)

```go
type Bls12381G2Curve struct {
    *elliptic.CurveParams
}
```

### func \(\*Bls12381G2Curve\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L81>)

```go
func (curve *Bls12381G2Curve) Add(x1, y1, x2, y2 *big.Int) (*big.Int, *big.Int)
```

### func \(\*Bls12381G2Curve\) [CompressedBytesFromBigInts](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L137>)

```go
func (curve *Bls12381G2Curve) CompressedBytesFromBigInts(x, y *big.Int) ([]byte, error)
```

CompressedBytesFromBigInts takes x and y coordinates and converts them to the BLS compressed point form

### func \(\*Bls12381G2Curve\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L95>)

```go
func (curve *Bls12381G2Curve) Double(x1, y1 *big.Int) (*big.Int, *big.Int)
```

### func \(\*Bls12381G2Curve\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L128>)

```go
func (curve *Bls12381G2Curve) Hash(msg []byte) (*big.Int, *big.Int)
```

Hash an arbitrary byte sequence to a G1 point according to the hash\-to\-curve standard

### func \(\*Bls12381G2Curve\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L76>)

```go
func (curve *Bls12381G2Curve) IsOnCurve(x, y *big.Int) bool
```

### func \(\*Bls12381G2Curve\) [Params](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L72>)

```go
func (curve *Bls12381G2Curve) Params() *elliptic.CurveParams
```

### func \(\*Bls12381G2Curve\) [ScalarBaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L117>)

```go
func (curve *Bls12381G2Curve) ScalarBaseMult(k []byte) (*big.Int, *big.Int)
```

### func \(\*Bls12381G2Curve\) [ScalarMult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/bls12381g2curve.go#L104>)

```go
func (curve *Bls12381G2Curve) ScalarMult(Bx, By *big.Int, k []byte) (*big.Int, *big.Int)
```

## type [Ed25519Curve](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L22-L24>)

```go
type Ed25519Curve struct {
    *elliptic.CurveParams
}
```

### func [Ed25519](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L37>)

```go
func Ed25519() *Ed25519Curve
```

### func \(\*Ed25519Curve\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L53>)

```go
func (curve *Ed25519Curve) Add(x1, y1, x2, y2 *big.Int) (*big.Int, *big.Int)
```

### func \(\*Ed25519Curve\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L76>)

```go
func (curve *Ed25519Curve) Double(x1, y1 *big.Int) (*big.Int, *big.Int)
```

### func \(\*Ed25519Curve\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L133>)

```go
func (curve *Ed25519Curve) Hash(msg []byte) (*big.Int, *big.Int)
```

### func \(\*Ed25519Curve\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L46>)

```go
func (curve *Ed25519Curve) IsOnCurve(x, y *big.Int) bool
```

### func \(\*Ed25519Curve\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L118>)

```go
func (curve *Ed25519Curve) Neg(Bx, By *big.Int) (*big.Int, *big.Int)
```

### func \(\*Ed25519Curve\) [Params](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L42>)

```go
func (curve *Ed25519Curve) Params() *elliptic.CurveParams
```

### func \(\*Ed25519Curve\) [ScalarBaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L104>)

```go
func (curve *Ed25519Curve) ScalarBaseMult(k []byte) (*big.Int, *big.Int)
```

### func \(\*Ed25519Curve\) [ScalarMult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/ed25519curve.go#L86>)

```go
func (curve *Ed25519Curve) ScalarMult(Bx, By *big.Int, k []byte) (*big.Int, *big.Int)
```

## type [Feldman](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/feldman.go#L17-L20>)

Feldman Verifiable Secret Sharing Scheme

```go
type Feldman struct {
    // contains filtered or unexported fields
}
```

### func [NewFeldman](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/feldman.go#L28>)

```go
func NewFeldman(threshold, limit uint32, curve elliptic.Curve) (*Feldman, error)
```

### func \(Feldman\) [Combine](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/feldman.go#L59>)

```go
func (f Feldman) Combine(shares ...*ShamirShare) ([]byte, error)
```

### func \(Feldman\) [Split](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/feldman.go#L40>)

```go
func (f Feldman) Split(secret []byte) ([]*ShareVerifier, []*ShamirShare, error)
```

### func \(Feldman\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/feldman.go#L66>)

```go
func (f Feldman) Verify(share *ShamirShare, verifiers []*ShareVerifier) (bool, error)
```

Verify checks a share for validity

## type [FeldmanResult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/feldman.go#L23-L26>)

FeldmanResult contains all the data from calling Split

```go
type FeldmanResult struct {
    SecretShares []*ShamirShare
    Verifiers    []*ShareVerifier
}
```

## type [Pedersen](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/pedersen.go#L20-L23>)

Pedersen Verifiable Secret Sharing Scheme

```go
type Pedersen struct {
    // contains filtered or unexported fields
}
```

### func [NewPedersen](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/pedersen.go#L34>)

```go
func NewPedersen(threshold, limit uint32, generator *curves.EcPoint) (*Pedersen, error)
```

NewPedersen creates a new pedersen VSS

### func \(Pedersen\) [Combine](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/pedersen.go#L109>)

```go
func (pd Pedersen) Combine(shares ...*ShamirShare) ([]byte, error)
```

Combine recreates the original secret from the shares

### func \(Pedersen\) [Split](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/pedersen.go#L58>)

```go
func (pd Pedersen) Split(secret []byte) (*PedersenResult, error)
```

Split creates the verifiers\, blinding and shares

### func \(Pedersen\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/pedersen.go#L116>)

```go
func (pd Pedersen) Verify(share *ShamirShare, blinding *ShamirShare, blindedverifiers []*ShareVerifier) (bool, error)
```

Verify checks a share for validity

## type [PedersenResult](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/pedersen.go#L26-L31>)

PedersenResult contains all the data from calling Split

```go
type PedersenResult struct {
    Blinding                     *big.Int
    BlindingShares, SecretShares []*ShamirShare
    BlindedVerifiers             []*ShareVerifier
    Verifiers                    []*ShareVerifier
}
```

## type [Shamir](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L51-L54>)

Shamir is the Shamir secret sharing scheme

```go
type Shamir struct {
    // contains filtered or unexported fields
}
```

### func [NewShamir](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L57>)

```go
func NewShamir(threshold, limit int, field *curves.Field) (*Shamir, error)
```

NewShamir creates a Shamir secret sharing scheme

### func \(\*Shamir\) [Combine](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L77>)

```go
func (s *Shamir) Combine(shares ...*ShamirShare) ([]byte, error)
```

Combine takes any number of shares and tries to combine them into the original secret

### func \(Shamir\) [ComputeL](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L171>)

```go
func (s Shamir) ComputeL(shares ...*ShamirShare) ([]*curves.Element, error)
```

ComputeL is a function that computes all Lagrange coefficients\. This function is particularly needed in FROST tSchnorr signature\.

### func \(\*Shamir\) [GetSharesAndPolynomial](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L110>)

```go
func (s *Shamir) GetSharesAndPolynomial(secret []byte) ([]*ShamirShare, *polynomial, error)
```

getSharesAndPolynomial returns the shares for the specified secret and the polynomial used to create the shares

### func \(\*Shamir\) [Interpolate](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L138>)

```go
func (s *Shamir) Interpolate(xCoordinates, yCoordinates []*curves.Element) (*curves.Element, error)
```

interpolate calculates the lagrange interpolation

### func \(\*Shamir\) [Split](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L71>)

```go
func (s *Shamir) Split(secret []byte) ([]*ShamirShare, error)
```

Split takes a secret and splits it into multiple shares that requires threshold to reconstruct

## type [ShamirShare](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L17-L22>)

ShamirShare is the data from splitting a secret

```go
type ShamirShare struct {
    // x-coordinate
    Identifier uint32 `json:"identifier"`
    // y-coordinate
    Value *curves.Element `json:"value"`
}
```

### func [NewShamirShare](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L25>)

```go
func NewShamirShare(x uint32, y []byte, f *curves.Field) *ShamirShare
```

NewShamirShare creates a ShamirShare given the Identifier\, value\, and Field for the value

### func \(ShamirShare\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L42>)

```go
func (s ShamirShare) Add(other *ShamirShare) *ShamirShare
```

Add returns the sum of two Shamir shares

### func \(ShamirShare\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/shamir.go#L34>)

```go
func (s ShamirShare) Bytes() []byte
```

Bytes returns the representation of the share in bytes with the identifier as the first 4 bytes

## type [ShareVerifier](<https://github.com/coinbase/kryptology/blob/master/pkg/sharing/v1/common.go#L14>)

ShareVerifier is used to verify secret shares from Feldman or Pedersen VSS

```go
type ShareVerifier = kryptology.EcPoint
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
