<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# bbs

```go
import "github.com/coinbase/kryptology/pkg/signatures/bbs"
```

## Index

- [func NewKeys(curve *curves.PairingCurve) (*PublicKey, *SecretKey, error)](<#func-newkeys>)
- [type BlindSignature](<#type-blindsignature>)
  - [func (sig *BlindSignature) Init(curve *curves.PairingCurve) *BlindSignature](<#func-blindsignature-init>)
  - [func (sig BlindSignature) MarshalBinary() ([]byte, error)](<#func-blindsignature-marshalbinary>)
  - [func (sig BlindSignature) ToUnblinded(blinder common.SignatureBlinding) *Signature](<#func-blindsignature-tounblinded>)
  - [func (sig *BlindSignature) UnmarshalBinary(data []byte) error](<#func-blindsignature-unmarshalbinary>)
- [type BlindSignatureContext](<#type-blindsignaturecontext>)
  - [func NewBlindSignatureContext(curve *curves.PairingCurve, msgs map[int]curves.Scalar, generators *MessageGenerators, nonce common.Nonce, reader io.Reader) (*BlindSignatureContext, common.SignatureBlinding, error)](<#func-newblindsignaturecontext>)
  - [func (bsc *BlindSignatureContext) Init(curve *curves.PairingCurve) *BlindSignatureContext](<#func-blindsignaturecontext-init>)
  - [func (bsc BlindSignatureContext) MarshalBinary() ([]byte, error)](<#func-blindsignaturecontext-marshalbinary>)
  - [func (bsc BlindSignatureContext) ToBlindSignature(msgs map[int]curves.Scalar, sk *SecretKey, generators *MessageGenerators, nonce common.Nonce) (*BlindSignature, error)](<#func-blindsignaturecontext-toblindsignature>)
  - [func (bsc *BlindSignatureContext) UnmarshalBinary(in []byte) error](<#func-blindsignaturecontext-unmarshalbinary>)
  - [func (bsc BlindSignatureContext) Verify(knownMsgs []int, generators *MessageGenerators, nonce common.Nonce) error](<#func-blindsignaturecontext-verify>)
- [type MessageGenerators](<#type-messagegenerators>)
  - [func (msgg MessageGenerators) Get(i int) curves.PairingPoint](<#func-messagegenerators-get>)
  - [func (msgg *MessageGenerators) Init(w *PublicKey, length int) *MessageGenerators](<#func-messagegenerators-init>)
- [type PokSignature](<#type-poksignature>)
  - [func NewPokSignature(sig *Signature, generators *MessageGenerators, msgs []common.ProofMessage, reader io.Reader) (*PokSignature, error)](<#func-newpoksignature>)
  - [func (pok *PokSignature) GenerateProof(challenge curves.Scalar) (*PokSignatureProof, error)](<#func-poksignature-generateproof>)
  - [func (pok *PokSignature) GetChallengeContribution(transcript *merlin.Transcript)](<#func-poksignature-getchallengecontribution>)
- [type PokSignatureProof](<#type-poksignatureproof>)
  - [func (pok PokSignatureProof) GetChallengeContribution(generators *MessageGenerators, revealedMessages map[int]curves.Scalar, challenge common.Challenge, transcript *merlin.Transcript)](<#func-poksignatureproof-getchallengecontribution>)
  - [func (pok *PokSignatureProof) Init(curve *curves.PairingCurve) *PokSignatureProof](<#func-poksignatureproof-init>)
  - [func (pok *PokSignatureProof) MarshalBinary() ([]byte, error)](<#func-poksignatureproof-marshalbinary>)
  - [func (pok *PokSignatureProof) UnmarshalBinary(in []byte) error](<#func-poksignatureproof-unmarshalbinary>)
  - [func (pok PokSignatureProof) Verify(revealedMsgs map[int]curves.Scalar, pk *PublicKey, generators *MessageGenerators, nonce common.Nonce, challenge common.Challenge, transcript *merlin.Transcript) bool](<#func-poksignatureproof-verify>)
  - [func (pok PokSignatureProof) VerifySigPok(pk *PublicKey) bool](<#func-poksignatureproof-verifysigpok>)
- [type PublicKey](<#type-publickey>)
  - [func (pk *PublicKey) Init(curve *curves.PairingCurve) *PublicKey](<#func-publickey-init>)
  - [func (pk PublicKey) MarshalBinary() ([]byte, error)](<#func-publickey-marshalbinary>)
  - [func (pk *PublicKey) UnmarshalBinary(in []byte) error](<#func-publickey-unmarshalbinary>)
  - [func (pk PublicKey) Verify(signature *Signature, generators *MessageGenerators, msgs []curves.Scalar) error](<#func-publickey-verify>)
- [type SecretKey](<#type-secretkey>)
  - [func NewSecretKey(curve *curves.PairingCurve) (*SecretKey, error)](<#func-newsecretkey>)
  - [func (sk *SecretKey) Init(curve *curves.PairingCurve) *SecretKey](<#func-secretkey-init>)
  - [func (sk SecretKey) MarshalBinary() ([]byte, error)](<#func-secretkey-marshalbinary>)
  - [func (sk *SecretKey) PublicKey() *PublicKey](<#func-secretkey-publickey>)
  - [func (sk *SecretKey) Sign(generators *MessageGenerators, msgs []curves.Scalar) (*Signature, error)](<#func-secretkey-sign>)
  - [func (sk *SecretKey) UnmarshalBinary(in []byte) error](<#func-secretkey-unmarshalbinary>)
- [type Signature](<#type-signature>)
  - [func (sig *Signature) Init(curve *curves.PairingCurve) *Signature](<#func-signature-init>)
  - [func (sig Signature) MarshalBinary() ([]byte, error)](<#func-signature-marshalbinary>)
  - [func (sig *Signature) UnmarshalBinary(data []byte) error](<#func-signature-unmarshalbinary>)


## func [NewKeys](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/secret_key.go#L73>)

```go
func NewKeys(curve *curves.PairingCurve) (*PublicKey, *SecretKey, error)
```

## type [BlindSignature](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature.go#L22-L25>)

BlindSignature is a BBS\+ blind signature structurally identical to \`Signature\` but is used to help avoid misuse and confusion\.

1 or more message have been hidden by the potential signature holder so the signer only knows a subset of the messages to be signed

```go
type BlindSignature struct {
    // contains filtered or unexported fields
}
```

### func \(\*BlindSignature\) [Init](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature.go#L29>)

```go
func (sig *BlindSignature) Init(curve *curves.PairingCurve) *BlindSignature
```

Init creates an empty signature to a specific curve which should be followed by UnmarshalBinary

### func \(BlindSignature\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature.go#L36>)

```go
func (sig BlindSignature) MarshalBinary() ([]byte, error)
```

### func \(BlindSignature\) [ToUnblinded](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature.go#L67>)

```go
func (sig BlindSignature) ToUnblinded(blinder common.SignatureBlinding) *Signature
```

### func \(\*BlindSignature\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature.go#L42>)

```go
func (sig *BlindSignature) UnmarshalBinary(data []byte) error
```

## type [BlindSignatureContext](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature_context.go#L27-L34>)

BlindSignatureContext contains the data used for computing a blind signature and verifying proof of hidden messages from a future signature holder\. A potential holder commits to messages that the signer will not know during the signing process rendering them hidden\, but requires the holder to prove knowledge of those messages so a malicious party doesn't add just random data from anywhere\.

```go
type BlindSignatureContext struct {
    // contains filtered or unexported fields
}
```

### func [NewBlindSignatureContext](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature_context.go#L43>)

```go
func NewBlindSignatureContext(curve *curves.PairingCurve, msgs map[int]curves.Scalar, generators *MessageGenerators, nonce common.Nonce, reader io.Reader) (*BlindSignatureContext, common.SignatureBlinding, error)
```

NewBlindSignatureContext creates the data needed to send to a signer to complete a blinded signature \`msgs\` is an index to message map where the index corresponds to the index in \`generators\` msgs are hidden from the signer but can also be empty if no messages are hidden but a blind signature is still desired because the signer should have no knowledge of the signature

### func \(\*BlindSignatureContext\) [Init](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature_context.go#L106>)

```go
func (bsc *BlindSignatureContext) Init(curve *curves.PairingCurve) *BlindSignatureContext
```

### func \(BlindSignatureContext\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature_context.go#L116>)

```go
func (bsc BlindSignatureContext) MarshalBinary() ([]byte, error)
```

MarshalBinary store the generators as a sequence of bytes where each point is compressed\. Needs \(N \+ 1\) \* ScalarSize \+ PointSize

### func \(BlindSignatureContext\) [ToBlindSignature](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature_context.go#L197>)

```go
func (bsc BlindSignatureContext) ToBlindSignature(msgs map[int]curves.Scalar, sk *SecretKey, generators *MessageGenerators, nonce common.Nonce) (*BlindSignature, error)
```

ToBlindSignature converts a blind signature where msgs are known to the signer \`msgs\` is an index to message map where the index corresponds to the index in \`generators\`

### func \(\*BlindSignatureContext\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature_context.go#L124>)

```go
func (bsc *BlindSignatureContext) UnmarshalBinary(in []byte) error
```

### func \(BlindSignatureContext\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/blind_signature_context.go#L158>)

```go
func (bsc BlindSignatureContext) Verify(knownMsgs []int, generators *MessageGenerators, nonce common.Nonce) error
```

Verify validates a proof of hidden messages

## type [MessageGenerators](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/message_generators.go#L28-L33>)

MessageGenerators are used to sign a vector of commitments for a BBS\+ signature\. These must be the same generators used by sign\, verify\, prove\, and open

These are generated in a deterministic manner\. By using MessageGenerators in this way\, the generators do not need to be stored alongside the public key and the same key can be used to sign an arbitrary number of messages Generators are created by computing H\_i = H\_G1\(W || I2OSP\(0\, 4\) || I2OSP\(0\, 1\) || I2OSP\(length\, 4\)\) where I2OSP means Integer to Octet Stream Primitive and I2OSP represents an integer in a statically sized byte array\. \`W\` is the BBS\+ public key\. Internally we store the 201 byte state since the only value that changes is the index

```go
type MessageGenerators struct {
    // contains filtered or unexported fields
}
```

### func \(MessageGenerators\) [Get](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/message_generators.go#L54>)

```go
func (msgg MessageGenerators) Get(i int) curves.PairingPoint
```

### func \(\*MessageGenerators\) [Init](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/message_generators.go#L36>)

```go
func (msgg *MessageGenerators) Init(w *PublicKey, length int) *MessageGenerators
```

Init set the message generators to the default state

## type [PokSignature](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature.go#L21-L33>)

PokSignature a\.k\.a\. Proof of Knowledge of a Signature is used by the prover to convince a verifier that they possess a valid signature and can selectively disclose a set of signed messages

```go
type PokSignature struct {
    // contains filtered or unexported fields
}
```

### func [NewPokSignature](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature.go#L36-L39>)

```go
func NewPokSignature(sig *Signature, generators *MessageGenerators, msgs []common.ProofMessage, reader io.Reader) (*PokSignature, error)
```

NewPokSignature creates the initial proof data before a Fiat\-Shamir calculation

### func \(\*PokSignature\) [GenerateProof](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature.go#L141>)

```go
func (pok *PokSignature) GenerateProof(challenge curves.Scalar) (*PokSignatureProof, error)
```

GenerateProof converts the blinding factors and secrets into Schnorr proofs

### func \(\*PokSignature\) [GetChallengeContribution](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature.go#L132>)

```go
func (pok *PokSignature) GetChallengeContribution(transcript *merlin.Transcript)
```

GetChallengeContribution returns the bytes that should be added to a sigma protocol transcript for generating the challenge

## type [PokSignatureProof](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature_proof.go#L19-L22>)

PokSignatureProof is the actual proof sent from a prover to a verifier that contains a proof of knowledge of a signature and the selective disclosure proof

```go
type PokSignatureProof struct {
    // contains filtered or unexported fields
}
```

### func \(PokSignatureProof\) [GetChallengeContribution](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature_proof.go#L114-L119>)

```go
func (pok PokSignatureProof) GetChallengeContribution(generators *MessageGenerators, revealedMessages map[int]curves.Scalar, challenge common.Challenge, transcript *merlin.Transcript)
```

GetChallengeContribution converts the committed values to bytes for the Fiat\-Shamir challenge

### func \(\*PokSignatureProof\) [Init](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature_proof.go#L26>)

```go
func (pok *PokSignatureProof) Init(curve *curves.PairingCurve) *PokSignatureProof
```

Init creates an empty proof to a specific curve which should be followed by UnmarshalBinary

### func \(\*PokSignatureProof\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature_proof.go#L38>)

```go
func (pok *PokSignatureProof) MarshalBinary() ([]byte, error)
```

### func \(\*PokSignatureProof\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature_proof.go#L50>)

```go
func (pok *PokSignatureProof) UnmarshalBinary(in []byte) error
```

### func \(PokSignatureProof\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature_proof.go#L184-L191>)

```go
func (pok PokSignatureProof) Verify(revealedMsgs map[int]curves.Scalar, pk *PublicKey, generators *MessageGenerators, nonce common.Nonce, challenge common.Challenge, transcript *merlin.Transcript) bool
```

Verify checks a signature proof of knowledge and selective disclosure proof

### func \(PokSignatureProof\) [VerifySigPok](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/pok_signature_proof.go#L176>)

```go
func (pok PokSignatureProof) VerifySigPok(pk *PublicKey) bool
```

VerifySigPok only validates the signature proof\, the selective disclosure proof is checked by verifying pok\.challenge == computedChallenge

## type [PublicKey](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/public_key.go#L15-L17>)

PublicKey is a BBS\+ verification key

```go
type PublicKey struct {
    // contains filtered or unexported fields
}
```

### func \(\*PublicKey\) [Init](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/public_key.go#L19>)

```go
func (pk *PublicKey) Init(curve *curves.PairingCurve) *PublicKey
```

### func \(PublicKey\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/public_key.go#L24>)

```go
func (pk PublicKey) MarshalBinary() ([]byte, error)
```

### func \(\*PublicKey\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/public_key.go#L28>)

```go
func (pk *PublicKey) UnmarshalBinary(in []byte) error
```

### func \(PublicKey\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/public_key.go#L38>)

```go
func (pk PublicKey) Verify(signature *Signature, generators *MessageGenerators, msgs []curves.Scalar) error
```

Verify checks a signature where all messages are known to the verifier

## type [SecretKey](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/secret_key.go#L20-L22>)

SecretKey is a BBS\+ signing key

```go
type SecretKey struct {
    // contains filtered or unexported fields
}
```

### func [NewSecretKey](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/secret_key.go#L24>)

```go
func NewSecretKey(curve *curves.PairingCurve) (*SecretKey, error)
```

### func \(\*SecretKey\) [Init](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/secret_key.go#L81>)

```go
func (sk *SecretKey) Init(curve *curves.PairingCurve) *SecretKey
```

### func \(SecretKey\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/secret_key.go#L86>)

```go
func (sk SecretKey) MarshalBinary() ([]byte, error)
```

### func \(\*SecretKey\) [PublicKey](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/secret_key.go#L130>)

```go
func (sk *SecretKey) PublicKey() *PublicKey
```

PublicKey returns the corresponding public key

### func \(\*SecretKey\) [Sign](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/secret_key.go#L100>)

```go
func (sk *SecretKey) Sign(generators *MessageGenerators, msgs []curves.Scalar) (*Signature, error)
```

Sign generates a new signature where all messages are known to the signer

### func \(\*SecretKey\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/secret_key.go#L90>)

```go
func (sk *SecretKey) UnmarshalBinary(in []byte) error
```

## type [Signature](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/signature.go#L17-L20>)

Signature is a BBS\+ signature as described in 4\.3 in \<https://eprint.iacr.org/2016/663.pdf\>

```go
type Signature struct {
    // contains filtered or unexported fields
}
```

### func \(\*Signature\) [Init](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/signature.go#L24>)

```go
func (sig *Signature) Init(curve *curves.PairingCurve) *Signature
```

Init creates an empty signature to a specific curve which should be followed by UnmarshalBinary or Create

### func \(Signature\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/signature.go#L31>)

```go
func (sig Signature) MarshalBinary() ([]byte, error)
```

### func \(\*Signature\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/bbs/signature.go#L37>)

```go
func (sig *Signature) UnmarshalBinary(data []byte) error
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
