<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# common

```go
import "github.com/coinbase/kryptology/pkg/signatures/common"
```

## Index

- [type Challenge](<#type-challenge>)
- [type Commitment](<#type-commitment>)
- [type HmacDrbg](<#type-hmacdrbg>)
  - [func NewHmacDrbg(entropy, nonce, pers []byte, hasher func() hash.Hash) *HmacDrbg](<#func-newhmacdrbg>)
  - [func (drbg *HmacDrbg) Read(dst []byte) (n int, err error)](<#func-hmacdrbg-read>)
  - [func (drbg *HmacDrbg) Reseed(entropy []byte)](<#func-hmacdrbg-reseed>)
- [type Nonce](<#type-nonce>)
- [type ProofCommittedBuilder](<#type-proofcommittedbuilder>)
  - [func NewProofCommittedBuilder(curve *curves.Curve) *ProofCommittedBuilder](<#func-newproofcommittedbuilder>)
  - [func (pcb *ProofCommittedBuilder) Commit(point curves.Point, scalar curves.Scalar) error](<#func-proofcommittedbuilder-commit>)
  - [func (pcb *ProofCommittedBuilder) CommitRandom(point curves.Point, reader io.Reader) error](<#func-proofcommittedbuilder-commitrandom>)
  - [func (pcb ProofCommittedBuilder) GenerateProof(challenge curves.Scalar, secrets []curves.Scalar) ([]curves.Scalar, error)](<#func-proofcommittedbuilder-generateproof>)
  - [func (pcb *ProofCommittedBuilder) Get(index int) (curves.Point, curves.Scalar)](<#func-proofcommittedbuilder-get>)
  - [func (pcb ProofCommittedBuilder) GetChallengeContribution() []byte](<#func-proofcommittedbuilder-getchallengecontribution>)
- [type ProofMessage](<#type-proofmessage>)
- [type ProofSpecificMessage](<#type-proofspecificmessage>)
  - [func (ps ProofSpecificMessage) GetBlinding(reader io.Reader) curves.Scalar](<#func-proofspecificmessage-getblinding>)
  - [func (ps ProofSpecificMessage) GetMessage() curves.Scalar](<#func-proofspecificmessage-getmessage>)
  - [func (ps ProofSpecificMessage) IsHidden() bool](<#func-proofspecificmessage-ishidden>)
- [type RevealedMessage](<#type-revealedmessage>)
  - [func (r RevealedMessage) GetBlinding(reader io.Reader) curves.Scalar](<#func-revealedmessage-getblinding>)
  - [func (r RevealedMessage) GetMessage() curves.Scalar](<#func-revealedmessage-getmessage>)
  - [func (r RevealedMessage) IsHidden() bool](<#func-revealedmessage-ishidden>)
- [type SharedBlindingMessage](<#type-sharedblindingmessage>)
  - [func (ps SharedBlindingMessage) GetBlinding(reader io.Reader) curves.Scalar](<#func-sharedblindingmessage-getblinding>)
  - [func (ps SharedBlindingMessage) GetMessage() curves.Scalar](<#func-sharedblindingmessage-getmessage>)
  - [func (ps SharedBlindingMessage) IsHidden() bool](<#func-sharedblindingmessage-ishidden>)
- [type SignatureBlinding](<#type-signatureblinding>)


## type [Challenge](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/challenge.go#L14>)

Challenge generated by fiat\-shamir heuristic

```go
type Challenge = curves.Scalar
```

## type [Commitment](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/commitment.go#L15>)

Commitment represents a point Pedersen commitment of one or more points multiplied by scalars

```go
type Commitment = curves.Point
```

## type [HmacDrbg](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/hmacdrbg.go#L17-L21>)

HmacDrbg is an HMAC deterministic random bit generator that can use any hash function\. Handles reseeding automatically

```go
type HmacDrbg struct {
    // contains filtered or unexported fields
}
```

### func [NewHmacDrbg](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/hmacdrbg.go#L23>)

```go
func NewHmacDrbg(entropy, nonce, pers []byte, hasher func() hash.Hash) *HmacDrbg
```

### func \(\*HmacDrbg\) [Read](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/hmacdrbg.go#L40>)

```go
func (drbg *HmacDrbg) Read(dst []byte) (n int, err error)
```

### func \(\*HmacDrbg\) [Reseed](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/hmacdrbg.go#L61>)

```go
func (drbg *HmacDrbg) Reseed(entropy []byte)
```

## type [Nonce](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/nonce.go#L15>)

Nonce is used for zero\-knowledge proofs to prevent replay attacks and prove freshness

```go
type Nonce = curves.Scalar
```

## type [ProofCommittedBuilder](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_committed_builder.go#L21-L25>)

ProofCommittedBuilder is used to create proofs from multiple commitments where each secret is committed with a random blinding factor and turned into a Schnorr proof

```go
type ProofCommittedBuilder struct {
    // contains filtered or unexported fields
}
```

### func [NewProofCommittedBuilder](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_committed_builder.go#L28>)

```go
func NewProofCommittedBuilder(curve *curves.Curve) *ProofCommittedBuilder
```

NewProofCommittedBuilder creates a new builder using the specified curve

### func \(\*ProofCommittedBuilder\) [Commit](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_committed_builder.go#L47>)

```go
func (pcb *ProofCommittedBuilder) Commit(point curves.Point, scalar curves.Scalar) error
```

Commit uses the specified point and scalar to create a commitment

### func \(\*ProofCommittedBuilder\) [CommitRandom](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_committed_builder.go#L37>)

```go
func (pcb *ProofCommittedBuilder) CommitRandom(point curves.Point, reader io.Reader) error
```

CommitRandom uses the specified point and commits a random value to it

### func \(ProofCommittedBuilder\) [GenerateProof](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_committed_builder.go#L75>)

```go
func (pcb ProofCommittedBuilder) GenerateProof(challenge curves.Scalar, secrets []curves.Scalar) ([]curves.Scalar, error)
```

GenerateProof converts the blinding factors and secrets into Schnorr proofs

### func \(\*ProofCommittedBuilder\) [Get](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_committed_builder.go#L57>)

```go
func (pcb *ProofCommittedBuilder) Get(index int) (curves.Point, curves.Scalar)
```

Get returns the point and scalar at the specified index

### func \(ProofCommittedBuilder\) [GetChallengeContribution](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_committed_builder.go#L66>)

```go
func (pcb ProofCommittedBuilder) GetChallengeContribution() []byte
```

GetChallengeContribution returns the bytes that should be added to a sigma protocol transcript for generating the challenge

## type [ProofMessage](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L18-L30>)

ProofMessage classifies how a message is presented in a proof Either Revealed or Hidden\. Hidden has two sub categories: proof specific i\.e\. the message is only used for this proof or shared i\.e\. the message should be proved to be common across proofs

```go
type ProofMessage interface {
    // IsHidden indicates the message should be hidden
    IsHidden() bool
    // GetBlinding is used for hidden messages
    // blindings can either be proof specific to a signature
    // or involved with other proofs like boundchecks,
    // set memberships, or inequalities so the blinding
    // factor is shared among proofs to produce a common
    // schnorr linking proof
    GetBlinding(reader io.Reader) curves.Scalar
    // GetMessage returns the underlying message
    GetMessage() curves.Scalar
}
```

## type [ProofSpecificMessage](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L48-L50>)

```go
type ProofSpecificMessage struct {
    Message curves.Scalar
}
```

### func \(ProofSpecificMessage\) [GetBlinding](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L56>)

```go
func (ps ProofSpecificMessage) GetBlinding(reader io.Reader) curves.Scalar
```

### func \(ProofSpecificMessage\) [GetMessage](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L60>)

```go
func (ps ProofSpecificMessage) GetMessage() curves.Scalar
```

### func \(ProofSpecificMessage\) [IsHidden](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L52>)

```go
func (ps ProofSpecificMessage) IsHidden() bool
```

## type [RevealedMessage](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L32-L34>)

```go
type RevealedMessage struct {
    Message curves.Scalar
}
```

### func \(RevealedMessage\) [GetBlinding](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L40>)

```go
func (r RevealedMessage) GetBlinding(reader io.Reader) curves.Scalar
```

### func \(RevealedMessage\) [GetMessage](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L44>)

```go
func (r RevealedMessage) GetMessage() curves.Scalar
```

### func \(RevealedMessage\) [IsHidden](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L36>)

```go
func (r RevealedMessage) IsHidden() bool
```

## type [SharedBlindingMessage](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L64-L66>)

```go
type SharedBlindingMessage struct {
    Message, Blinding curves.Scalar
}
```

### func \(SharedBlindingMessage\) [GetBlinding](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L72>)

```go
func (ps SharedBlindingMessage) GetBlinding(reader io.Reader) curves.Scalar
```

### func \(SharedBlindingMessage\) [GetMessage](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L76>)

```go
func (ps SharedBlindingMessage) GetMessage() curves.Scalar
```

### func \(SharedBlindingMessage\) [IsHidden](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/proof_message.go#L68>)

```go
func (ps SharedBlindingMessage) IsHidden() bool
```

## type [SignatureBlinding](<https://github.com/coinbase/kryptology/blob/master/pkg/signatures/common/signature_blinding.go#L14>)

SignatureBlinding is a value used for computing blind signatures

```go
type SignatureBlinding = curves.PairingScalar
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
