<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# dkls

```go
import "github.com/coinbase/kryptology/pkg/tecdsa/dkls"
```

Package dkls implements the 2\-of\-2 threshold ECDSA signing algorithm of \[Doerner\, Kondi\, Lee\, and shelat\]\(https://eprint.iacr.org/2018/499\)\. For an example of use\, look at sign\.go\.

It is currently a work in progress; do not use it in real\-life scenarios yet\. TODO: Docs to be completed\.

## Index

- [func EncodeAlice(a *Alice) ([]byte, error)](<#func-encodealice>)
- [func EncodeBob(b *Bob) ([]byte, error)](<#func-encodebob>)
- [func NewPipeWrappers() (*pipeWrapper, *pipeWrapper)](<#func-newpipewrappers>)
- [type Alice](<#type-alice>)
  - [func DecodeAlice(params *Params, b []byte) (*Alice, error)](<#func-decodealice>)
  - [func NewAlice(params *Params) *Alice](<#func-newalice>)
  - [func (alice *Alice) DKG(rw io.ReadWriter) error](<#func-alice-dkg>)
  - [func (alice *Alice) Sign(m []byte, rw io.ReadWriter) error](<#func-alice-sign>)
- [type AliceDkg](<#type-alicedkg>)
  - [func NewAliceDkg(params *Params) *AliceDkg](<#func-newalicedkg>)
  - [func (a *AliceDkg) Result() (interface{}, error)](<#func-alicedkg-result>)
  - [func (a *AliceDkg) SetDebug(log io.Writer)](<#func-alicedkg-setdebug>)
- [type AliceSign](<#type-alicesign>)
  - [func NewAliceSign(params *Params, msg []byte, dkgResult []byte) (*AliceSign, error)](<#func-newalicesign>)
  - [func (a *AliceSign) Result() (interface{}, error)](<#func-alicesign-result>)
  - [func (a *AliceSign) SetDebug(log io.Writer)](<#func-alicesign-setdebug>)
- [type Bob](<#type-bob>)
  - [func DecodeBob(params *Params, b []byte) (*Bob, error)](<#func-decodebob>)
  - [func NewBob(params *Params) *Bob](<#func-newbob>)
  - [func (bob *Bob) DKG(rw io.ReadWriter) error](<#func-bob-dkg>)
  - [func (bob *Bob) Sign(m []byte, rw io.ReadWriter) error](<#func-bob-sign>)
- [type BobDkg](<#type-bobdkg>)
  - [func NewBobDkg(params *Params) *BobDkg](<#func-newbobdkg>)
  - [func (b *BobDkg) Result() (interface{}, error)](<#func-bobdkg-result>)
  - [func (b *BobDkg) SetDebug(log io.Writer)](<#func-bobdkg-setdebug>)
- [type BobSign](<#type-bobsign>)
  - [func NewBobSign(params *Params, msg []byte, dkgResult []byte) (*BobSign, error)](<#func-newbobsign>)
  - [func (d *BobSign) Result() (interface{}, error)](<#func-bobsign-result>)
  - [func (b *BobSign) SetDebug(log io.Writer)](<#func-bobsign-setdebug>)
- [type DkgResult](<#type-dkgresult>)
- [type MultiplyReceiver](<#type-multiplyreceiver>)
  - [func NewMultiplyReceiver(multiplicity int, sender *seedOTSender) *MultiplyReceiver](<#func-newmultiplyreceiver>)
  - [func (receiver *MultiplyReceiver) MultiplyInit(idExt [32]byte, beta []*big.Int, w io.Writer) error](<#func-multiplyreceiver-multiplyinit>)
  - [func (receiver *MultiplyReceiver) MultiplyTransfer(r io.Reader) error](<#func-multiplyreceiver-multiplytransfer>)
- [type MultiplySender](<#type-multiplysender>)
  - [func NewMultiplySender(multiplicity int, receiver *seedOTReceiver) *MultiplySender](<#func-newmultiplysender>)
  - [func (sender *MultiplySender) Multiply(idExt [32]byte, alpha []*big.Int, rw io.ReadWriter) error](<#func-multiplysender-multiply>)
- [type Params](<#type-params>)
  - [func NewParams(curve elliptic.Curve, scalar curves.EcScalar) (*Params, error)](<#func-newparams>)
- [type ProtocolIterator](<#type-protocoliterator>)
- [type Schnorr](<#type-schnorr>)
  - [func (proof *Schnorr) DecommitVerify(com []byte) error](<#func-schnorr-decommitverify>)
  - [func (proof *Schnorr) Prove(x *big.Int) error](<#func-schnorr-prove>)
  - [func (proof *Schnorr) ProveCommit(x *big.Int) ([]byte, error)](<#func-schnorr-provecommit>)
  - [func (proof *Schnorr) Verify() error](<#func-schnorr-verify>)


## func [EncodeAlice](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L280>)

```go
func EncodeAlice(a *Alice) ([]byte, error)
```

Encodes an alice object as a byte sequence after DKG has been completed\.

## func [EncodeBob](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L294>)

```go
func EncodeBob(b *Bob) ([]byte, error)
```

Encodes a bob object as a byte sequence after DKG has been completed\.

## func [NewPipeWrappers](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/conn.go#L29>)

```go
func NewPipeWrappers() (*pipeWrapper, *pipeWrapper)
```

## type [Alice](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/sign.go#L23-L31>)

Alice struct encoding Alice's state during one execution of the overall signing algorithm\. At the end of the joint computation\, Alice will NOT obtain the signature\.

```go
type Alice struct {
    PkA      *Schnorr // this is a "schnorr statement" for pkA.
    Receiver *seedOTReceiver
    SkA      *big.Int // the witness
    Pk       *curves.EcPoint
    // contains filtered or unexported fields
}
```

### func [DecodeAlice](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L287>)

```go
func DecodeAlice(params *Params, b []byte) (*Alice, error)
```

Decodes an alice object that was encoded after DKG\.

### func [NewAlice](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/sign.go#L55>)

```go
func NewAlice(params *Params) *Alice
```

NewAlice creates a party that can participate in 2\-of\-2 DKG and threshold signature\.

### func \(\*Alice\) [DKG](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/dkg.go#L80>)

```go
func (alice *Alice) DKG(rw io.ReadWriter) error
```

### func \(\*Alice\) [Sign](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/sign.go#L275>)

```go
func (alice *Alice) Sign(m []byte, rw io.ReadWriter) error
```

Sign this is an illustrative helper method which shows the overall flow for Alice\. in practice this will be replaced by a method which actually sends messages back and forth\.

## type [AliceDkg](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L51-L54>)

AliceDkg DKLS DKG implementation that satisfies the protocol iterator interface\.

```go
type AliceDkg struct {
    // contains filtered or unexported fields
}
```

### func [NewAliceDkg](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L108>)

```go
func NewAliceDkg(params *Params) *AliceDkg
```

NewAliceDkg creates a new protocol that can compute a DKG as Alice

### func \(\*AliceDkg\) [Result](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L147>)

```go
func (a *AliceDkg) Result() (interface{}, error)
```

Result Returns an encoded version of Alice as sequence of bytes that can be used to initialize an AliceSign protocol\.

### func \(\*AliceDkg\) [SetDebug](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L142>)

```go
func (a *AliceDkg) SetDebug(log io.Writer)
```

## type [AliceSign](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L63-L66>)

AliceSign DKLS sign implementation that satisfies the protocol iterator interface\.

```go
type AliceSign struct {
    // contains filtered or unexported fields
}
```

### func [NewAliceSign](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L217>)

```go
func NewAliceSign(params *Params, msg []byte, dkgResult []byte) (*AliceSign, error)
```

Creates a new protocol that can compute a signature as Alice\. Requires dkg state that was produced at the end of DKG\.Result\(\)\.

### func \(\*AliceSign\) [Result](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L256>)

```go
func (a *AliceSign) Result() (interface{}, error)
```

Result always returns errNoSig\. Alice does not compute a signature in the DKLS protocol; only Bob computes the signature\.

### func \(\*AliceSign\) [SetDebug](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L250>)

```go
func (a *AliceSign) SetDebug(log io.Writer)
```

## type [Bob](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/sign.go#L35-L52>)

Bob struct encoding Bob's state during one execution of the overall signing algorithm\. At the end of the joint computation\, Bob will obtain the signature\.

```go
type Bob struct {
    // Exported fields
    PkB    *Schnorr // this is a "schnorr statement" for pkB.
    Sender *seedOTSender
    SkB    *big.Int
    Pk     *curves.EcPoint
    Sig    *curves.EcdsaSignature // The resulting digital signature
    // contains filtered or unexported fields
}
```

### func [DecodeBob](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L301>)

```go
func DecodeBob(params *Params, b []byte) (*Bob, error)
```

Decodes an bob object that was encoded after DKG\.

### func [NewBob](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/sign.go#L65>)

```go
func NewBob(params *Params) *Bob
```

NewBob creates a party that can participate in 2\-of\-2 DKG and threshold signature\. This party is the receiver of the signature at the end\.

### func \(\*Bob\) [DKG](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/dkg.go#L90>)

```go
func (bob *Bob) DKG(rw io.ReadWriter) error
```

### func \(\*Bob\) [Sign](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/sign.go#L280>)

```go
func (bob *Bob) Sign(m []byte, rw io.ReadWriter) error
```

Sign this is an illustrative helper method which shows the overall flow for Bob\.

## type [BobDkg](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L57-L60>)

BobDkg DKLS DKG implementation that satisfies the protocol iterator interface\.

```go
type BobDkg struct {
    // contains filtered or unexported fields
}
```

### func [NewBobDkg](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L126>)

```go
func NewBobDkg(params *Params) *BobDkg
```

NewBobDkg Creates a new protocol that can compute a DKG as Bob

### func \(\*BobDkg\) [Result](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L185>)

```go
func (b *BobDkg) Result() (interface{}, error)
```

Result returns an encoded version of Alice as sequence of bytes that can be used to initialize an AliceSign protocol\.

### func \(\*BobDkg\) [SetDebug](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L179>)

```go
func (b *BobDkg) SetDebug(log io.Writer)
```

## type [BobSign](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L69-L72>)

BobSign DKLS sign implementation that satisfies the protocol iterator interface\.

```go
type BobSign struct {
    // contains filtered or unexported fields
}
```

### func [NewBobSign](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L234>)

```go
func NewBobSign(params *Params, msg []byte, dkgResult []byte) (*BobSign, error)
```

NewBobSign creates a new protocol that can compute a signature as Bob\. Requires dkg state that was produced at the end of DKG\.Result\(\)\.

### func \(\*BobSign\) [Result](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L266>)

```go
func (d *BobSign) Result() (interface{}, error)
```

If the signing protocol completed successfully\, returns the signature that Bob computed as a \*core\.EcdsaSignature\.

### func \(\*BobSign\) [SetDebug](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L260>)

```go
func (b *BobSign) SetDebug(log io.Writer)
```

## type [DkgResult](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L46-L49>)

DKG protocols produce the following result on successful completion

```go
type DkgResult struct {
    DkgState []byte
    Pubkey   *curves.EcPoint
}
```

## type [MultiplyReceiver](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/multiply.go#L28-L34>)

```go
type MultiplyReceiver struct {
    TB []*big.Int
    // contains filtered or unexported fields
}
```

### func [NewMultiplyReceiver](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/multiply.go#L45>)

```go
func NewMultiplyReceiver(multiplicity int, sender *seedOTSender) *MultiplyReceiver
```

### func \(\*MultiplyReceiver\) [MultiplyInit](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/multiply.go#L92>)

```go
func (receiver *MultiplyReceiver) MultiplyInit(idExt [32]byte, beta []*big.Int, w io.Writer) error
```

MultiplyInit Protocol 5\.\, Multiplication\, 3\)\. Bob \(receiver\) encodes beta and initiates the cOT extension\!

### func \(\*MultiplyReceiver\) [MultiplyTransfer](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/multiply.go#L142>)

```go
func (receiver *MultiplyReceiver) MultiplyTransfer(r io.Reader) error
```

MultiplyTransfer Protocol 5\.\, Multiplication\, 3\) and 6\)\. Bob finalizes the cOT extension\. using that and Alice's multiplication message\, Bob completes the multiplication protocol\, including checks\. at the end\, Bob's values tB\_j are populated\.

## type [MultiplySender](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/multiply.go#L21-L26>)

```go
type MultiplySender struct {
    TA []*big.Int
    // contains filtered or unexported fields
}
```

### func [NewMultiplySender](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/multiply.go#L36>)

```go
func NewMultiplySender(multiplicity int, receiver *seedOTReceiver) *MultiplySender
```

### func \(\*MultiplySender\) [Multiply](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/multiply.go#L104>)

```go
func (sender *MultiplySender) Multiply(idExt [32]byte, alpha []*big.Int, rw io.ReadWriter) error
```

Multiply Protocol 5\.\, steps 3\) 5\)\, 7\)\. Alice \_responds\_ to Bob's initial cOT message\, using a vector of alphas as input\. doesn't actually send that message yet\, only stashes it\, and moves onto the next steps of the multiplication protocol specifically\, Alice can then do step 5\) \(compute the outputs of the multiplication protocol\)\, also stashes this\. finishes up by taking care of 7\)\, after that\, Alice is totally done with multiplication and has stashed the outputs\.

## type [Params](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/params.go#L23-L28>)

```go
type Params struct {
    Curve     elliptic.Curve
    Scalar    curves.EcScalar
    Generator *curves.EcPoint
    // contains filtered or unexported fields
}
```

### func [NewParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/params.go#L32>)

```go
func NewParams(curve elliptic.Curve, scalar curves.EcScalar) (*Params, error)
```

NewParams receives an implementation of the curve and scalar interfaces and sets the parameters needed for DKG and Threshold ECDSA of DKLS\.

## type [ProtocolIterator](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/proto.go#L21-L36>)

ProtocolIterator a generalized interface for multi\-party protocols that follows the iterator pattern\.

```go
type ProtocolIterator interface {
    // Next runs the next round of the protocol.
    // Inputs are read from rw.Read(); outputs are written to rw.Write().
    // Returns io.EOF when protocol has completed.
    Next(rw io.ReadWriter) error

    // Result returns the final result, if any, of the completed protocol.
    // Reports an error if the protocol has not yet terminated
    // or if an error was encountered during protocol execution.
    Result() (interface{}, error)

    // SetDebug enables or disables (passing a nil value as input) debugging.
    // At the moment, we only print the final dkls dkg result as json value to this log, but if needed more debugging
    // can be added for various steps of the other protocols.
    SetDebug(log io.Writer)
}
```

## type [Schnorr](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/schnorr.go#L17-L22>)

```go
type Schnorr struct {
    Pub *curves.EcPoint // this is the public point.
    C   *big.Int
    S   *big.Int
    // contains filtered or unexported fields
}
```

### func \(\*Schnorr\) [DecommitVerify](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/schnorr.go#L100>)

```go
func (proof *Schnorr) DecommitVerify(com []byte) error
```

### func \(\*Schnorr\) [Prove](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/schnorr.go#L24>)

```go
func (proof *Schnorr) Prove(x *big.Int) error
```

### func \(\*Schnorr\) [ProveCommit](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/schnorr.go#L80>)

```go
func (proof *Schnorr) ProveCommit(x *big.Int) ([]byte, error)
```

this "commits to" a schnorr proof which is later revealed; see Functionality 7\. it mutates \`st\` by adding a proof to it\, and then also returns the commitment to the proof\.

### func \(\*Schnorr\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/dkls/schnorr.go#L52>)

```go
func (proof *Schnorr) Verify() error
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
