<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# dealer

```go
import "github.com/coinbase/kryptology/pkg/tecdsa/gg20/dealer"
```

## Index

- [func DerivePublicKey(curve elliptic.Curve, secretKey *big.Int) (*curves.EcPoint, error)](<#func-derivepublickey>)
- [func NewDealerShares(curve elliptic.Curve, threshold, total uint32, ikm *big.Int) (*curves.EcPoint, map[uint32]*Share, error)](<#func-newdealershares>)
- [func NewSecret(curve elliptic.Curve) (*big.Int, error)](<#func-newsecret>)
- [func PreparePublicShares(sharesMap map[uint32]*Share) (map[uint32]*PublicShare, error)](<#func-preparepublicshares>)
- [type DistributedKeyGenType](<#type-distributedkeygentype>)
  - [func (dkg DistributedKeyGenType) GetProofParams(id uint32) *ProofParams](<#func-distributedkeygentype-getproofparams>)
  - [func (dkg DistributedKeyGenType) IsTrustedDealer() bool](<#func-distributedkeygentype-istrusteddealer>)
- [type KeyGenType](<#type-keygentype>)
- [type ParticipantData](<#type-participantdata>)
  - [func (pd ParticipantData) MarshalJSON() ([]byte, error)](<#func-participantdata-marshaljson>)
  - [func (pd *ParticipantData) UnmarshalJSON(bytes []byte) error](<#func-participantdata-unmarshaljson>)
- [type ParticipantDataJson](<#type-participantdatajson>)
- [type ProofParams](<#type-proofparams>)
  - [func NewProofParams() (*ProofParams, error)](<#func-newproofparams>)
  - [func NewProofParamsWithPrimes(p, q *big.Int) (*ProofParams, error)](<#func-newproofparamswithprimes>)
- [type PublicShare](<#type-publicshare>)
- [type Share](<#type-share>)
  - [func (s Share) MarshalJSON() ([]byte, error)](<#func-share-marshaljson>)
  - [func (s *Share) UnmarshalJSON(bytes []byte) error](<#func-share-unmarshaljson>)
- [type ShareJson](<#type-sharejson>)
- [type TrustedDealerKeyGenType](<#type-trusteddealerkeygentype>)
  - [func (td TrustedDealerKeyGenType) GetProofParams(_ uint32) *ProofParams](<#func-trusteddealerkeygentype-getproofparams>)
  - [func (td TrustedDealerKeyGenType) IsTrustedDealer() bool](<#func-trusteddealerkeygentype-istrusteddealer>)


## func [DerivePublicKey](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L178>)

```go
func DerivePublicKey(curve elliptic.Curve, secretKey *big.Int) (*curves.EcPoint, error)
```

## func [NewDealerShares](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L184>)

```go
func NewDealerShares(curve elliptic.Curve, threshold, total uint32, ikm *big.Int) (*curves.EcPoint, map[uint32]*Share, error)
```

NewDealerShares generates the Secp256k1 private key shares and public key if ikm == nil\, a new private key will be generated

## func [NewSecret](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L174>)

```go
func NewSecret(curve elliptic.Curve) (*big.Int, error)
```

New Secret generates a new private key

## func [PreparePublicShares](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L159>)

```go
func PreparePublicShares(sharesMap map[uint32]*Share) (map[uint32]*PublicShare, error)
```

PreparePublicShares makes public shares that can be sent to the participant to compute their additive shares and participate in signing rounds

## type [DistributedKeyGenType](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/keygentype.go#L26-L28>)

DistributedKeyGenType means each participant has their own proof params that were distributed to each other participant

```go
type DistributedKeyGenType struct {
    ProofParams map[uint32]*ProofParams
}
```

### func \(DistributedKeyGenType\) [GetProofParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/keygentype.go#L46>)

```go
func (dkg DistributedKeyGenType) GetProofParams(id uint32) *ProofParams
```

GetProofParams returns the proof params specified by the participant id

### func \(DistributedKeyGenType\) [IsTrustedDealer](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/keygentype.go#L41>)

```go
func (dkg DistributedKeyGenType) IsTrustedDealer() bool
```

IsTrustedDealer return true if TrustedDealerKeyGenType

## type [KeyGenType](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/keygentype.go#L12-L15>)

KeyGenType encapsulates the different methods that tecdsa can generate keys\. Currently TrustedDealer or Distributed Key Generation

```go
type KeyGenType interface {
    IsTrustedDealer() bool
    GetProofParams(id uint32) *ProofParams
}
```

## type [ParticipantData](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L23-L32>)

ParticipantData represents all data to be sent to a participant after the dealer is finished

```go
type ParticipantData struct {
    Id             uint32
    DecryptKey     *paillier.SecretKey
    SecretKeyShare *Share
    // Public values set to all signing participants
    EcdsaPublicKey *curves.EcPoint
    KeyGenType     KeyGenType
    PublicShares   map[uint32]*PublicShare
    EncryptKeys    map[uint32]*paillier.PublicKey
}
```

### func \(ParticipantData\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L46>)

```go
func (pd ParticipantData) MarshalJSON() ([]byte, error)
```

### func \(\*ParticipantData\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L63>)

```go
func (pd *ParticipantData) UnmarshalJSON(bytes []byte) error
```

## type [ParticipantDataJson](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L34-L44>)

```go
type ParticipantDataJson struct {
    Id             uint32
    DecryptKey     *paillier.SecretKey
    SecretKeyShare *Share
    // Public values set to all signing participants
    EcdsaPublicKey    *curves.EcPoint
    DealerParams      *ProofParams
    ParticipantParams map[uint32]*ProofParams
    PublicShares      map[uint32]*PublicShare
    EncryptKeys       map[uint32]*paillier.PublicKey
}
```

## type [ProofParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L88-L95>)

ProofParams is the modulus and generators used when constructing keys and completing the signing rounds

```go
type ProofParams struct {
    // n is the modulus for the signing rounds, product of two safe primes
    N   *big.Int
    // h1 random value quadratic residue in n
    H1  *big.Int
    // h2 is a random modular power of h1
    H2  *big.Int
}
```

### func [NewProofParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L140>)

```go
func NewProofParams() (*ProofParams, error)
```

NewProofParams creates new ProofParams with \`bits\` sized values

### func [NewProofParamsWithPrimes](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L146>)

```go
func NewProofParamsWithPrimes(p, q *big.Int) (*ProofParams, error)
```

NewProofParamsWithPrimes creates new ProofParams using the parameters as the primes

## type [PublicShare](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L98-L100>)

PublicShare can be sent to a Participant so it can be used to convert Share to its additive form

```go
type PublicShare struct {
    Point *curves.EcPoint
}
```

## type [Share](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L103-L106>)

Share represents a piece of the ECDSA private key and a commitment to the share

```go
type Share struct {
    *v1.ShamirShare
    Point *curves.EcPoint
}
```

### func \(Share\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L117>)

```go
func (s Share) MarshalJSON() ([]byte, error)
```

### func \(\*Share\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L125>)

```go
func (s *Share) UnmarshalJSON(bytes []byte) error
```

## type [ShareJson](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/dealer.go#L111-L115>)

ShareJson encapsulates the data that is serialized to JSON used internally and not for external use\. Public so other pieces can use for serialization

```go
type ShareJson struct {
    Identifier uint32   // x-coordinate
    Value      *big.Int // y-coordinate
    Point      *curves.EcPoint
}
```

## type [TrustedDealerKeyGenType](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/keygentype.go#L19-L21>)

TrustedDealerKeyGenType means the same proof parameters will be used by all participants

```go
type TrustedDealerKeyGenType struct {
    ProofParams *ProofParams
}
```

### func \(TrustedDealerKeyGenType\) [GetProofParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/keygentype.go#L36>)

```go
func (td TrustedDealerKeyGenType) GetProofParams(_ uint32) *ProofParams
```

GetProofParams returns the proof params specified by the participant id

### func \(TrustedDealerKeyGenType\) [IsTrustedDealer](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/dealer/keygentype.go#L31>)

```go
func (td TrustedDealerKeyGenType) IsTrustedDealer() bool
```

IsTrustedDealer return true if TrustedDealerKeyGenType



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
