<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# participant

```go
import "github.com/coinbase/kryptology/pkg/tecdsa/gg20/participant"
```

## Index

- [type DkgParticipant](<#type-dkgparticipant>)
  - [func (dp *DkgParticipant) DkgRound1(threshold, total uint32) (*DkgRound1Bcast, error)](<#func-dkgparticipant-dkground1>)
  - [func (dp *DkgParticipant) DkgRound2(params map[uint32]*DkgRound1Bcast) (*DkgRound2Bcast, map[uint32]*DkgRound2P2PSend, error)](<#func-dkgparticipant-dkground2>)
  - [func (dp *DkgParticipant) DkgRound3(d map[uint32]*core.Witness, x map[uint32]*v1.ShamirShare) (paillier.PsfProof, error)](<#func-dkgparticipant-dkground3>)
  - [func (dp *DkgParticipant) DkgRound4(psfProof map[uint32]paillier.PsfProof) (*DkgResult, error)](<#func-dkgparticipant-dkground4>)
- [type DkgParticipantData](<#type-dkgparticipantdata>)
- [type DkgResult](<#type-dkgresult>)
- [type DkgRound1Bcast](<#type-dkground1bcast>)
- [type DkgRound2Bcast](<#type-dkground2bcast>)
- [type DkgRound2P2PSend](<#type-dkground2p2psend>)
- [type P2PSend](<#type-p2psend>)
  - [func (p2ps *P2PSend) UnmarshalJSON(bytes []byte) error](<#func-p2psend-unmarshaljson>)
- [type Participant](<#type-participant>)
  - [func (p Participant) PrepareToSign(pubKey *curves.EcPoint, verify curves.EcdsaVerify, curve elliptic.Curve, keyGenType dealer.KeyGenType, publicSharesMap map[uint32]*dealer.PublicShare, pubKeys map[uint32]*paillier.PublicKey) (*Signer, error)](<#func-participant-preparetosign>)
- [type Round1Bcast](<#type-round1bcast>)
- [type Round1P2PSend](<#type-round1p2psend>)
- [type Round3Bcast](<#type-round3bcast>)
  - [func (r3b Round3Bcast) MarshalJSON() ([]byte, error)](<#func-round3bcast-marshaljson>)
  - [func (r3b *Round3Bcast) UnmarshalJSON(data []byte) error](<#func-round3bcast-unmarshaljson>)
- [type Round3BcastJSON](<#type-round3bcastjson>)
- [type Round4Bcast](<#type-round4bcast>)
- [type Round5Bcast](<#type-round5bcast>)
- [type Round5P2PSend](<#type-round5p2psend>)
- [type Round6FullBcast](<#type-round6fullbcast>)
  - [func (r6b Round6FullBcast) MarshalJSON() ([]byte, error)](<#func-round6fullbcast-marshaljson>)
  - [func (r6b *Round6FullBcast) UnmarshalJSON(data []byte) error](<#func-round6fullbcast-unmarshaljson>)
- [type Round6FullBcastJSON](<#type-round6fullbcastjson>)
- [type Signer](<#type-signer>)
  - [func NewSigner(info *dealer.ParticipantData, cosigners []uint32) (*Signer, error)](<#func-newsigner>)
  - [func (signer *Signer) SignOutput(in map[uint32]*Round6FullBcast) (*curves.EcdsaSignature, error)](<#func-signer-signoutput>)
  - [func (signer *Signer) SignRound1() (*Round1Bcast, map[uint32]*Round1P2PSend, error)](<#func-signer-signround1>)
  - [func (signer *Signer) SignRound2(params map[uint32]*Round1Bcast, p2p map[uint32]*Round1P2PSend) (map[uint32]*P2PSend, error)](<#func-signer-signround2>)
  - [func (s *Signer) SignRound3(in map[uint32]*P2PSend) (*Round3Bcast, error)](<#func-signer-signround3>)
  - [func (s *Signer) SignRound4(deltas map[uint32]*Round3Bcast) (*Round4Bcast, error)](<#func-signer-signround4>)
  - [func (signer *Signer) SignRound5(witnesses map[uint32]*Round4Bcast) (*Round5Bcast, map[uint32]*Round5P2PSend, error)](<#func-signer-signround5>)
  - [func (signer *Signer) SignRound6Full(hash []byte, in map[uint32]*Round5Bcast, p2p map[uint32]*Round5P2PSend) (*Round6FullBcast, error)](<#func-signer-signround6full>)


## type [DkgParticipant](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/participant.go#L299-L304>)

DkgParticipant is a DKG player that contains information needed to perform DKG rounds and finally get info for signing rounds\.

```go
type DkgParticipant struct {
    Curve elliptic.Curve

    Round uint
    // contains filtered or unexported fields
}
```

### func \(\*DkgParticipant\) [DkgRound1](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round1.go#L31>)

```go
func (dp *DkgParticipant) DkgRound1(threshold, total uint32) (*DkgRound1Bcast, error)
```

DkgRound1 performs round 1 distributed key generation operation \[spec\] fig 5: DistKeyGenRound1

### func \(\*DkgParticipant\) [DkgRound2](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round2.go#L31>)

```go
func (dp *DkgParticipant) DkgRound2(params map[uint32]*DkgRound1Bcast) (*DkgRound2Bcast, map[uint32]*DkgRound2P2PSend, error)
```

DkgRound2 implements distributed key generation round 2 \[spec\] fig 5: DistKeyGenRound2

### func \(\*DkgParticipant\) [DkgRound3](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round3.go#L23>)

```go
func (dp *DkgParticipant) DkgRound3(d map[uint32]*core.Witness, x map[uint32]*v1.ShamirShare) (paillier.PsfProof, error)
```

DkgRound3 computes dkg round 3 as shown in \[spec\] fig\. 5: DistKeyGenRoun3

### func \(\*DkgParticipant\) [DkgRound4](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round4.go#L35>)

```go
func (dp *DkgParticipant) DkgRound4(psfProof map[uint32]paillier.PsfProof) (*DkgResult, error)
```

DkgRound4 computes dkg round 4 as shown in \[spec\] fig\. 5: DistKeyGenRound4

## type [DkgParticipantData](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round4.go#L28-L31>)

```go
type DkgParticipantData struct {
    PublicKey   *paillier.PublicKey
    ProofParams *dealer.ProofParams
}
```

## type [DkgResult](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round4.go#L20-L26>)

DkgResult is all the data generated from the DKG

```go
type DkgResult struct {
    PublicShares    []*curves.EcPoint
    VerificationKey *curves.EcPoint
    SigningKeyShare *big.Int
    EncryptionKey   *paillier.SecretKey
    ParticipantData map[uint32]*DkgParticipantData
}
```

## type [DkgRound1Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round1.go#L21-L27>)

DkgRound1Bcast contains values to be broadcast to all players after the completion of DKG round 1

```go
type DkgRound1Bcast struct {
    Identifier       uint32
    Ci               core.Commitment
    Pki              *paillier.PublicKey
    H1i, H2i, Ni     *big.Int
    Proof1i, Proof2i *proof.CdlProof
}
```

## type [DkgRound2Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round2.go#L20-L22>)

DkgRound2Bcast contains value that will be echo broadcast to all other players\.

```go
type DkgRound2Bcast struct {
    Di *core.Witness
}
```

## type [DkgRound2P2PSend](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/dkg_round2.go#L25-L27>)

DkgRound2P2PSend contains value that will be P2PSend to all other player Pj

```go
type DkgRound2P2PSend struct {
    // contains filtered or unexported fields
}
```

## type [P2PSend](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round2.go#L20-L22>)

P2PSend is all the values that need to be sent to each player

```go
type P2PSend struct {
    Proof2, Proof3 proof.ResponseFinalizer
}
```

### func \(\*P2PSend\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round2.go#L25>)

```go
func (p2ps *P2PSend) UnmarshalJSON(bytes []byte) error
```

UnmarshalJSON explicitly unmarshals into ResponseProofs instead of ResponsFinalizer interface

## type [Participant](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/participant.go#L25-L28>)

Participant is a tECDSA player that receives information from a trusted dealer

```go
type Participant struct {
    dealer.Share
    // contains filtered or unexported fields
}
```

### func \(Participant\) [PrepareToSign](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/participant.go#L247-L252>)

```go
func (p Participant) PrepareToSign(pubKey *curves.EcPoint, verify curves.EcdsaVerify, curve elliptic.Curve, keyGenType dealer.KeyGenType, publicSharesMap map[uint32]*dealer.PublicShare, pubKeys map[uint32]*paillier.PublicKey) (*Signer, error)
```

PrepareToSign creates a Signer out of a Participant\. The expected co\-signers for the signing rounds are expected to be exactly those included in the publicSharesMap

## type [Round1Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round1.go#L21-L26>)

Round1Bcast contains values to be broadcast to all players after the completion of singing round 1

```go
type Round1Bcast struct {
    Identifier uint32
    C          core.Commitment
    Ctxt       *big.Int
    Proof      *proof.Range1Proof
}
```

## type [Round1P2PSend](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round1.go#L28>)

```go
type Round1P2PSend = proof.Range1Proof
```

## type [Round3Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round3.go#L22-L32>)

Round3Bcast represents the value to be broadcast to all players at the conclusion of round 3

```go
type Round3Bcast struct {
    // contains filtered or unexported fields
}
```

### func \(Round3Bcast\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round3.go#L39>)

```go
func (r3b Round3Bcast) MarshalJSON() ([]byte, error)
```

### func \(\*Round3Bcast\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round3.go#L43>)

```go
func (r3b *Round3Bcast) UnmarshalJSON(data []byte) error
```

## type [Round3BcastJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round3.go#L34-L36>)

Round3Bcast represents the value to be broadcast to all players at the conclusion of round 3

```go
type Round3BcastJSON struct {
    DeltaElement *big.Int
}
```

## type [Round4Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round4.go#L17-L19>)

Round4Bcast are the values to be broadcast to the other players at the conclusion of signing round 4

```go
type Round4Bcast struct {
    Witness *core.Witness
}
```

## type [Round5Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round5.go#L19-L22>)

Round5Bcast are the values to be broadcast to the other players at the conclusion of signing round 5

```go
type Round5Bcast struct {
    Rbar  *curves.EcPoint
    Proof *proof.PdlProof
}
```

## type [Round5P2PSend](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round5.go#L26>)

Round5P2PSend are the values sent to each participant at the conclusion of signing round 5

```go
type Round5P2PSend = proof.PdlProof
```

## type [Round6FullBcast](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round6.go#L23-L33>)

Round6FullBcast are the values to be broadcast to the other players This is the s\_i value from §5\.fig 5\.SignRound6\.step 9

```go
type Round6FullBcast struct {
    // contains filtered or unexported fields
}
```

### func \(Round6FullBcast\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round6.go#L40>)

```go
func (r6b Round6FullBcast) MarshalJSON() ([]byte, error)
```

### func \(\*Round6FullBcast\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round6.go#L44>)

```go
func (r6b *Round6FullBcast) UnmarshalJSON(data []byte) error
```

## type [Round6FullBcastJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round6.go#L35-L37>)

Round6FullBcast are the values to be broadcast to the other players This is the s\_i value from §5\.fig 5\.SignRound6\.step 9

```go
type Round6FullBcastJSON struct {
    SElement *big.Int
}
```

## type [Signer](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/participant.go#L31-L43>)

Signer is a tECDSA player that holds the additive shares needed for performing the signing operation

```go
type Signer struct {
    PublicKey *curves.EcPoint
    Curve     elliptic.Curve
    Round     uint // current signing round in our linear state machine
    // contains filtered or unexported fields
}
```

### func [NewSigner](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/participant.go#L46>)

```go
func NewSigner(info *dealer.ParticipantData, cosigners []uint32) (*Signer, error)
```

NewSigner C=creates a new signer from a dealer\-provided output and a specific set of co\-signers

### func \(\*Signer\) [SignOutput](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round6.go#L172>)

```go
func (signer *Signer) SignOutput(in map[uint32]*Round6FullBcast) (*curves.EcdsaSignature, error)
```

SignOutput performs the signature aggregation step in \[spec\] §5\.fig 5

### func \(\*Signer\) [SignRound1](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round1.go#L36>)

```go
func (signer *Signer) SignRound1() (*Round1Bcast, map[uint32]*Round1P2PSend, error)
```

SignRound1 performs round 1 signing operation Trusted Dealer Mode: see \[spec\] fig 7: SignRound1 DKG Mode: see \[spec\] fig 8: SignRound1 NOTE: Pseudocode shows N\~\, h1\, h2\, the curve's g\, q\, and signer's public key as inputs Since \`signer\` already knows the paillier secret and public keys\, this input is not necessary here \`participant\.PrepareToSign\` receives the other inputs and stores them as state variables\.

### func \(\*Signer\) [SignRound2](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round2.go#L45>)

```go
func (signer *Signer) SignRound2(params map[uint32]*Round1Bcast, p2p map[uint32]*Round1P2PSend) (map[uint32]*P2PSend, error)
```

SignRound2 performs round 2 signing operations for a single signer Trusted Dealer Mode: see \[spec\] fig 7: SignRound2 DKG Mode: see \[spec\] fig 8: SignRound2

### func \(\*Signer\) [SignRound3](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round3.go#L56>)

```go
func (s *Signer) SignRound3(in map[uint32]*P2PSend) (*Round3Bcast, error)
```

SignRound3 performs the round 3 signing operation according to Trusted Dealer Mode: see \[spec\] fig 7: SignRound3 DKG Mode: see \[spec\] fig 8: SignRound3

### func \(\*Signer\) [SignRound4](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round4.go#L26>)

```go
func (s *Signer) SignRound4(deltas map[uint32]*Round3Bcast) (*Round4Bcast, error)
```

SignRound4 performs the round 4 signing operation\. It takes input the delta\_j values broadcast from signers at the conclusion of round 3\. Trusted Dealer Mode: see \[spec\] fig 7: SignRound4 DKG Mode: see \[spec\] fig 8: SignRound4

### func \(\*Signer\) [SignRound5](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round5.go#L33>)

```go
func (signer *Signer) SignRound5(witnesses map[uint32]*Round4Bcast) (*Round5Bcast, map[uint32]*Round5P2PSend, error)
```

SignRound5 performs the round 5 signing operation\. It takes input the Witness values broadcast from signers at the conclusion of round 4\. Trusted Dealer Mode: see \[spec\] fig 7: SignRound5 DKG Mode: see \[spec\] fig 8: SignRound5

### func \(\*Signer\) [SignRound6Full](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/participant/round6.go#L57>)

```go
func (signer *Signer) SignRound6Full(hash []byte, in map[uint32]*Round5Bcast, p2p map[uint32]*Round5P2PSend) (*Round6FullBcast, error)
```

SignRound6Full performs the round 6 signing operation according to Trusted Dealer Mode: see \[spec\] fig 7: SignRound6 DKG Mode: see \[spec\] fig 8: SignRound6



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
