<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# proof

```go
import "github.com/coinbase/kryptology/pkg/tecdsa/gg20/proof"
```

## Index

- [type CdlProof](<#type-cdlproof>)
  - [func (cdlp CdlProof) MarshalJSON() ([]byte, error)](<#func-cdlproof-marshaljson>)
  - [func (cdlp *CdlProof) UnmarshalJSON(bytes []byte) error](<#func-cdlproof-unmarshaljson>)
  - [func (p CdlProof) Verify(cv *CdlVerifyParams) error](<#func-cdlproof-verify>)
- [type CdlProofParams](<#type-cdlproofparams>)
  - [func (p CdlProofParams) Prove() (*CdlProof, error)](<#func-cdlproofparams-prove>)
- [type CdlVerifyParams](<#type-cdlverifyparams>)
- [type PdlProof](<#type-pdlproof>)
  - [func (pdlp PdlProof) MarshalJSON() ([]byte, error)](<#func-pdlproof-marshaljson>)
  - [func (pdlp *PdlProof) UnmarshalJSON(bytes []byte) error](<#func-pdlproof-unmarshaljson>)
  - [func (p PdlProof) Verify(pv *PdlVerifyParams) error](<#func-pdlproof-verify>)
- [type PdlProofParams](<#type-pdlproofparams>)
  - [func (p PdlProofParams) Prove() (*PdlProof, error)](<#func-pdlproofparams-prove>)
- [type PdlVerifyParams](<#type-pdlverifyparams>)
- [type Proof1Params](<#type-proof1params>)
  - [func (pp Proof1Params) Prove() (*Range1Proof, error)](<#func-proof1params-prove>)
- [type Range1Proof](<#type-range1proof>)
  - [func (r Range1Proof) MarshalJSON() ([]byte, error)](<#func-range1proof-marshaljson>)
  - [func (r *Range1Proof) UnmarshalJSON(bytes []byte) error](<#func-range1proof-unmarshaljson>)
  - [func (pi Range1Proof) Verify(pp *Proof1Params) error](<#func-range1proof-verify>)
- [type Range2Proof](<#type-range2proof>)
  - [func (rP2 Range2Proof) MarshalJSON() ([]byte, error)](<#func-range2proof-marshaljson>)
  - [func (rP2 *Range2Proof) UnmarshalJSON(bytes []byte) error](<#func-range2proof-unmarshaljson>)
  - [func (pi Range2Proof) Verify(pp *verifyProof2Params) error](<#func-range2proof-verify>)
  - [func (pi Range2Proof) VerifyWc(pp *verifyProof2Params) error](<#func-range2proof-verifywc>)
- [type ResponseFinalizer](<#type-responsefinalizer>)
- [type ResponseProof](<#type-responseproof>)
  - [func (rp ResponseProof) Finalize(vp *ResponseVerifyParams) (*big.Int, error)](<#func-responseproof-finalize>)
  - [func (rp ResponseProof) FinalizeWc(vp *ResponseVerifyParams) (*big.Int, error)](<#func-responseproof-finalizewc>)
- [type ResponseProofParams](<#type-responseproofparams>)
  - [func (rp ResponseProofParams) Prove() (*ResponseProof, error)](<#func-responseproofparams-prove>)
  - [func (rp ResponseProofParams) ProveWc() (*ResponseProof, error)](<#func-responseproofparams-provewc>)
- [type ResponseVerifyParams](<#type-responseverifyparams>)


## type [CdlProof](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/cdl.go#L31-L33>)

```go
type CdlProof struct {
    // contains filtered or unexported fields
}
```

### func \(CdlProof\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/cdl.go#L40>)

```go
func (cdlp CdlProof) MarshalJSON() ([]byte, error)
```

### func \(\*CdlProof\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/cdl.go#L48>)

```go
func (cdlp *CdlProof) UnmarshalJSON(bytes []byte) error
```

### func \(CdlProof\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/cdl.go#L121>)

```go
func (p CdlProof) Verify(cv *CdlVerifyParams) error
```

Verify checks the CdlProof as specified in \[spec\] §10\.fig 16

## type [CdlProofParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/cdl.go#L26-L29>)

CdlProofParams encapsulates parameters for ProveCompositeDL in Fig\.16 Curve contains EC group generator g and EC group modulus q Pi\, Qi are small p\_i\, q\_i s\.t\. P\_i = 2p\_i\+1\, Q\_i = 2q\_i\+1\, which are Safe Primes ScalarX is a random element from Z\_N\~ and it should be kept as secret N is the field modulus

```go
type CdlProofParams struct {
    Curve                      elliptic.Curve
    Pi, Qi, H1, H2, ScalarX, N *big.Int
}
```

### func \(CdlProofParams\) [Prove](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/cdl.go#L67>)

```go
func (p CdlProofParams) Prove() (*CdlProof, error)
```

Prove generates a CdlProof as specified in \[spec\] §10\.fig 16

## type [CdlVerifyParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/cdl.go#L60-L63>)

```go
type CdlVerifyParams struct {
    Curve     elliptic.Curve
    H1, H2, N *big.Int
}
```

## type [PdlProof](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/pdl.go#L35-L37>)

PdlProof is the proof generated in \[spec\] fig 14

```go
type PdlProof struct {
    // contains filtered or unexported fields
}
```

### func \(PdlProof\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/pdl.go#L43>)

```go
func (pdlp PdlProof) MarshalJSON() ([]byte, error)
```

### func \(\*PdlProof\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/pdl.go#L54>)

```go
func (pdlp *PdlProof) UnmarshalJSON(bytes []byte) error
```

### func \(PdlProof\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/pdl.go#L163>)

```go
func (p PdlProof) Verify(pv *PdlVerifyParams) error
```

Verify checks the PdlProof as specified in \[spec\] fig 14

## type [PdlProofParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/pdl.go#L25-L31>)

PdlProofParams encapsulates the parameters for ProvePDL in \[spec\] fig 14

```go
type PdlProofParams struct {
    Curve               elliptic.Curve
    DealerParams        *dealer.ProofParams
    Pk                  *paillier.PublicKey
    ScalarX, ScalarR, C *big.Int
    PointX, PointR      *curves.EcPoint
}
```

### func \(PdlProofParams\) [Prove](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/pdl.go#L88>)

```go
func (p PdlProofParams) Prove() (*PdlProof, error)
```

Prove generates a PdlProof as specified in \[spec\] fig 14

## type [PdlVerifyParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/pdl.go#L72-L78>)

PdlVerifyParams encapsulates the parameters for VerifyPDL in \[spec\] fig 14

```go
type PdlVerifyParams struct {
    Curve          elliptic.Curve
    DealerParams   *dealer.ProofParams
    Pk             *paillier.PublicKey
    PointX, PointR *curves.EcPoint
    C              *big.Int
}
```

## type [Proof1Params](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L60-L65>)

Proof1Params encapsulates the values over which a range proof \(1\) is computed\. \[spec\] fig 10

```go
type Proof1Params struct {
    Curve        elliptic.Curve
    Pk           *paillier.PublicKey
    DealerParams *dealer.ProofParams
    A, C, R      *big.Int
}
```

### func \(Proof1Params\) [Prove](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L311>)

```go
func (pp Proof1Params) Prove() (*Range1Proof, error)
```

Prove computes a range proof over these parameters \[spec\] fig 10: MtaProveRange1

## type [Range1Proof](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L75-L77>)

Range1Proof encapsulates the results returned in proof \(1\) \[spec\] fig 10

```go
type Range1Proof struct {
    // contains filtered or unexported fields
}
```

### func \(Range1Proof\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L125>)

```go
func (r Range1Proof) MarshalJSON() ([]byte, error)
```

MarshalJSON converts Range1Proof into JSON

### func \(\*Range1Proof\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L136>)

```go
func (r *Range1Proof) UnmarshalJSON(bytes []byte) error
```

UnmarshalJSON converts json into a Range1Proof

### func \(Range1Proof\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L440>)

```go
func (pi Range1Proof) Verify(pp *Proof1Params) error
```

Verify checks a range \(1\) proof: \[spec\] §7\.fig 7: MtaVerifyRange1

## type [Range2Proof](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L113-L116>)

Range2Proof encapsulates the values over which a range proof \(2\) is computed\. \[spec\] fig 12

```go
type Range2Proof struct {
    // contains filtered or unexported fields
}
```

### func \(Range2Proof\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L152>)

```go
func (rP2 Range2Proof) MarshalJSON() ([]byte, error)
```

MarshalJSON converts Range2Proof into JSON format

### func \(\*Range2Proof\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L167>)

```go
func (rP2 *Range2Proof) UnmarshalJSON(bytes []byte) error
```

UnmarshalJSON converts json into a Range2Proof

### func \(Range2Proof\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L678>)

```go
func (pi Range2Proof) Verify(pp *verifyProof2Params) error
```

Verify checks a range \(2\) proof: \[spec\] §7\.fig 9: MtaVerifyRange2

### func \(Range2Proof\) [VerifyWc](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L683>)

```go
func (pi Range2Proof) VerifyWc(pp *verifyProof2Params) error
```

VerifyWc checks a range \(2\) proof: \[spec\] §7\.fig 9: MtaVerifyRange2\_wc

## type [ResponseFinalizer](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L45-L48>)

ResponseFinalizer captures the interface provided by a response proof \[spec\] fig 13

```go
type ResponseFinalizer interface {
    Finalize(vp *ResponseVerifyParams) (*big.Int, error)
    FinalizeWc(vp *ResponseVerifyParams) (*big.Int, error)
}
```

## type [ResponseProof](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L53-L56>)

ResponseProof encapsulates the values over which a range proof \(2\) is computed and a portion of the random value is encrypted \[spec\] §7\.fig 8

```go
type ResponseProof struct {
    R2proof  *Range2Proof
    C2, Beta *big.Int
}
```

### func \(ResponseProof\) [Finalize](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L260>)

```go
func (rp ResponseProof) Finalize(vp *ResponseVerifyParams) (*big.Int, error)
```

Finalize checks a range \(2\) proof: \[spec\] fig 13: MtaFinalize and returns the paillier encrypted random value

### func \(ResponseProof\) [FinalizeWc](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L284>)

```go
func (rp ResponseProof) FinalizeWc(vp *ResponseVerifyParams) (*big.Int, error)
```

FinalizeWc checks a range \(2\) proof: \[spec\] fig 13: MtaFinalize\_wc and returns the paillier encrypted random value

## type [ResponseProofParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L25-L31>)

ResponseProofParams encapsulates the values over which a range proof \(2\) is computed\. \[spec\] §7\.fig 8

```go
type ResponseProofParams struct {
    Curve        elliptic.Curve
    DealerParams *dealer.ProofParams
    Pk           *paillier.PublicKey
    SmallB, C1   *big.Int
    B            *curves.EcPoint
}
```

### func \(ResponseProofParams\) [Prove](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L189>)

```go
func (rp ResponseProofParams) Prove() (*ResponseProof, error)
```

Prove computes a range proof over these parameters \[spec\] fig 11: MtaResponse

### func \(ResponseProofParams\) [ProveWc](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L195>)

```go
func (rp ResponseProofParams) ProveWc() (*ResponseProof, error)
```

ProveWc computes: \[spec\] fig 11: MtaResponse\_wc

## type [ResponseVerifyParams](<https://github.com/coinbase/kryptology/blob/master/pkg/tecdsa/gg20/proof/mta.go#L35-L41>)

ResponseVerifyParams encapsulates the values over which a range proof \(2\) is verified\. \[spec\] §7\.fig 10

```go
type ResponseVerifyParams struct {
    Curve        elliptic.Curve
    DealerParams *dealer.ProofParams
    Sk           *paillier.SecretKey
    C1           *big.Int
    B            *curves.EcPoint
}
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
