<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# frost

```go
import "github.com/coinbase/kryptology/pkg/ted25519/frost"
```

## Index

- [type ChallengeDerive](<#type-challengederive>)
- [type Ed25519ChallengeDeriver](<#type-ed25519challengederiver>)
  - [func (ed Ed25519ChallengeDeriver) DeriveChallenge(msg []byte, pubKey curves.Point, r curves.Point) (curves.Scalar, error)](<#func-ed25519challengederiver-derivechallenge>)
- [type Round1Bcast](<#type-round1bcast>)
  - [func (result *Round1Bcast) Decode(input []byte) error](<#func-round1bcast-decode>)
  - [func (result *Round1Bcast) Encode() ([]byte, error)](<#func-round1bcast-encode>)
- [type Round2Bcast](<#type-round2bcast>)
  - [func (result *Round2Bcast) Decode(input []byte) error](<#func-round2bcast-decode>)
  - [func (result *Round2Bcast) Encode() ([]byte, error)](<#func-round2bcast-encode>)
- [type Round3Bcast](<#type-round3bcast>)
- [type Signature](<#type-signature>)
- [type Signer](<#type-signer>)
  - [func NewSigner(info *frost.DkgParticipant, id, thresh uint32, lcoeffs map[uint32]curves.Scalar, cosigners []uint32, challengeDeriver ChallengeDerive) (*Signer, error)](<#func-newsigner>)
  - [func (signer *Signer) SignRound1() (*Round1Bcast, error)](<#func-signer-signround1>)
  - [func (signer *Signer) SignRound2(msg []byte, round2Input map[uint32]*Round1Bcast) (*Round2Bcast, error)](<#func-signer-signround2>)
  - [func (signer *Signer) SignRound3(round3Input map[uint32]*Round2Bcast) (*Round3Bcast, error)](<#func-signer-signround3>)
  - [func (signer *Signer) Verify(vk curves.Point, message []byte, signature *Signature) (bool, error)](<#func-signer-verify>)


## type [ChallengeDerive](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/challenge_derive.go#L14-L16>)

```go
type ChallengeDerive interface {
    DeriveChallenge(msg []byte, pubKey curves.Point, r curves.Point) (curves.Scalar, error)
}
```

## type [Ed25519ChallengeDeriver](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/challenge_derive.go#L18>)

```go
type Ed25519ChallengeDeriver struct{}
```

### func \(Ed25519ChallengeDeriver\) [DeriveChallenge](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/challenge_derive.go#L20>)

```go
func (ed Ed25519ChallengeDeriver) DeriveChallenge(msg []byte, pubKey curves.Point, r curves.Point) (curves.Scalar, error)
```

## type [Round1Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round1.go#L16-L18>)

Round1Bcast contains values to be broadcast to all players after the completion of signing round 1\.

```go
type Round1Bcast struct {
    Di, Ei curves.Point
}
```

### func \(\*Round1Bcast\) [Decode](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round1.go#L34>)

```go
func (result *Round1Bcast) Decode(input []byte) error
```

### func \(\*Round1Bcast\) [Encode](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round1.go#L23>)

```go
func (result *Round1Bcast) Encode() ([]byte, error)
```

## type [Round2Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round2.go#L19-L22>)

Round2Bcast contains values that will be broadcast to other signers after completion of round 2\.

```go
type Round2Bcast struct {
    Zi  curves.Scalar
    Vki curves.Point
}
```

### func \(\*Round2Bcast\) [Decode](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round2.go#L35>)

```go
func (result *Round2Bcast) Decode(input []byte) error
```

### func \(\*Round2Bcast\) [Encode](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round2.go#L24>)

```go
func (result *Round2Bcast) Encode() ([]byte, error)
```

## type [Round3Bcast](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round3.go#L17-L21>)

Round3Bcast contains the output of FROST signature\, i\.e\.\, it contains FROST signature \(z\,c\) and the corresponding message msg\.

```go
type Round3Bcast struct {
    R    curves.Point
    Z, C curves.Scalar
    // contains filtered or unexported fields
}
```

## type [Signature](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round3.go#L24-L27>)

Define frost signature type

```go
type Signature struct {
    Z   curves.Scalar
    C   curves.Scalar
}
```

## type [Signer](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/participant.go#L17-L29>)

Signer is a tSchnorr player performing the signing operation\.

```go
type Signer struct {
    // contains filtered or unexported fields
}
```

### func [NewSigner](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/participant.go#L47>)

```go
func NewSigner(info *frost.DkgParticipant, id, thresh uint32, lcoeffs map[uint32]curves.Scalar, cosigners []uint32, challengeDeriver ChallengeDerive) (*Signer, error)
```

NewSigner create a signer from a dkg participant Note that we can pre\-assign Lagrange coefficients lcoeffs of each cosigner\. This optimizes performance\. See paragraph 3 of section 3 in the draft \- https://tools.ietf.org/pdf/draft-komlo-frost-00.pdf

### func \(\*Signer\) [SignRound1](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round1.go#L20>)

```go
func (signer *Signer) SignRound1() (*Round1Bcast, error)
```

### func \(\*Signer\) [SignRound2](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round2.go#L22>)

```go
func (signer *Signer) SignRound2(msg []byte, round2Input map[uint32]*Round1Bcast) (*Round2Bcast, error)
```

SignRound2 implements FROST signing round 2\.

### func \(\*Signer\) [SignRound3](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round3.go#L23>)

```go
func (signer *Signer) SignRound3(round3Input map[uint32]*Round2Bcast) (*Round3Bcast, error)
```

### func \(\*Signer\) [Verify](<https://github.com/coinbase/kryptology/blob/master/pkg/ted25519/frost/round3.go#L133>)

```go
func (signer *Signer) Verify(vk curves.Point, message []byte, signature *Signature) (bool, error)
```

Method to verify a frost signature\.



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
