<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# elgamal

```go
import "github.com/coinbase/kryptology/pkg/verenc/elgamal"
```

## Index

- [func NewKeys(curve *curves.Curve) (*EncryptionKey, *DecryptionKey, error)](<#func-newkeys>)
- [type CipherText](<#type-ciphertext>)
  - [func (c CipherText) MarshalBinary() ([]byte, error)](<#func-ciphertext-marshalbinary>)
  - [func (c CipherText) ToHomomorphicCipherText() *HomomorphicCipherText](<#func-ciphertext-tohomomorphicciphertext>)
  - [func (c *CipherText) UnmarshalBinary(data []byte) error](<#func-ciphertext-unmarshalbinary>)
- [type DecryptionKey](<#type-decryptionkey>)
  - [func (dk *DecryptionKey) Decrypt(cipherText *HomomorphicCipherText) curves.Point](<#func-decryptionkey-decrypt>)
  - [func (dk DecryptionKey) EncryptionKey() *EncryptionKey](<#func-decryptionkey-encryptionkey>)
  - [func (dk DecryptionKey) MarshalBinary() ([]byte, error)](<#func-decryptionkey-marshalbinary>)
  - [func (dk *DecryptionKey) UnmarshalBinary(data []byte) error](<#func-decryptionkey-unmarshalbinary>)
  - [func (dk DecryptionKey) VerifiableDecrypt(cipherText *CipherText) ([]byte, curves.Scalar, error)](<#func-decryptionkey-verifiabledecrypt>)
  - [func (dk DecryptionKey) VerifiableDecryptWithDomain(domain []byte, cipherText *CipherText) ([]byte, curves.Scalar, error)](<#func-decryptionkey-verifiabledecryptwithdomain>)
- [type EncryptParams](<#type-encryptparams>)
- [type EncryptionKey](<#type-encryptionkey>)
  - [func (ek EncryptionKey) HomomorphicEncrypt(msg curves.Scalar) (*HomomorphicCipherText, error)](<#func-encryptionkey-homomorphicencrypt>)
  - [func (ek EncryptionKey) MarshalBinary() ([]byte, error)](<#func-encryptionkey-marshalbinary>)
  - [func (ek *EncryptionKey) UnmarshalBinary(data []byte) error](<#func-encryptionkey-unmarshalbinary>)
  - [func (ek EncryptionKey) VerifiableEncrypt(msg []byte, params *EncryptParams) (*CipherText, *ProofVerEnc, error)](<#func-encryptionkey-verifiableencrypt>)
  - [func (ek EncryptionKey) VerifyDomainEncryptProof(nonce []byte, ciphertext *CipherText, proof *ProofVerEnc) error](<#func-encryptionkey-verifydomainencryptproof>)
  - [func (ek EncryptionKey) VerifyEncryptProof(nonce []byte, ciphertext *CipherText, proof *ProofVerEnc) error](<#func-encryptionkey-verifyencryptproof>)
- [type HomomorphicCipherText](<#type-homomorphicciphertext>)
  - [func (c HomomorphicCipherText) Add(rhs *HomomorphicCipherText) *HomomorphicCipherText](<#func-homomorphicciphertext-add>)
  - [func (c HomomorphicCipherText) Decrypt(dk *DecryptionKey) (curves.Point, error)](<#func-homomorphicciphertext-decrypt>)
  - [func (c HomomorphicCipherText) MarshalBinary() ([]byte, error)](<#func-homomorphicciphertext-marshalbinary>)
  - [func (c *HomomorphicCipherText) UnmarshalBinary(in []byte) error](<#func-homomorphicciphertext-unmarshalbinary>)
- [type ProofVerEnc](<#type-proofverenc>)
  - [func (pf ProofVerEnc) MarshalBinary() ([]byte, error)](<#func-proofverenc-marshalbinary>)
  - [func (pf *ProofVerEnc) UnmarshalBinary(data []byte) error](<#func-proofverenc-unmarshalbinary>)


## func [NewKeys](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/encryption_key.go#L52>)

```go
func NewKeys(curve *curves.Curve) (*EncryptionKey, *DecryptionKey, error)
```

NewKeys creates a new key pair for El\-Gamal encryption

## type [CipherText](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L18-L23>)

CipherText represents verifiably encrypted ciphertext using El\-Gamal encryption

```go
type CipherText struct {
    C1, C2      curves.Point
    Nonce       []byte
    Aead        []byte
    MsgIsHashed bool
}
```

### func \(CipherText\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L49>)

```go
func (c CipherText) MarshalBinary() ([]byte, error)
```

### func \(CipherText\) [ToHomomorphicCipherText](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L91>)

```go
func (c CipherText) ToHomomorphicCipherText() *HomomorphicCipherText
```

ToHomomorphicCipherText returns the El\-Gamal points that can be homomorphically multiplied

### func \(\*CipherText\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L62>)

```go
func (c *CipherText) UnmarshalBinary(data []byte) error
```

## type [DecryptionKey](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/decryption_key.go#L26-L28>)

DecryptionKey decrypts verifiable ciphertext and verifies proofs

```go
type DecryptionKey struct {
    // contains filtered or unexported fields
}
```

### func \(\*DecryptionKey\) [Decrypt](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/decryption_key.go#L67>)

```go
func (dk *DecryptionKey) Decrypt(cipherText *HomomorphicCipherText) curves.Point
```

Decrypt returns the resulting point from El\-Gamal decryption\. No checking is performed whether the ciphertext has been modified\. M = H \* m = C2 \- C1 \* x

### func \(DecryptionKey\) [EncryptionKey](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/decryption_key.go#L31>)

```go
func (dk DecryptionKey) EncryptionKey() *EncryptionKey
```

EncryptionKey returns the corresponding encryption key for this decryption key

### func \(DecryptionKey\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/decryption_key.go#L38>)

```go
func (dk DecryptionKey) MarshalBinary() ([]byte, error)
```

MarshalBinary serializes a key to bytes

### func \(\*DecryptionKey\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/decryption_key.go#L46>)

```go
func (dk *DecryptionKey) UnmarshalBinary(data []byte) error
```

UnmarshalBinary deserializes a key from bytes

### func \(DecryptionKey\) [VerifiableDecrypt](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/decryption_key.go#L78>)

```go
func (dk DecryptionKey) VerifiableDecrypt(cipherText *CipherText) ([]byte, curves.Scalar, error)
```

VerifiableDecrypt the ciphertext\. This performs verifiable decryption such that the decrypted data is checked against El\-Gamal C2 value\. If the plaintext does not match\, an error is returned been generated by Encrypt

### func \(DecryptionKey\) [VerifiableDecryptWithDomain](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/decryption_key.go#L97>)

```go
func (dk DecryptionKey) VerifiableDecryptWithDomain(domain []byte, cipherText *CipherText) ([]byte, curves.Scalar, error)
```

VerifiableDecryptWithDomain the ciphertext\. This performs verifiable decryption such that the decrypted data is checked against El\-Gamal C2 value\. If the plaintext does not match\, an error is returned The Domain component is meant for scenarios where \`msg\` is used in more than just one setting and should be contextualized\. The ciphertext must have been generated by EncryptWithDomain

## type [EncryptParams](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/encryption_key.go#L37-L43>)

EncryptParams is all the options for doing verifiable encryption\. Message must be supplied and is the value to be encrypted\. MessageIsHashed defines whether Message represents an unhashed arbitrary byte sequence or already represents a scalar in the elliptic curve\. Domain is an optional domain separation tag and used to generate a separate point for the pedersen commitment in El\-Gamal ciphertexts\. Blinding is blinding factor \(bf\) of the El\-Gamal ciphertext\. If nil a bf is generated at random\. GenProof indicates whether to return a proof of encryption correctness to the corresponding public key\. ProofNonce is the nonce used to generate the one time proof\. This value is required if GenProof is true\.

```go
type EncryptParams struct {
    MessageIsHashed bool
    Domain          []byte
    Blinding        curves.Scalar
    GenProof        bool
    ProofNonce      []byte
}
```

## type [EncryptionKey](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/encryption_key.go#L47-L49>)

EncryptionKey encrypts a message to a ciphertext from which zero\-knowledge proofs can be derived

```go
type EncryptionKey struct {
    // contains filtered or unexported fields
}
```

### func \(EncryptionKey\) [HomomorphicEncrypt](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/encryption_key.go#L94>)

```go
func (ek EncryptionKey) HomomorphicEncrypt(msg curves.Scalar) (*HomomorphicCipherText, error)
```

### func \(EncryptionKey\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/encryption_key.go#L68>)

```go
func (ek EncryptionKey) MarshalBinary() ([]byte, error)
```

MarshalBinary serializes a key to bytes

### func \(\*EncryptionKey\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/encryption_key.go#L76>)

```go
func (ek *EncryptionKey) UnmarshalBinary(data []byte) error
```

UnmarshalBinary deserializes a key from bytes

### func \(EncryptionKey\) [VerifiableEncrypt](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/proof_enc.go#L70>)

```go
func (ek EncryptionKey) VerifiableEncrypt(msg []byte, params *EncryptParams) (*CipherText, *ProofVerEnc, error)
```

VerifiableEncrypt a message using El\-Gamal\. This also functions as an ECIES encryption algorithm\. The advantage here is proofs can be made about the ciphertext versus plain ECIES if desired and/or linked to external proofs\.

### func \(EncryptionKey\) [VerifyDomainEncryptProof](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/proof_enc.go#L152>)

```go
func (ek EncryptionKey) VerifyDomainEncryptProof(nonce []byte, ciphertext *CipherText, proof *ProofVerEnc) error
```

VerifyDomainEncryptProof a Proof of Verifiable Encryption that was generated with EncryptDomainAndProve or EncryptDomainAndProveBlinding\.

### func \(EncryptionKey\) [VerifyEncryptProof](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/proof_enc.go#L172>)

```go
func (ek EncryptionKey) VerifyEncryptProof(nonce []byte, ciphertext *CipherText, proof *ProofVerEnc) error
```

VerifyEncryptProof a Proof of Verifiable Encryption that was generated with EncryptAndProve or EncryptAndProveBlinding

## type [HomomorphicCipherText](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L30-L32>)

HomomorphicCipherText represents encrypted ciphertexts that have been added together\. The result when decrypted does not include the AEAD encrypted ciphertexts since these are not homomorphic\. This is solely for checking results or ignoring the AEAD ciphertext\.

```go
type HomomorphicCipherText struct {
    C1, C2 curves.Point
}
```

### func \(HomomorphicCipherText\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L99>)

```go
func (c HomomorphicCipherText) Add(rhs *HomomorphicCipherText) *HomomorphicCipherText
```

Add combines two ciphertexts multiplicatively homomorphic

### func \(HomomorphicCipherText\) [Decrypt](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L107>)

```go
func (c HomomorphicCipherText) Decrypt(dk *DecryptionKey) (curves.Point, error)
```

Decrypt returns the C2 \- C1

### func \(HomomorphicCipherText\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L114>)

```go
func (c HomomorphicCipherText) MarshalBinary() ([]byte, error)
```

### func \(\*HomomorphicCipherText\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/ciphertext.go#L122>)

```go
func (c *HomomorphicCipherText) UnmarshalBinary(in []byte) error
```

## type [ProofVerEnc](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/proof_enc.go#L18-L20>)

ProofVerEnc is a proof of verifiable encryption for a discrete log

```go
type ProofVerEnc struct {
    // contains filtered or unexported fields
}
```

### func \(ProofVerEnc\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/proof_enc.go#L29>)

```go
func (pf ProofVerEnc) MarshalBinary() ([]byte, error)
```

### func \(\*ProofVerEnc\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/verenc/elgamal/proof_enc.go#L39>)

```go
func (pf *ProofVerEnc) UnmarshalBinary(data []byte) error
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
