<!-- Code generated by gomarkdoc. DO NOT EDIT -->

# curves

```go
import "github.com/coinbase/kryptology/pkg/core/curves"
```

This implementation IS NOT constant time as it leverages math/big for big number operations\.

## Index

- [Constants](<#constants>)
- [func Ed25519Order() *big.Int](<#func-ed25519order>)
- [func VerifyEcdsa(pk *EcPoint, hash []byte, sig *EcdsaSignature) bool](<#func-verifyecdsa>)
- [type Bls12381Scalar](<#type-bls12381scalar>)
  - [func NewBls12381Scalar() *Bls12381Scalar](<#func-newbls12381scalar>)
  - [func (k Bls12381Scalar) Add(x, y *big.Int) *big.Int](<#func-bls12381scalar-add>)
  - [func (k Bls12381Scalar) Bytes(x *big.Int) []byte](<#func-bls12381scalar-bytes>)
  - [func (k Bls12381Scalar) Div(x, y *big.Int) *big.Int](<#func-bls12381scalar-div>)
  - [func (k Bls12381Scalar) Hash(input []byte) *big.Int](<#func-bls12381scalar-hash>)
  - [func (k Bls12381Scalar) IsValid(x *big.Int) bool](<#func-bls12381scalar-isvalid>)
  - [func (k Bls12381Scalar) Mul(x, y *big.Int) *big.Int](<#func-bls12381scalar-mul>)
  - [func (k Bls12381Scalar) Neg(x *big.Int) *big.Int](<#func-bls12381scalar-neg>)
  - [func (k Bls12381Scalar) Random() (*big.Int, error)](<#func-bls12381scalar-random>)
  - [func (k Bls12381Scalar) Sub(x, y *big.Int) *big.Int](<#func-bls12381scalar-sub>)
- [type Curve](<#type-curve>)
  - [func BLS12377G1() *Curve](<#func-bls12377g1>)
  - [func BLS12377G2() *Curve](<#func-bls12377g2>)
  - [func BLS12381G1() *Curve](<#func-bls12381g1>)
  - [func BLS12381G2() *Curve](<#func-bls12381g2>)
  - [func ED25519() *Curve](<#func-ed25519>)
  - [func GetCurveByName(name string) *Curve](<#func-getcurvebyname>)
  - [func K256() *Curve](<#func-k256>)
  - [func P256() *Curve](<#func-p256>)
  - [func PALLAS() *Curve](<#func-pallas>)
  - [func (c Curve) NewGeneratorPoint() Point](<#func-curve-newgeneratorpoint>)
  - [func (c Curve) NewIdentityPoint() Point](<#func-curve-newidentitypoint>)
  - [func (c Curve) NewScalar() Scalar](<#func-curve-newscalar>)
  - [func (c Curve) ScalarBaseMult(sc Scalar) Point](<#func-curve-scalarbasemult>)
- [type EcPoint](<#type-ecpoint>)
  - [func NewScalarBaseMult(curve elliptic.Curve, k *big.Int) (*EcPoint, error)](<#func-newscalarbasemult>)
  - [func PointFromBytesUncompressed(curve elliptic.Curve, b []byte) (*EcPoint, error)](<#func-pointfrombytesuncompressed>)
  - [func (a *EcPoint) Add(b *EcPoint) (*EcPoint, error)](<#func-ecpoint-add>)
  - [func (a EcPoint) Bytes() []byte](<#func-ecpoint-bytes>)
  - [func (a EcPoint) Equals(b *EcPoint) bool](<#func-ecpoint-equals>)
  - [func (a EcPoint) IsBasePoint() bool](<#func-ecpoint-isbasepoint>)
  - [func (a EcPoint) IsIdentity() bool](<#func-ecpoint-isidentity>)
  - [func (a EcPoint) IsOnCurve() bool](<#func-ecpoint-isoncurve>)
  - [func (a EcPoint) IsValid() bool](<#func-ecpoint-isvalid>)
  - [func (a *EcPoint) MarshalBinary() ([]byte, error)](<#func-ecpoint-marshalbinary>)
  - [func (a EcPoint) MarshalJSON() ([]byte, error)](<#func-ecpoint-marshaljson>)
  - [func (a *EcPoint) Neg() (*EcPoint, error)](<#func-ecpoint-neg>)
  - [func (a *EcPoint) ScalarMult(k *big.Int) (*EcPoint, error)](<#func-ecpoint-scalarmult>)
  - [func (a *EcPoint) UnmarshalBinary(data []byte) error](<#func-ecpoint-unmarshalbinary>)
  - [func (a *EcPoint) UnmarshalJSON(bytes []byte) error](<#func-ecpoint-unmarshaljson>)
- [type EcPointJson](<#type-ecpointjson>)
- [type EcScalar](<#type-ecscalar>)
- [type EcdsaSignature](<#type-ecdsasignature>)
- [type EcdsaVerify](<#type-ecdsaverify>)
- [type Ed25519Scalar](<#type-ed25519scalar>)
  - [func NewEd25519Scalar() *Ed25519Scalar](<#func-newed25519scalar>)
  - [func (k Ed25519Scalar) Add(x, y *big.Int) *big.Int](<#func-ed25519scalar-add>)
  - [func (k Ed25519Scalar) Bytes(x *big.Int) []byte](<#func-ed25519scalar-bytes>)
  - [func (k Ed25519Scalar) Div(x, y *big.Int) *big.Int](<#func-ed25519scalar-div>)
  - [func (k Ed25519Scalar) Hash(input []byte) *big.Int](<#func-ed25519scalar-hash>)
  - [func (k Ed25519Scalar) IsValid(x *big.Int) bool](<#func-ed25519scalar-isvalid>)
  - [func (k Ed25519Scalar) Mul(x, y *big.Int) *big.Int](<#func-ed25519scalar-mul>)
  - [func (k Ed25519Scalar) Neg(x *big.Int) *big.Int](<#func-ed25519scalar-neg>)
  - [func (k Ed25519Scalar) Random() (*big.Int, error)](<#func-ed25519scalar-random>)
  - [func (k Ed25519Scalar) RandomWithReader(r io.Reader) (*big.Int, error)](<#func-ed25519scalar-randomwithreader>)
  - [func (k Ed25519Scalar) Sub(x, y *big.Int) *big.Int](<#func-ed25519scalar-sub>)
- [type Element](<#type-element>)
  - [func (x Element) Add(y *Element) *Element](<#func-element-add>)
  - [func (x Element) BigInt() *big.Int](<#func-element-bigint>)
  - [func (x Element) Bytes() []byte](<#func-element-bytes>)
  - [func (x Element) Clone() *Element](<#func-element-clone>)
  - [func (x Element) Div(y *Element) *Element](<#func-element-div>)
  - [func (x Element) Field() *Field](<#func-element-field>)
  - [func (x Element) Invert() *Element](<#func-element-invert>)
  - [func (x Element) IsEqual(y *Element) bool](<#func-element-isequal>)
  - [func (x *Element) MarshalJSON() ([]byte, error)](<#func-element-marshaljson>)
  - [func (x Element) Mul(y *Element) *Element](<#func-element-mul>)
  - [func (x Element) Neg() *Element](<#func-element-neg>)
  - [func (x Element) Pow(y *Element) *Element](<#func-element-pow>)
  - [func (x Element) Sqrt() *Element](<#func-element-sqrt>)
  - [func (x Element) Sub(y *Element) *Element](<#func-element-sub>)
  - [func (x *Element) UnmarshalJSON(bytes []byte) error](<#func-element-unmarshaljson>)
- [type ElementJSON](<#type-elementjson>)
- [type Ep](<#type-ep>)
  - [func (p *Ep) Add(lhs *Ep, rhs *Ep) *Ep](<#func-ep-add>)
  - [func (p *Ep) CMove(lhs, rhs *Ep, condition int) *Ep](<#func-ep-cmove>)
  - [func (p Ep) CurveName() string](<#func-ep-curvename>)
  - [func (p *Ep) Double(other *Ep) *Ep](<#func-ep-double>)
  - [func (p *Ep) Equal(other *Ep) bool](<#func-ep-equal>)
  - [func (p *Ep) FromAffineCompressed(bytes []byte) (*Ep, error)](<#func-ep-fromaffinecompressed>)
  - [func (p *Ep) FromAffineUncompressed(bytes []byte) (*Ep, error)](<#func-ep-fromaffineuncompressed>)
  - [func (p *Ep) Generator() *Ep](<#func-ep-generator>)
  - [func (p *Ep) Hash(bytes []byte) *Ep](<#func-ep-hash>)
  - [func (p *Ep) Identity() *Ep](<#func-ep-identity>)
  - [func (p *Ep) IsIdentity() bool](<#func-ep-isidentity>)
  - [func (p *Ep) IsOnCurve() bool](<#func-ep-isoncurve>)
  - [func (p *Ep) Mul(point *Ep, scalar *fq.Fq) *Ep](<#func-ep-mul>)
  - [func (p *Ep) Neg(other *Ep) *Ep](<#func-ep-neg>)
  - [func (p *Ep) Random(reader io.Reader) *Ep](<#func-ep-random>)
  - [func (p *Ep) Set(other *Ep) *Ep](<#func-ep-set>)
  - [func (p *Ep) Sub(lhs, rhs *Ep) *Ep](<#func-ep-sub>)
  - [func (p Ep) SumOfProducts(points []*Ep, scalars []Scalar) *Ep](<#func-ep-sumofproducts>)
  - [func (p *Ep) ToAffineCompressed() []byte](<#func-ep-toaffinecompressed>)
  - [func (p *Ep) ToAffineUncompressed() []byte](<#func-ep-toaffineuncompressed>)
  - [func (p *Ep) X() *fp.Fp](<#func-ep-x>)
  - [func (p *Ep) Y() *fp.Fp](<#func-ep-y>)
- [type Field](<#type-field>)
  - [func NewField(modulus *big.Int) *Field](<#func-newfield>)
  - [func (f Field) ElementFromBytes(bytes []byte) *Element](<#func-field-elementfrombytes>)
  - [func (f Field) IsValid(value *big.Int) bool](<#func-field-isvalid>)
  - [func (f Field) NewElement(value *big.Int) *Element](<#func-field-newelement>)
  - [func (f Field) One() *Element](<#func-field-one>)
  - [func (f Field) RandomElement(r io.Reader) (*Element, error)](<#func-field-randomelement>)
  - [func (f Field) ReducedElementFromBytes(bytes []byte) *Element](<#func-field-reducedelementfrombytes>)
  - [func (f Field) Zero() *Element](<#func-field-zero>)
- [type K256Scalar](<#type-k256scalar>)
  - [func NewK256Scalar() *K256Scalar](<#func-newk256scalar>)
  - [func (k K256Scalar) Add(x, y *big.Int) *big.Int](<#func-k256scalar-add>)
  - [func (k K256Scalar) Bytes(x *big.Int) []byte](<#func-k256scalar-bytes>)
  - [func (k K256Scalar) Div(x, y *big.Int) *big.Int](<#func-k256scalar-div>)
  - [func (k K256Scalar) Hash(input []byte) *big.Int](<#func-k256scalar-hash>)
  - [func (k K256Scalar) IsValid(x *big.Int) bool](<#func-k256scalar-isvalid>)
  - [func (k K256Scalar) Mul(x, y *big.Int) *big.Int](<#func-k256scalar-mul>)
  - [func (k K256Scalar) Neg(x *big.Int) *big.Int](<#func-k256scalar-neg>)
  - [func (k K256Scalar) Random() (*big.Int, error)](<#func-k256scalar-random>)
  - [func (k K256Scalar) Sub(x, y *big.Int) *big.Int](<#func-k256scalar-sub>)
- [type P256Scalar](<#type-p256scalar>)
  - [func NewP256Scalar() *P256Scalar](<#func-newp256scalar>)
  - [func (k P256Scalar) Add(x, y *big.Int) *big.Int](<#func-p256scalar-add>)
  - [func (k P256Scalar) Bytes(x *big.Int) []byte](<#func-p256scalar-bytes>)
  - [func (k P256Scalar) Div(x, y *big.Int) *big.Int](<#func-p256scalar-div>)
  - [func (k P256Scalar) Hash(input []byte) *big.Int](<#func-p256scalar-hash>)
  - [func (k P256Scalar) IsValid(x *big.Int) bool](<#func-p256scalar-isvalid>)
  - [func (k P256Scalar) Mul(x, y *big.Int) *big.Int](<#func-p256scalar-mul>)
  - [func (k P256Scalar) Neg(x *big.Int) *big.Int](<#func-p256scalar-neg>)
  - [func (k P256Scalar) Random() (*big.Int, error)](<#func-p256scalar-random>)
  - [func (k P256Scalar) Sub(x, y *big.Int) *big.Int](<#func-p256scalar-sub>)
- [type PairingCurve](<#type-pairingcurve>)
  - [func BLS12381(preferredPoint Point) *PairingCurve](<#func-bls12381>)
  - [func GetPairingCurveByName(name string) *PairingCurve](<#func-getpairingcurvebyname>)
  - [func (c PairingCurve) NewG1GeneratorPoint() PairingPoint](<#func-pairingcurve-newg1generatorpoint>)
  - [func (c PairingCurve) NewG1IdentityPoint() PairingPoint](<#func-pairingcurve-newg1identitypoint>)
  - [func (c PairingCurve) NewG2GeneratorPoint() PairingPoint](<#func-pairingcurve-newg2generatorpoint>)
  - [func (c PairingCurve) NewG2IdentityPoint() PairingPoint](<#func-pairingcurve-newg2identitypoint>)
  - [func (c PairingCurve) NewScalar() PairingScalar](<#func-pairingcurve-newscalar>)
  - [func (c PairingCurve) ScalarG1BaseMult(sc Scalar) PairingPoint](<#func-pairingcurve-scalarg1basemult>)
  - [func (c PairingCurve) ScalarG2BaseMult(sc Scalar) PairingPoint](<#func-pairingcurve-scalarg2basemult>)
- [type PairingPoint](<#type-pairingpoint>)
- [type PairingScalar](<#type-pairingscalar>)
- [type PallasCurve](<#type-pallascurve>)
  - [func Pallas() *PallasCurve](<#func-pallas>)
  - [func (curve *PallasCurve) Add(x1, y1, x2, y2 *big.Int) (*big.Int, *big.Int)](<#func-pallascurve-add>)
  - [func (curve *PallasCurve) Double(x1, y1 *big.Int) (*big.Int, *big.Int)](<#func-pallascurve-double>)
  - [func (curve *PallasCurve) IsOnCurve(x, y *big.Int) bool](<#func-pallascurve-isoncurve>)
  - [func (curve *PallasCurve) Params() *elliptic.CurveParams](<#func-pallascurve-params>)
  - [func (curve *PallasCurve) ScalarBaseMult(k []byte) (*big.Int, *big.Int)](<#func-pallascurve-scalarbasemult>)
  - [func (curve *PallasCurve) ScalarMult(Bx, By *big.Int, k []byte) (*big.Int, *big.Int)](<#func-pallascurve-scalarmult>)
- [type PallasScalar](<#type-pallasscalar>)
  - [func NewPallasScalar() *PallasScalar](<#func-newpallasscalar>)
  - [func (k PallasScalar) Add(x, y *big.Int) *big.Int](<#func-pallasscalar-add>)
  - [func (k PallasScalar) Bytes(x *big.Int) []byte](<#func-pallasscalar-bytes>)
  - [func (k PallasScalar) Div(x, y *big.Int) *big.Int](<#func-pallasscalar-div>)
  - [func (k PallasScalar) Hash(input []byte) *big.Int](<#func-pallasscalar-hash>)
  - [func (k PallasScalar) IsValid(x *big.Int) bool](<#func-pallasscalar-isvalid>)
  - [func (k PallasScalar) Mul(x, y *big.Int) *big.Int](<#func-pallasscalar-mul>)
  - [func (k PallasScalar) Neg(x *big.Int) *big.Int](<#func-pallasscalar-neg>)
  - [func (k PallasScalar) Random() (*big.Int, error)](<#func-pallasscalar-random>)
  - [func (k PallasScalar) Sub(x, y *big.Int) *big.Int](<#func-pallasscalar-sub>)
- [type Point](<#type-point>)
- [type PointBls12377G1](<#type-pointbls12377g1>)
  - [func (p *PointBls12377G1) Add(rhs Point) Point](<#func-pointbls12377g1-add>)
  - [func (p *PointBls12377G1) CurveName() string](<#func-pointbls12377g1-curvename>)
  - [func (p *PointBls12377G1) Double() Point](<#func-pointbls12377g1-double>)
  - [func (p *PointBls12377G1) Equal(rhs Point) bool](<#func-pointbls12377g1-equal>)
  - [func (p *PointBls12377G1) FromAffineCompressed(bytes []byte) (Point, error)](<#func-pointbls12377g1-fromaffinecompressed>)
  - [func (p *PointBls12377G1) FromAffineUncompressed(bytes []byte) (Point, error)](<#func-pointbls12377g1-fromaffineuncompressed>)
  - [func (p *PointBls12377G1) Generator() Point](<#func-pointbls12377g1-generator>)
  - [func (p *PointBls12377G1) Hash(bytes []byte) Point](<#func-pointbls12377g1-hash>)
  - [func (p *PointBls12377G1) Identity() Point](<#func-pointbls12377g1-identity>)
  - [func (p *PointBls12377G1) IsIdentity() bool](<#func-pointbls12377g1-isidentity>)
  - [func (p *PointBls12377G1) IsNegative() bool](<#func-pointbls12377g1-isnegative>)
  - [func (p *PointBls12377G1) IsOnCurve() bool](<#func-pointbls12377g1-isoncurve>)
  - [func (p *PointBls12377G1) MarshalBinary() ([]byte, error)](<#func-pointbls12377g1-marshalbinary>)
  - [func (p *PointBls12377G1) MarshalJSON() ([]byte, error)](<#func-pointbls12377g1-marshaljson>)
  - [func (p *PointBls12377G1) MarshalText() ([]byte, error)](<#func-pointbls12377g1-marshaltext>)
  - [func (p *PointBls12377G1) Modulus() *big.Int](<#func-pointbls12377g1-modulus>)
  - [func (p *PointBls12377G1) Mul(rhs Scalar) Point](<#func-pointbls12377g1-mul>)
  - [func (p *PointBls12377G1) MultiPairing(points ...PairingPoint) Scalar](<#func-pointbls12377g1-multipairing>)
  - [func (p *PointBls12377G1) Neg() Point](<#func-pointbls12377g1-neg>)
  - [func (p *PointBls12377G1) OtherGroup() PairingPoint](<#func-pointbls12377g1-othergroup>)
  - [func (p *PointBls12377G1) Pairing(rhs PairingPoint) Scalar](<#func-pointbls12377g1-pairing>)
  - [func (p *PointBls12377G1) Random(reader io.Reader) Point](<#func-pointbls12377g1-random>)
  - [func (p *PointBls12377G1) Scalar() Scalar](<#func-pointbls12377g1-scalar>)
  - [func (p *PointBls12377G1) Set(x, y *big.Int) (Point, error)](<#func-pointbls12377g1-set>)
  - [func (p *PointBls12377G1) Sub(rhs Point) Point](<#func-pointbls12377g1-sub>)
  - [func (p *PointBls12377G1) SumOfProducts(points []Point, scalars []Scalar) Point](<#func-pointbls12377g1-sumofproducts>)
  - [func (p *PointBls12377G1) ToAffineCompressed() []byte](<#func-pointbls12377g1-toaffinecompressed>)
  - [func (p *PointBls12377G1) ToAffineUncompressed() []byte](<#func-pointbls12377g1-toaffineuncompressed>)
  - [func (p *PointBls12377G1) UnmarshalBinary(input []byte) error](<#func-pointbls12377g1-unmarshalbinary>)
  - [func (p *PointBls12377G1) UnmarshalJSON(input []byte) error](<#func-pointbls12377g1-unmarshaljson>)
  - [func (p *PointBls12377G1) UnmarshalText(input []byte) error](<#func-pointbls12377g1-unmarshaltext>)
  - [func (p *PointBls12377G1) X() *big.Int](<#func-pointbls12377g1-x>)
  - [func (p *PointBls12377G1) Y() *big.Int](<#func-pointbls12377g1-y>)
- [type PointBls12377G2](<#type-pointbls12377g2>)
  - [func (p *PointBls12377G2) Add(rhs Point) Point](<#func-pointbls12377g2-add>)
  - [func (p *PointBls12377G2) CurveName() string](<#func-pointbls12377g2-curvename>)
  - [func (p *PointBls12377G2) Double() Point](<#func-pointbls12377g2-double>)
  - [func (p *PointBls12377G2) Equal(rhs Point) bool](<#func-pointbls12377g2-equal>)
  - [func (p *PointBls12377G2) FromAffineCompressed(bytes []byte) (Point, error)](<#func-pointbls12377g2-fromaffinecompressed>)
  - [func (p *PointBls12377G2) FromAffineUncompressed(bytes []byte) (Point, error)](<#func-pointbls12377g2-fromaffineuncompressed>)
  - [func (p *PointBls12377G2) Generator() Point](<#func-pointbls12377g2-generator>)
  - [func (p *PointBls12377G2) Hash(bytes []byte) Point](<#func-pointbls12377g2-hash>)
  - [func (p *PointBls12377G2) Identity() Point](<#func-pointbls12377g2-identity>)
  - [func (p *PointBls12377G2) IsIdentity() bool](<#func-pointbls12377g2-isidentity>)
  - [func (p *PointBls12377G2) IsNegative() bool](<#func-pointbls12377g2-isnegative>)
  - [func (p *PointBls12377G2) IsOnCurve() bool](<#func-pointbls12377g2-isoncurve>)
  - [func (p *PointBls12377G2) MarshalBinary() ([]byte, error)](<#func-pointbls12377g2-marshalbinary>)
  - [func (p *PointBls12377G2) MarshalJSON() ([]byte, error)](<#func-pointbls12377g2-marshaljson>)
  - [func (p *PointBls12377G2) MarshalText() ([]byte, error)](<#func-pointbls12377g2-marshaltext>)
  - [func (p *PointBls12377G2) Modulus() *big.Int](<#func-pointbls12377g2-modulus>)
  - [func (p *PointBls12377G2) Mul(rhs Scalar) Point](<#func-pointbls12377g2-mul>)
  - [func (p *PointBls12377G2) MultiPairing(points ...PairingPoint) Scalar](<#func-pointbls12377g2-multipairing>)
  - [func (p *PointBls12377G2) Neg() Point](<#func-pointbls12377g2-neg>)
  - [func (p *PointBls12377G2) OtherGroup() PairingPoint](<#func-pointbls12377g2-othergroup>)
  - [func (p *PointBls12377G2) Pairing(rhs PairingPoint) Scalar](<#func-pointbls12377g2-pairing>)
  - [func (p *PointBls12377G2) Random(reader io.Reader) Point](<#func-pointbls12377g2-random>)
  - [func (p *PointBls12377G2) Scalar() Scalar](<#func-pointbls12377g2-scalar>)
  - [func (p *PointBls12377G2) Set(x, y *big.Int) (Point, error)](<#func-pointbls12377g2-set>)
  - [func (p *PointBls12377G2) Sub(rhs Point) Point](<#func-pointbls12377g2-sub>)
  - [func (p *PointBls12377G2) SumOfProducts(points []Point, scalars []Scalar) Point](<#func-pointbls12377g2-sumofproducts>)
  - [func (p *PointBls12377G2) ToAffineCompressed() []byte](<#func-pointbls12377g2-toaffinecompressed>)
  - [func (p *PointBls12377G2) ToAffineUncompressed() []byte](<#func-pointbls12377g2-toaffineuncompressed>)
  - [func (p *PointBls12377G2) UnmarshalBinary(input []byte) error](<#func-pointbls12377g2-unmarshalbinary>)
  - [func (p *PointBls12377G2) UnmarshalJSON(input []byte) error](<#func-pointbls12377g2-unmarshaljson>)
  - [func (p *PointBls12377G2) UnmarshalText(input []byte) error](<#func-pointbls12377g2-unmarshaltext>)
  - [func (p *PointBls12377G2) X() *big.Int](<#func-pointbls12377g2-x>)
  - [func (p *PointBls12377G2) Y() *big.Int](<#func-pointbls12377g2-y>)
- [type PointBls12381G1](<#type-pointbls12381g1>)
  - [func (p *PointBls12381G1) Add(rhs Point) Point](<#func-pointbls12381g1-add>)
  - [func (p *PointBls12381G1) CurveName() string](<#func-pointbls12381g1-curvename>)
  - [func (p *PointBls12381G1) Double() Point](<#func-pointbls12381g1-double>)
  - [func (p *PointBls12381G1) Equal(rhs Point) bool](<#func-pointbls12381g1-equal>)
  - [func (p *PointBls12381G1) FromAffineCompressed(bytes []byte) (Point, error)](<#func-pointbls12381g1-fromaffinecompressed>)
  - [func (p *PointBls12381G1) FromAffineUncompressed(bytes []byte) (Point, error)](<#func-pointbls12381g1-fromaffineuncompressed>)
  - [func (p *PointBls12381G1) Generator() Point](<#func-pointbls12381g1-generator>)
  - [func (p *PointBls12381G1) Hash(bytes []byte) Point](<#func-pointbls12381g1-hash>)
  - [func (p *PointBls12381G1) Identity() Point](<#func-pointbls12381g1-identity>)
  - [func (p *PointBls12381G1) IsIdentity() bool](<#func-pointbls12381g1-isidentity>)
  - [func (p *PointBls12381G1) IsNegative() bool](<#func-pointbls12381g1-isnegative>)
  - [func (p *PointBls12381G1) IsOnCurve() bool](<#func-pointbls12381g1-isoncurve>)
  - [func (p *PointBls12381G1) MarshalBinary() ([]byte, error)](<#func-pointbls12381g1-marshalbinary>)
  - [func (p *PointBls12381G1) MarshalJSON() ([]byte, error)](<#func-pointbls12381g1-marshaljson>)
  - [func (p *PointBls12381G1) MarshalText() ([]byte, error)](<#func-pointbls12381g1-marshaltext>)
  - [func (p *PointBls12381G1) Modulus() *big.Int](<#func-pointbls12381g1-modulus>)
  - [func (p *PointBls12381G1) Mul(rhs Scalar) Point](<#func-pointbls12381g1-mul>)
  - [func (p *PointBls12381G1) MultiPairing(points ...PairingPoint) Scalar](<#func-pointbls12381g1-multipairing>)
  - [func (p *PointBls12381G1) Neg() Point](<#func-pointbls12381g1-neg>)
  - [func (p *PointBls12381G1) OtherGroup() PairingPoint](<#func-pointbls12381g1-othergroup>)
  - [func (p *PointBls12381G1) Pairing(rhs PairingPoint) Scalar](<#func-pointbls12381g1-pairing>)
  - [func (p *PointBls12381G1) Random(reader io.Reader) Point](<#func-pointbls12381g1-random>)
  - [func (p *PointBls12381G1) Scalar() Scalar](<#func-pointbls12381g1-scalar>)
  - [func (p *PointBls12381G1) Set(x, y *big.Int) (Point, error)](<#func-pointbls12381g1-set>)
  - [func (p *PointBls12381G1) Sub(rhs Point) Point](<#func-pointbls12381g1-sub>)
  - [func (p *PointBls12381G1) SumOfProducts(points []Point, scalars []Scalar) Point](<#func-pointbls12381g1-sumofproducts>)
  - [func (p *PointBls12381G1) ToAffineCompressed() []byte](<#func-pointbls12381g1-toaffinecompressed>)
  - [func (p *PointBls12381G1) ToAffineUncompressed() []byte](<#func-pointbls12381g1-toaffineuncompressed>)
  - [func (p *PointBls12381G1) UnmarshalBinary(input []byte) error](<#func-pointbls12381g1-unmarshalbinary>)
  - [func (p *PointBls12381G1) UnmarshalJSON(input []byte) error](<#func-pointbls12381g1-unmarshaljson>)
  - [func (p *PointBls12381G1) UnmarshalText(input []byte) error](<#func-pointbls12381g1-unmarshaltext>)
  - [func (p *PointBls12381G1) X() *big.Int](<#func-pointbls12381g1-x>)
  - [func (p *PointBls12381G1) Y() *big.Int](<#func-pointbls12381g1-y>)
- [type PointBls12381G2](<#type-pointbls12381g2>)
  - [func (p *PointBls12381G2) Add(rhs Point) Point](<#func-pointbls12381g2-add>)
  - [func (p *PointBls12381G2) CurveName() string](<#func-pointbls12381g2-curvename>)
  - [func (p *PointBls12381G2) Double() Point](<#func-pointbls12381g2-double>)
  - [func (p *PointBls12381G2) Equal(rhs Point) bool](<#func-pointbls12381g2-equal>)
  - [func (p *PointBls12381G2) FromAffineCompressed(bytes []byte) (Point, error)](<#func-pointbls12381g2-fromaffinecompressed>)
  - [func (p *PointBls12381G2) FromAffineUncompressed(bytes []byte) (Point, error)](<#func-pointbls12381g2-fromaffineuncompressed>)
  - [func (p *PointBls12381G2) Generator() Point](<#func-pointbls12381g2-generator>)
  - [func (p *PointBls12381G2) Hash(bytes []byte) Point](<#func-pointbls12381g2-hash>)
  - [func (p *PointBls12381G2) Identity() Point](<#func-pointbls12381g2-identity>)
  - [func (p *PointBls12381G2) IsIdentity() bool](<#func-pointbls12381g2-isidentity>)
  - [func (p *PointBls12381G2) IsNegative() bool](<#func-pointbls12381g2-isnegative>)
  - [func (p *PointBls12381G2) IsOnCurve() bool](<#func-pointbls12381g2-isoncurve>)
  - [func (p *PointBls12381G2) MarshalBinary() ([]byte, error)](<#func-pointbls12381g2-marshalbinary>)
  - [func (p *PointBls12381G2) MarshalJSON() ([]byte, error)](<#func-pointbls12381g2-marshaljson>)
  - [func (p *PointBls12381G2) MarshalText() ([]byte, error)](<#func-pointbls12381g2-marshaltext>)
  - [func (p *PointBls12381G2) Modulus() *big.Int](<#func-pointbls12381g2-modulus>)
  - [func (p *PointBls12381G2) Mul(rhs Scalar) Point](<#func-pointbls12381g2-mul>)
  - [func (p *PointBls12381G2) MultiPairing(points ...PairingPoint) Scalar](<#func-pointbls12381g2-multipairing>)
  - [func (p *PointBls12381G2) Neg() Point](<#func-pointbls12381g2-neg>)
  - [func (p *PointBls12381G2) OtherGroup() PairingPoint](<#func-pointbls12381g2-othergroup>)
  - [func (p *PointBls12381G2) Pairing(rhs PairingPoint) Scalar](<#func-pointbls12381g2-pairing>)
  - [func (p *PointBls12381G2) Random(reader io.Reader) Point](<#func-pointbls12381g2-random>)
  - [func (p *PointBls12381G2) Scalar() Scalar](<#func-pointbls12381g2-scalar>)
  - [func (p *PointBls12381G2) Set(x, y *big.Int) (Point, error)](<#func-pointbls12381g2-set>)
  - [func (p *PointBls12381G2) Sub(rhs Point) Point](<#func-pointbls12381g2-sub>)
  - [func (p *PointBls12381G2) SumOfProducts(points []Point, scalars []Scalar) Point](<#func-pointbls12381g2-sumofproducts>)
  - [func (p *PointBls12381G2) ToAffineCompressed() []byte](<#func-pointbls12381g2-toaffinecompressed>)
  - [func (p *PointBls12381G2) ToAffineUncompressed() []byte](<#func-pointbls12381g2-toaffineuncompressed>)
  - [func (p *PointBls12381G2) UnmarshalBinary(input []byte) error](<#func-pointbls12381g2-unmarshalbinary>)
  - [func (p *PointBls12381G2) UnmarshalJSON(input []byte) error](<#func-pointbls12381g2-unmarshaljson>)
  - [func (p *PointBls12381G2) UnmarshalText(input []byte) error](<#func-pointbls12381g2-unmarshaltext>)
  - [func (p *PointBls12381G2) X() *big.Int](<#func-pointbls12381g2-x>)
  - [func (p *PointBls12381G2) Y() *big.Int](<#func-pointbls12381g2-y>)
- [type PointEd25519](<#type-pointed25519>)
  - [func (p *PointEd25519) Add(rhs Point) Point](<#func-pointed25519-add>)
  - [func (p *PointEd25519) CurveName() string](<#func-pointed25519-curvename>)
  - [func (p *PointEd25519) Double() Point](<#func-pointed25519-double>)
  - [func (p *PointEd25519) Equal(rhs Point) bool](<#func-pointed25519-equal>)
  - [func (p *PointEd25519) FromAffineCompressed(inBytes []byte) (Point, error)](<#func-pointed25519-fromaffinecompressed>)
  - [func (p *PointEd25519) FromAffineUncompressed(inBytes []byte) (Point, error)](<#func-pointed25519-fromaffineuncompressed>)
  - [func (p *PointEd25519) Generator() Point](<#func-pointed25519-generator>)
  - [func (p *PointEd25519) GetEdwardsPoint() *edwards25519.Point](<#func-pointed25519-getedwardspoint>)
  - [func (p *PointEd25519) Hash(bytes []byte) Point](<#func-pointed25519-hash>)
  - [func (p *PointEd25519) Identity() Point](<#func-pointed25519-identity>)
  - [func (p *PointEd25519) IsIdentity() bool](<#func-pointed25519-isidentity>)
  - [func (p *PointEd25519) IsNegative() bool](<#func-pointed25519-isnegative>)
  - [func (p *PointEd25519) IsOnCurve() bool](<#func-pointed25519-isoncurve>)
  - [func (p *PointEd25519) MangleScalarBitsAndMulByBasepointToProducePublicKey(rhs *ScalarEd25519) *PointEd25519](<#func-pointed25519-manglescalarbitsandmulbybasepointtoproducepublickey>)
  - [func (p *PointEd25519) MarshalBinary() ([]byte, error)](<#func-pointed25519-marshalbinary>)
  - [func (p *PointEd25519) MarshalJSON() ([]byte, error)](<#func-pointed25519-marshaljson>)
  - [func (p *PointEd25519) MarshalText() ([]byte, error)](<#func-pointed25519-marshaltext>)
  - [func (p *PointEd25519) Mul(rhs Scalar) Point](<#func-pointed25519-mul>)
  - [func (p *PointEd25519) Neg() Point](<#func-pointed25519-neg>)
  - [func (p *PointEd25519) Random(reader io.Reader) Point](<#func-pointed25519-random>)
  - [func (p *PointEd25519) Scalar() Scalar](<#func-pointed25519-scalar>)
  - [func (p *PointEd25519) Set(x, y *big.Int) (Point, error)](<#func-pointed25519-set>)
  - [func (p *PointEd25519) SetEdwardsPoint(pt *edwards25519.Point) *PointEd25519](<#func-pointed25519-setedwardspoint>)
  - [func (p *PointEd25519) Sub(rhs Point) Point](<#func-pointed25519-sub>)
  - [func (p *PointEd25519) SumOfProducts(points []Point, scalars []Scalar) Point](<#func-pointed25519-sumofproducts>)
  - [func (p *PointEd25519) ToAffineCompressed() []byte](<#func-pointed25519-toaffinecompressed>)
  - [func (p *PointEd25519) ToAffineUncompressed() []byte](<#func-pointed25519-toaffineuncompressed>)
  - [func (p *PointEd25519) UnmarshalBinary(input []byte) error](<#func-pointed25519-unmarshalbinary>)
  - [func (p *PointEd25519) UnmarshalJSON(input []byte) error](<#func-pointed25519-unmarshaljson>)
  - [func (p *PointEd25519) UnmarshalText(input []byte) error](<#func-pointed25519-unmarshaltext>)
  - [func (p *PointEd25519) VarTimeDoubleScalarBaseMult(a Scalar, A Point, b Scalar) Point](<#func-pointed25519-vartimedoublescalarbasemult>)
- [type PointK256](<#type-pointk256>)
  - [func (p *PointK256) Add(rhs Point) Point](<#func-pointk256-add>)
  - [func (p *PointK256) CurveName() string](<#func-pointk256-curvename>)
  - [func (p *PointK256) Double() Point](<#func-pointk256-double>)
  - [func (p *PointK256) Equal(rhs Point) bool](<#func-pointk256-equal>)
  - [func (p *PointK256) FromAffineCompressed(bytes []byte) (Point, error)](<#func-pointk256-fromaffinecompressed>)
  - [func (p *PointK256) FromAffineUncompressed(bytes []byte) (Point, error)](<#func-pointk256-fromaffineuncompressed>)
  - [func (p *PointK256) Generator() Point](<#func-pointk256-generator>)
  - [func (p *PointK256) Hash(bytes []byte) Point](<#func-pointk256-hash>)
  - [func (p *PointK256) Identity() Point](<#func-pointk256-identity>)
  - [func (p *PointK256) IsIdentity() bool](<#func-pointk256-isidentity>)
  - [func (p *PointK256) IsNegative() bool](<#func-pointk256-isnegative>)
  - [func (p *PointK256) IsOnCurve() bool](<#func-pointk256-isoncurve>)
  - [func (p *PointK256) MarshalBinary() ([]byte, error)](<#func-pointk256-marshalbinary>)
  - [func (p *PointK256) MarshalJSON() ([]byte, error)](<#func-pointk256-marshaljson>)
  - [func (p *PointK256) MarshalText() ([]byte, error)](<#func-pointk256-marshaltext>)
  - [func (p *PointK256) Mul(rhs Scalar) Point](<#func-pointk256-mul>)
  - [func (p *PointK256) Neg() Point](<#func-pointk256-neg>)
  - [func (p *PointK256) Params() *elliptic.CurveParams](<#func-pointk256-params>)
  - [func (p *PointK256) Random(reader io.Reader) Point](<#func-pointk256-random>)
  - [func (p *PointK256) Scalar() Scalar](<#func-pointk256-scalar>)
  - [func (p *PointK256) Set(x, y *big.Int) (Point, error)](<#func-pointk256-set>)
  - [func (p *PointK256) Sub(rhs Point) Point](<#func-pointk256-sub>)
  - [func (p *PointK256) SumOfProducts(points []Point, scalars []Scalar) Point](<#func-pointk256-sumofproducts>)
  - [func (p *PointK256) ToAffineCompressed() []byte](<#func-pointk256-toaffinecompressed>)
  - [func (p *PointK256) ToAffineUncompressed() []byte](<#func-pointk256-toaffineuncompressed>)
  - [func (p *PointK256) UnmarshalBinary(input []byte) error](<#func-pointk256-unmarshalbinary>)
  - [func (p *PointK256) UnmarshalJSON(input []byte) error](<#func-pointk256-unmarshaljson>)
  - [func (p *PointK256) UnmarshalText(input []byte) error](<#func-pointk256-unmarshaltext>)
  - [func (p *PointK256) X() *big.Int](<#func-pointk256-x>)
  - [func (p *PointK256) Y() *big.Int](<#func-pointk256-y>)
- [type PointP256](<#type-pointp256>)
  - [func (p *PointP256) Add(rhs Point) Point](<#func-pointp256-add>)
  - [func (p *PointP256) CurveName() string](<#func-pointp256-curvename>)
  - [func (p *PointP256) Double() Point](<#func-pointp256-double>)
  - [func (p *PointP256) Equal(rhs Point) bool](<#func-pointp256-equal>)
  - [func (p *PointP256) FromAffineCompressed(bytes []byte) (Point, error)](<#func-pointp256-fromaffinecompressed>)
  - [func (p *PointP256) FromAffineUncompressed(bytes []byte) (Point, error)](<#func-pointp256-fromaffineuncompressed>)
  - [func (p *PointP256) Generator() Point](<#func-pointp256-generator>)
  - [func (p *PointP256) Hash(bytes []byte) Point](<#func-pointp256-hash>)
  - [func (p *PointP256) Identity() Point](<#func-pointp256-identity>)
  - [func (p *PointP256) IsIdentity() bool](<#func-pointp256-isidentity>)
  - [func (p *PointP256) IsNegative() bool](<#func-pointp256-isnegative>)
  - [func (p *PointP256) IsOnCurve() bool](<#func-pointp256-isoncurve>)
  - [func (p *PointP256) MarshalBinary() ([]byte, error)](<#func-pointp256-marshalbinary>)
  - [func (p *PointP256) MarshalJSON() ([]byte, error)](<#func-pointp256-marshaljson>)
  - [func (p *PointP256) MarshalText() ([]byte, error)](<#func-pointp256-marshaltext>)
  - [func (p *PointP256) Mul(rhs Scalar) Point](<#func-pointp256-mul>)
  - [func (p *PointP256) Neg() Point](<#func-pointp256-neg>)
  - [func (p *PointP256) Params() *elliptic.CurveParams](<#func-pointp256-params>)
  - [func (p *PointP256) Random(reader io.Reader) Point](<#func-pointp256-random>)
  - [func (p *PointP256) Scalar() Scalar](<#func-pointp256-scalar>)
  - [func (p *PointP256) Set(x, y *big.Int) (Point, error)](<#func-pointp256-set>)
  - [func (p *PointP256) Sub(rhs Point) Point](<#func-pointp256-sub>)
  - [func (p *PointP256) SumOfProducts(points []Point, scalars []Scalar) Point](<#func-pointp256-sumofproducts>)
  - [func (p *PointP256) ToAffineCompressed() []byte](<#func-pointp256-toaffinecompressed>)
  - [func (p *PointP256) ToAffineUncompressed() []byte](<#func-pointp256-toaffineuncompressed>)
  - [func (p *PointP256) UnmarshalBinary(input []byte) error](<#func-pointp256-unmarshalbinary>)
  - [func (p *PointP256) UnmarshalJSON(input []byte) error](<#func-pointp256-unmarshaljson>)
  - [func (p *PointP256) UnmarshalText(input []byte) error](<#func-pointp256-unmarshaltext>)
  - [func (p *PointP256) X() *big.Int](<#func-pointp256-x>)
  - [func (p *PointP256) Y() *big.Int](<#func-pointp256-y>)
- [type PointPallas](<#type-pointpallas>)
  - [func (p *PointPallas) Add(rhs Point) Point](<#func-pointpallas-add>)
  - [func (p *PointPallas) CurveName() string](<#func-pointpallas-curvename>)
  - [func (p *PointPallas) Double() Point](<#func-pointpallas-double>)
  - [func (p *PointPallas) Equal(rhs Point) bool](<#func-pointpallas-equal>)
  - [func (p *PointPallas) FromAffineCompressed(bytes []byte) (Point, error)](<#func-pointpallas-fromaffinecompressed>)
  - [func (p *PointPallas) FromAffineUncompressed(bytes []byte) (Point, error)](<#func-pointpallas-fromaffineuncompressed>)
  - [func (p *PointPallas) Generator() Point](<#func-pointpallas-generator>)
  - [func (p *PointPallas) GetEp() *Ep](<#func-pointpallas-getep>)
  - [func (p *PointPallas) Hash(bytes []byte) Point](<#func-pointpallas-hash>)
  - [func (p *PointPallas) Identity() Point](<#func-pointpallas-identity>)
  - [func (p *PointPallas) IsIdentity() bool](<#func-pointpallas-isidentity>)
  - [func (p *PointPallas) IsNegative() bool](<#func-pointpallas-isnegative>)
  - [func (p *PointPallas) IsOnCurve() bool](<#func-pointpallas-isoncurve>)
  - [func (p *PointPallas) MarshalBinary() ([]byte, error)](<#func-pointpallas-marshalbinary>)
  - [func (p *PointPallas) MarshalJSON() ([]byte, error)](<#func-pointpallas-marshaljson>)
  - [func (p *PointPallas) MarshalText() ([]byte, error)](<#func-pointpallas-marshaltext>)
  - [func (p *PointPallas) Mul(rhs Scalar) Point](<#func-pointpallas-mul>)
  - [func (p *PointPallas) Neg() Point](<#func-pointpallas-neg>)
  - [func (p *PointPallas) Random(reader io.Reader) Point](<#func-pointpallas-random>)
  - [func (p *PointPallas) Scalar() Scalar](<#func-pointpallas-scalar>)
  - [func (p *PointPallas) Set(x, y *big.Int) (Point, error)](<#func-pointpallas-set>)
  - [func (p *PointPallas) Sub(rhs Point) Point](<#func-pointpallas-sub>)
  - [func (p *PointPallas) SumOfProducts(points []Point, scalars []Scalar) Point](<#func-pointpallas-sumofproducts>)
  - [func (p *PointPallas) ToAffineCompressed() []byte](<#func-pointpallas-toaffinecompressed>)
  - [func (p *PointPallas) ToAffineUncompressed() []byte](<#func-pointpallas-toaffineuncompressed>)
  - [func (p *PointPallas) UnmarshalBinary(input []byte) error](<#func-pointpallas-unmarshalbinary>)
  - [func (p *PointPallas) UnmarshalJSON(input []byte) error](<#func-pointpallas-unmarshaljson>)
  - [func (p *PointPallas) UnmarshalText(input []byte) error](<#func-pointpallas-unmarshaltext>)
  - [func (p *PointPallas) X() *fp.Fp](<#func-pointpallas-x>)
  - [func (p *PointPallas) Y() *fp.Fp](<#func-pointpallas-y>)
- [type Scalar](<#type-scalar>)
- [type ScalarBls12377](<#type-scalarbls12377>)
  - [func (s *ScalarBls12377) Add(rhs Scalar) Scalar](<#func-scalarbls12377-add>)
  - [func (s *ScalarBls12377) BigInt() *big.Int](<#func-scalarbls12377-bigint>)
  - [func (s *ScalarBls12377) Bytes() []byte](<#func-scalarbls12377-bytes>)
  - [func (s *ScalarBls12377) Clone() Scalar](<#func-scalarbls12377-clone>)
  - [func (s *ScalarBls12377) Cmp(rhs Scalar) int](<#func-scalarbls12377-cmp>)
  - [func (s *ScalarBls12377) Cube() Scalar](<#func-scalarbls12377-cube>)
  - [func (s *ScalarBls12377) Div(rhs Scalar) Scalar](<#func-scalarbls12377-div>)
  - [func (s *ScalarBls12377) Double() Scalar](<#func-scalarbls12377-double>)
  - [func (s *ScalarBls12377) Hash(bytes []byte) Scalar](<#func-scalarbls12377-hash>)
  - [func (s *ScalarBls12377) Invert() (Scalar, error)](<#func-scalarbls12377-invert>)
  - [func (s *ScalarBls12377) IsEven() bool](<#func-scalarbls12377-iseven>)
  - [func (s *ScalarBls12377) IsOdd() bool](<#func-scalarbls12377-isodd>)
  - [func (s *ScalarBls12377) IsOne() bool](<#func-scalarbls12377-isone>)
  - [func (s *ScalarBls12377) IsZero() bool](<#func-scalarbls12377-iszero>)
  - [func (s *ScalarBls12377) MarshalBinary() ([]byte, error)](<#func-scalarbls12377-marshalbinary>)
  - [func (s *ScalarBls12377) MarshalJSON() ([]byte, error)](<#func-scalarbls12377-marshaljson>)
  - [func (s *ScalarBls12377) MarshalText() ([]byte, error)](<#func-scalarbls12377-marshaltext>)
  - [func (s *ScalarBls12377) Mul(rhs Scalar) Scalar](<#func-scalarbls12377-mul>)
  - [func (s *ScalarBls12377) MulAdd(y, z Scalar) Scalar](<#func-scalarbls12377-muladd>)
  - [func (s *ScalarBls12377) Neg() Scalar](<#func-scalarbls12377-neg>)
  - [func (s *ScalarBls12377) New(value int) Scalar](<#func-scalarbls12377-new>)
  - [func (s *ScalarBls12377) One() Scalar](<#func-scalarbls12377-one>)
  - [func (s *ScalarBls12377) Order() *big.Int](<#func-scalarbls12377-order>)
  - [func (s *ScalarBls12377) Point() Point](<#func-scalarbls12377-point>)
  - [func (s *ScalarBls12377) Random(reader io.Reader) Scalar](<#func-scalarbls12377-random>)
  - [func (s *ScalarBls12377) SetBigInt(v *big.Int) (Scalar, error)](<#func-scalarbls12377-setbigint>)
  - [func (s *ScalarBls12377) SetBytes(bytes []byte) (Scalar, error)](<#func-scalarbls12377-setbytes>)
  - [func (s *ScalarBls12377) SetBytesWide(bytes []byte) (Scalar, error)](<#func-scalarbls12377-setbyteswide>)
  - [func (s *ScalarBls12377) SetPoint(p Point) PairingScalar](<#func-scalarbls12377-setpoint>)
  - [func (s *ScalarBls12377) Sqrt() (Scalar, error)](<#func-scalarbls12377-sqrt>)
  - [func (s *ScalarBls12377) Square() Scalar](<#func-scalarbls12377-square>)
  - [func (s *ScalarBls12377) Sub(rhs Scalar) Scalar](<#func-scalarbls12377-sub>)
  - [func (s *ScalarBls12377) UnmarshalBinary(input []byte) error](<#func-scalarbls12377-unmarshalbinary>)
  - [func (s *ScalarBls12377) UnmarshalJSON(input []byte) error](<#func-scalarbls12377-unmarshaljson>)
  - [func (s *ScalarBls12377) UnmarshalText(input []byte) error](<#func-scalarbls12377-unmarshaltext>)
  - [func (s *ScalarBls12377) Zero() Scalar](<#func-scalarbls12377-zero>)
- [type ScalarBls12377Gt](<#type-scalarbls12377gt>)
  - [func (s *ScalarBls12377Gt) Add(rhs Scalar) Scalar](<#func-scalarbls12377gt-add>)
  - [func (s *ScalarBls12377Gt) BigInt() *big.Int](<#func-scalarbls12377gt-bigint>)
  - [func (s *ScalarBls12377Gt) Bytes() []byte](<#func-scalarbls12377gt-bytes>)
  - [func (s *ScalarBls12377Gt) Clone() Scalar](<#func-scalarbls12377gt-clone>)
  - [func (s *ScalarBls12377Gt) Cmp(rhs Scalar) int](<#func-scalarbls12377gt-cmp>)
  - [func (s *ScalarBls12377Gt) Cube() Scalar](<#func-scalarbls12377gt-cube>)
  - [func (s *ScalarBls12377Gt) Div(rhs Scalar) Scalar](<#func-scalarbls12377gt-div>)
  - [func (s *ScalarBls12377Gt) Double() Scalar](<#func-scalarbls12377gt-double>)
  - [func (s *ScalarBls12377Gt) Hash(bytes []byte) Scalar](<#func-scalarbls12377gt-hash>)
  - [func (s *ScalarBls12377Gt) Invert() (Scalar, error)](<#func-scalarbls12377gt-invert>)
  - [func (s *ScalarBls12377Gt) IsEven() bool](<#func-scalarbls12377gt-iseven>)
  - [func (s *ScalarBls12377Gt) IsOdd() bool](<#func-scalarbls12377gt-isodd>)
  - [func (s *ScalarBls12377Gt) IsOne() bool](<#func-scalarbls12377gt-isone>)
  - [func (s *ScalarBls12377Gt) IsZero() bool](<#func-scalarbls12377gt-iszero>)
  - [func (s *ScalarBls12377Gt) MarshalBinary() ([]byte, error)](<#func-scalarbls12377gt-marshalbinary>)
  - [func (s *ScalarBls12377Gt) MarshalJSON() ([]byte, error)](<#func-scalarbls12377gt-marshaljson>)
  - [func (s *ScalarBls12377Gt) MarshalText() ([]byte, error)](<#func-scalarbls12377gt-marshaltext>)
  - [func (s *ScalarBls12377Gt) Mul(rhs Scalar) Scalar](<#func-scalarbls12377gt-mul>)
  - [func (s *ScalarBls12377Gt) MulAdd(y, z Scalar) Scalar](<#func-scalarbls12377gt-muladd>)
  - [func (s *ScalarBls12377Gt) Neg() Scalar](<#func-scalarbls12377gt-neg>)
  - [func (s *ScalarBls12377Gt) New(input int) Scalar](<#func-scalarbls12377gt-new>)
  - [func (s *ScalarBls12377Gt) One() Scalar](<#func-scalarbls12377gt-one>)
  - [func (s *ScalarBls12377Gt) Point() Point](<#func-scalarbls12377gt-point>)
  - [func (s *ScalarBls12377Gt) Random(reader io.Reader) Scalar](<#func-scalarbls12377gt-random>)
  - [func (s *ScalarBls12377Gt) SetBigInt(v *big.Int) (Scalar, error)](<#func-scalarbls12377gt-setbigint>)
  - [func (s *ScalarBls12377Gt) SetBytes(bytes []byte) (Scalar, error)](<#func-scalarbls12377gt-setbytes>)
  - [func (s *ScalarBls12377Gt) SetBytesWide(bytes []byte) (Scalar, error)](<#func-scalarbls12377gt-setbyteswide>)
  - [func (s *ScalarBls12377Gt) Sqrt() (Scalar, error)](<#func-scalarbls12377gt-sqrt>)
  - [func (s *ScalarBls12377Gt) Square() Scalar](<#func-scalarbls12377gt-square>)
  - [func (s *ScalarBls12377Gt) Sub(rhs Scalar) Scalar](<#func-scalarbls12377gt-sub>)
  - [func (s *ScalarBls12377Gt) UnmarshalBinary(input []byte) error](<#func-scalarbls12377gt-unmarshalbinary>)
  - [func (s *ScalarBls12377Gt) UnmarshalJSON(input []byte) error](<#func-scalarbls12377gt-unmarshaljson>)
  - [func (s *ScalarBls12377Gt) UnmarshalText(input []byte) error](<#func-scalarbls12377gt-unmarshaltext>)
  - [func (s *ScalarBls12377Gt) Zero() Scalar](<#func-scalarbls12377gt-zero>)
- [type ScalarBls12381](<#type-scalarbls12381>)
  - [func (s *ScalarBls12381) Add(rhs Scalar) Scalar](<#func-scalarbls12381-add>)
  - [func (s *ScalarBls12381) BigInt() *big.Int](<#func-scalarbls12381-bigint>)
  - [func (s *ScalarBls12381) Bytes() []byte](<#func-scalarbls12381-bytes>)
  - [func (s *ScalarBls12381) Clone() Scalar](<#func-scalarbls12381-clone>)
  - [func (s *ScalarBls12381) Cmp(rhs Scalar) int](<#func-scalarbls12381-cmp>)
  - [func (s *ScalarBls12381) Cube() Scalar](<#func-scalarbls12381-cube>)
  - [func (s *ScalarBls12381) Div(rhs Scalar) Scalar](<#func-scalarbls12381-div>)
  - [func (s *ScalarBls12381) Double() Scalar](<#func-scalarbls12381-double>)
  - [func (s *ScalarBls12381) Hash(bytes []byte) Scalar](<#func-scalarbls12381-hash>)
  - [func (s *ScalarBls12381) Invert() (Scalar, error)](<#func-scalarbls12381-invert>)
  - [func (s *ScalarBls12381) IsEven() bool](<#func-scalarbls12381-iseven>)
  - [func (s *ScalarBls12381) IsOdd() bool](<#func-scalarbls12381-isodd>)
  - [func (s *ScalarBls12381) IsOne() bool](<#func-scalarbls12381-isone>)
  - [func (s *ScalarBls12381) IsZero() bool](<#func-scalarbls12381-iszero>)
  - [func (s *ScalarBls12381) MarshalBinary() ([]byte, error)](<#func-scalarbls12381-marshalbinary>)
  - [func (s *ScalarBls12381) MarshalJSON() ([]byte, error)](<#func-scalarbls12381-marshaljson>)
  - [func (s *ScalarBls12381) MarshalText() ([]byte, error)](<#func-scalarbls12381-marshaltext>)
  - [func (s *ScalarBls12381) Mul(rhs Scalar) Scalar](<#func-scalarbls12381-mul>)
  - [func (s *ScalarBls12381) MulAdd(y, z Scalar) Scalar](<#func-scalarbls12381-muladd>)
  - [func (s *ScalarBls12381) Neg() Scalar](<#func-scalarbls12381-neg>)
  - [func (s *ScalarBls12381) New(value int) Scalar](<#func-scalarbls12381-new>)
  - [func (s *ScalarBls12381) One() Scalar](<#func-scalarbls12381-one>)
  - [func (s *ScalarBls12381) Order() *big.Int](<#func-scalarbls12381-order>)
  - [func (s *ScalarBls12381) Point() Point](<#func-scalarbls12381-point>)
  - [func (s *ScalarBls12381) Random(reader io.Reader) Scalar](<#func-scalarbls12381-random>)
  - [func (s *ScalarBls12381) SetBigInt(v *big.Int) (Scalar, error)](<#func-scalarbls12381-setbigint>)
  - [func (s *ScalarBls12381) SetBytes(bytes []byte) (Scalar, error)](<#func-scalarbls12381-setbytes>)
  - [func (s *ScalarBls12381) SetBytesWide(bytes []byte) (Scalar, error)](<#func-scalarbls12381-setbyteswide>)
  - [func (s *ScalarBls12381) SetPoint(p Point) PairingScalar](<#func-scalarbls12381-setpoint>)
  - [func (s *ScalarBls12381) Sqrt() (Scalar, error)](<#func-scalarbls12381-sqrt>)
  - [func (s *ScalarBls12381) Square() Scalar](<#func-scalarbls12381-square>)
  - [func (s *ScalarBls12381) Sub(rhs Scalar) Scalar](<#func-scalarbls12381-sub>)
  - [func (s *ScalarBls12381) UnmarshalBinary(input []byte) error](<#func-scalarbls12381-unmarshalbinary>)
  - [func (s *ScalarBls12381) UnmarshalJSON(input []byte) error](<#func-scalarbls12381-unmarshaljson>)
  - [func (s *ScalarBls12381) UnmarshalText(input []byte) error](<#func-scalarbls12381-unmarshaltext>)
  - [func (s *ScalarBls12381) Zero() Scalar](<#func-scalarbls12381-zero>)
- [type ScalarBls12381Gt](<#type-scalarbls12381gt>)
  - [func (s *ScalarBls12381Gt) Add(rhs Scalar) Scalar](<#func-scalarbls12381gt-add>)
  - [func (s *ScalarBls12381Gt) BigInt() *big.Int](<#func-scalarbls12381gt-bigint>)
  - [func (s *ScalarBls12381Gt) Bytes() []byte](<#func-scalarbls12381gt-bytes>)
  - [func (s *ScalarBls12381Gt) Clone() Scalar](<#func-scalarbls12381gt-clone>)
  - [func (s *ScalarBls12381Gt) Cmp(rhs Scalar) int](<#func-scalarbls12381gt-cmp>)
  - [func (s *ScalarBls12381Gt) Cube() Scalar](<#func-scalarbls12381gt-cube>)
  - [func (s *ScalarBls12381Gt) Div(rhs Scalar) Scalar](<#func-scalarbls12381gt-div>)
  - [func (s *ScalarBls12381Gt) Double() Scalar](<#func-scalarbls12381gt-double>)
  - [func (s *ScalarBls12381Gt) Hash(bytes []byte) Scalar](<#func-scalarbls12381gt-hash>)
  - [func (s *ScalarBls12381Gt) Invert() (Scalar, error)](<#func-scalarbls12381gt-invert>)
  - [func (s *ScalarBls12381Gt) IsEven() bool](<#func-scalarbls12381gt-iseven>)
  - [func (s *ScalarBls12381Gt) IsOdd() bool](<#func-scalarbls12381gt-isodd>)
  - [func (s *ScalarBls12381Gt) IsOne() bool](<#func-scalarbls12381gt-isone>)
  - [func (s *ScalarBls12381Gt) IsZero() bool](<#func-scalarbls12381gt-iszero>)
  - [func (s *ScalarBls12381Gt) MarshalBinary() ([]byte, error)](<#func-scalarbls12381gt-marshalbinary>)
  - [func (s *ScalarBls12381Gt) MarshalJSON() ([]byte, error)](<#func-scalarbls12381gt-marshaljson>)
  - [func (s *ScalarBls12381Gt) MarshalText() ([]byte, error)](<#func-scalarbls12381gt-marshaltext>)
  - [func (s *ScalarBls12381Gt) Mul(rhs Scalar) Scalar](<#func-scalarbls12381gt-mul>)
  - [func (s *ScalarBls12381Gt) MulAdd(y, z Scalar) Scalar](<#func-scalarbls12381gt-muladd>)
  - [func (s *ScalarBls12381Gt) Neg() Scalar](<#func-scalarbls12381gt-neg>)
  - [func (s *ScalarBls12381Gt) New(input int) Scalar](<#func-scalarbls12381gt-new>)
  - [func (s *ScalarBls12381Gt) One() Scalar](<#func-scalarbls12381gt-one>)
  - [func (s *ScalarBls12381Gt) Point() Point](<#func-scalarbls12381gt-point>)
  - [func (s *ScalarBls12381Gt) Random(reader io.Reader) Scalar](<#func-scalarbls12381gt-random>)
  - [func (s *ScalarBls12381Gt) SetBigInt(v *big.Int) (Scalar, error)](<#func-scalarbls12381gt-setbigint>)
  - [func (s *ScalarBls12381Gt) SetBytes(bytes []byte) (Scalar, error)](<#func-scalarbls12381gt-setbytes>)
  - [func (s *ScalarBls12381Gt) SetBytesWide(bytes []byte) (Scalar, error)](<#func-scalarbls12381gt-setbyteswide>)
  - [func (s *ScalarBls12381Gt) Sqrt() (Scalar, error)](<#func-scalarbls12381gt-sqrt>)
  - [func (s *ScalarBls12381Gt) Square() Scalar](<#func-scalarbls12381gt-square>)
  - [func (s *ScalarBls12381Gt) Sub(rhs Scalar) Scalar](<#func-scalarbls12381gt-sub>)
  - [func (s *ScalarBls12381Gt) UnmarshalBinary(input []byte) error](<#func-scalarbls12381gt-unmarshalbinary>)
  - [func (s *ScalarBls12381Gt) UnmarshalJSON(input []byte) error](<#func-scalarbls12381gt-unmarshaljson>)
  - [func (s *ScalarBls12381Gt) UnmarshalText(input []byte) error](<#func-scalarbls12381gt-unmarshaltext>)
  - [func (s *ScalarBls12381Gt) Zero() Scalar](<#func-scalarbls12381gt-zero>)
- [type ScalarEd25519](<#type-scalared25519>)
  - [func (s *ScalarEd25519) Add(rhs Scalar) Scalar](<#func-scalared25519-add>)
  - [func (s *ScalarEd25519) BigInt() *big.Int](<#func-scalared25519-bigint>)
  - [func (s *ScalarEd25519) Bytes() []byte](<#func-scalared25519-bytes>)
  - [func (s *ScalarEd25519) Clone() Scalar](<#func-scalared25519-clone>)
  - [func (s *ScalarEd25519) Cmp(rhs Scalar) int](<#func-scalared25519-cmp>)
  - [func (s *ScalarEd25519) Cube() Scalar](<#func-scalared25519-cube>)
  - [func (s *ScalarEd25519) Div(rhs Scalar) Scalar](<#func-scalared25519-div>)
  - [func (s *ScalarEd25519) Double() Scalar](<#func-scalared25519-double>)
  - [func (s *ScalarEd25519) GetEdwardsScalar() *edwards25519.Scalar](<#func-scalared25519-getedwardsscalar>)
  - [func (s *ScalarEd25519) Hash(bytes []byte) Scalar](<#func-scalared25519-hash>)
  - [func (s *ScalarEd25519) Invert() (Scalar, error)](<#func-scalared25519-invert>)
  - [func (s *ScalarEd25519) IsEven() bool](<#func-scalared25519-iseven>)
  - [func (s *ScalarEd25519) IsOdd() bool](<#func-scalared25519-isodd>)
  - [func (s *ScalarEd25519) IsOne() bool](<#func-scalared25519-isone>)
  - [func (s *ScalarEd25519) IsZero() bool](<#func-scalared25519-iszero>)
  - [func (s *ScalarEd25519) MarshalBinary() ([]byte, error)](<#func-scalared25519-marshalbinary>)
  - [func (s *ScalarEd25519) MarshalJSON() ([]byte, error)](<#func-scalared25519-marshaljson>)
  - [func (s *ScalarEd25519) MarshalText() ([]byte, error)](<#func-scalared25519-marshaltext>)
  - [func (s *ScalarEd25519) Mul(rhs Scalar) Scalar](<#func-scalared25519-mul>)
  - [func (s *ScalarEd25519) MulAdd(y, z Scalar) Scalar](<#func-scalared25519-muladd>)
  - [func (s *ScalarEd25519) Neg() Scalar](<#func-scalared25519-neg>)
  - [func (s *ScalarEd25519) New(input int) Scalar](<#func-scalared25519-new>)
  - [func (s *ScalarEd25519) One() Scalar](<#func-scalared25519-one>)
  - [func (s *ScalarEd25519) Point() Point](<#func-scalared25519-point>)
  - [func (s *ScalarEd25519) Random(reader io.Reader) Scalar](<#func-scalared25519-random>)
  - [func (s *ScalarEd25519) SetBigInt(x *big.Int) (Scalar, error)](<#func-scalared25519-setbigint>)
  - [func (s *ScalarEd25519) SetBytes(input []byte) (Scalar, error)](<#func-scalared25519-setbytes>)
  - [func (s *ScalarEd25519) SetBytesCanonical(bytes []byte) (Scalar, error)](<#func-scalared25519-setbytescanonical>)
  - [func (s *ScalarEd25519) SetBytesClamping(bytes []byte) (Scalar, error)](<#func-scalared25519-setbytesclamping>)
  - [func (s *ScalarEd25519) SetBytesWide(bytes []byte) (Scalar, error)](<#func-scalared25519-setbyteswide>)
  - [func (s *ScalarEd25519) SetEdwardsScalar(sc *edwards25519.Scalar) *ScalarEd25519](<#func-scalared25519-setedwardsscalar>)
  - [func (s *ScalarEd25519) Sqrt() (Scalar, error)](<#func-scalared25519-sqrt>)
  - [func (s *ScalarEd25519) Square() Scalar](<#func-scalared25519-square>)
  - [func (s *ScalarEd25519) Sub(rhs Scalar) Scalar](<#func-scalared25519-sub>)
  - [func (s *ScalarEd25519) UnmarshalBinary(input []byte) error](<#func-scalared25519-unmarshalbinary>)
  - [func (s *ScalarEd25519) UnmarshalJSON(input []byte) error](<#func-scalared25519-unmarshaljson>)
  - [func (s *ScalarEd25519) UnmarshalText(input []byte) error](<#func-scalared25519-unmarshaltext>)
  - [func (s *ScalarEd25519) Zero() Scalar](<#func-scalared25519-zero>)
- [type ScalarK256](<#type-scalark256>)
  - [func (s *ScalarK256) Add(rhs Scalar) Scalar](<#func-scalark256-add>)
  - [func (s *ScalarK256) BigInt() *big.Int](<#func-scalark256-bigint>)
  - [func (s *ScalarK256) Bytes() []byte](<#func-scalark256-bytes>)
  - [func (s *ScalarK256) Clone() Scalar](<#func-scalark256-clone>)
  - [func (s *ScalarK256) Cmp(rhs Scalar) int](<#func-scalark256-cmp>)
  - [func (s *ScalarK256) Cube() Scalar](<#func-scalark256-cube>)
  - [func (s *ScalarK256) Div(rhs Scalar) Scalar](<#func-scalark256-div>)
  - [func (s *ScalarK256) Double() Scalar](<#func-scalark256-double>)
  - [func (s *ScalarK256) Hash(bytes []byte) Scalar](<#func-scalark256-hash>)
  - [func (s *ScalarK256) Invert() (Scalar, error)](<#func-scalark256-invert>)
  - [func (s *ScalarK256) IsEven() bool](<#func-scalark256-iseven>)
  - [func (s *ScalarK256) IsOdd() bool](<#func-scalark256-isodd>)
  - [func (s *ScalarK256) IsOne() bool](<#func-scalark256-isone>)
  - [func (s *ScalarK256) IsZero() bool](<#func-scalark256-iszero>)
  - [func (s *ScalarK256) MarshalBinary() ([]byte, error)](<#func-scalark256-marshalbinary>)
  - [func (s *ScalarK256) MarshalJSON() ([]byte, error)](<#func-scalark256-marshaljson>)
  - [func (s *ScalarK256) MarshalText() ([]byte, error)](<#func-scalark256-marshaltext>)
  - [func (s *ScalarK256) Mul(rhs Scalar) Scalar](<#func-scalark256-mul>)
  - [func (s *ScalarK256) MulAdd(y, z Scalar) Scalar](<#func-scalark256-muladd>)
  - [func (s *ScalarK256) Neg() Scalar](<#func-scalark256-neg>)
  - [func (s *ScalarK256) New(value int) Scalar](<#func-scalark256-new>)
  - [func (s *ScalarK256) One() Scalar](<#func-scalark256-one>)
  - [func (s *ScalarK256) Point() Point](<#func-scalark256-point>)
  - [func (s *ScalarK256) Random(reader io.Reader) Scalar](<#func-scalark256-random>)
  - [func (s *ScalarK256) SetBigInt(v *big.Int) (Scalar, error)](<#func-scalark256-setbigint>)
  - [func (s *ScalarK256) SetBytes(bytes []byte) (Scalar, error)](<#func-scalark256-setbytes>)
  - [func (s *ScalarK256) SetBytesWide(bytes []byte) (Scalar, error)](<#func-scalark256-setbyteswide>)
  - [func (s *ScalarK256) Sqrt() (Scalar, error)](<#func-scalark256-sqrt>)
  - [func (s *ScalarK256) Square() Scalar](<#func-scalark256-square>)
  - [func (s *ScalarK256) Sub(rhs Scalar) Scalar](<#func-scalark256-sub>)
  - [func (s *ScalarK256) UnmarshalBinary(input []byte) error](<#func-scalark256-unmarshalbinary>)
  - [func (s *ScalarK256) UnmarshalJSON(input []byte) error](<#func-scalark256-unmarshaljson>)
  - [func (s *ScalarK256) UnmarshalText(input []byte) error](<#func-scalark256-unmarshaltext>)
  - [func (s *ScalarK256) Zero() Scalar](<#func-scalark256-zero>)
- [type ScalarP256](<#type-scalarp256>)
  - [func (s *ScalarP256) Add(rhs Scalar) Scalar](<#func-scalarp256-add>)
  - [func (s *ScalarP256) BigInt() *big.Int](<#func-scalarp256-bigint>)
  - [func (s *ScalarP256) Bytes() []byte](<#func-scalarp256-bytes>)
  - [func (s *ScalarP256) Clone() Scalar](<#func-scalarp256-clone>)
  - [func (s *ScalarP256) Cmp(rhs Scalar) int](<#func-scalarp256-cmp>)
  - [func (s *ScalarP256) Cube() Scalar](<#func-scalarp256-cube>)
  - [func (s *ScalarP256) Div(rhs Scalar) Scalar](<#func-scalarp256-div>)
  - [func (s *ScalarP256) Double() Scalar](<#func-scalarp256-double>)
  - [func (s *ScalarP256) Hash(bytes []byte) Scalar](<#func-scalarp256-hash>)
  - [func (s *ScalarP256) Invert() (Scalar, error)](<#func-scalarp256-invert>)
  - [func (s *ScalarP256) IsEven() bool](<#func-scalarp256-iseven>)
  - [func (s *ScalarP256) IsOdd() bool](<#func-scalarp256-isodd>)
  - [func (s *ScalarP256) IsOne() bool](<#func-scalarp256-isone>)
  - [func (s *ScalarP256) IsZero() bool](<#func-scalarp256-iszero>)
  - [func (s *ScalarP256) MarshalBinary() ([]byte, error)](<#func-scalarp256-marshalbinary>)
  - [func (s *ScalarP256) MarshalJSON() ([]byte, error)](<#func-scalarp256-marshaljson>)
  - [func (s *ScalarP256) MarshalText() ([]byte, error)](<#func-scalarp256-marshaltext>)
  - [func (s *ScalarP256) Mul(rhs Scalar) Scalar](<#func-scalarp256-mul>)
  - [func (s *ScalarP256) MulAdd(y, z Scalar) Scalar](<#func-scalarp256-muladd>)
  - [func (s *ScalarP256) Neg() Scalar](<#func-scalarp256-neg>)
  - [func (s *ScalarP256) New(value int) Scalar](<#func-scalarp256-new>)
  - [func (s *ScalarP256) One() Scalar](<#func-scalarp256-one>)
  - [func (s *ScalarP256) Point() Point](<#func-scalarp256-point>)
  - [func (s *ScalarP256) Random(reader io.Reader) Scalar](<#func-scalarp256-random>)
  - [func (s *ScalarP256) SetBigInt(v *big.Int) (Scalar, error)](<#func-scalarp256-setbigint>)
  - [func (s *ScalarP256) SetBytes(bytes []byte) (Scalar, error)](<#func-scalarp256-setbytes>)
  - [func (s *ScalarP256) SetBytesWide(bytes []byte) (Scalar, error)](<#func-scalarp256-setbyteswide>)
  - [func (s *ScalarP256) Sqrt() (Scalar, error)](<#func-scalarp256-sqrt>)
  - [func (s *ScalarP256) Square() Scalar](<#func-scalarp256-square>)
  - [func (s *ScalarP256) Sub(rhs Scalar) Scalar](<#func-scalarp256-sub>)
  - [func (s *ScalarP256) UnmarshalBinary(input []byte) error](<#func-scalarp256-unmarshalbinary>)
  - [func (s *ScalarP256) UnmarshalJSON(input []byte) error](<#func-scalarp256-unmarshaljson>)
  - [func (s *ScalarP256) UnmarshalText(input []byte) error](<#func-scalarp256-unmarshaltext>)
  - [func (s *ScalarP256) Zero() Scalar](<#func-scalarp256-zero>)
- [type ScalarPallas](<#type-scalarpallas>)
  - [func (s *ScalarPallas) Add(rhs Scalar) Scalar](<#func-scalarpallas-add>)
  - [func (s *ScalarPallas) BigInt() *big.Int](<#func-scalarpallas-bigint>)
  - [func (s *ScalarPallas) Bytes() []byte](<#func-scalarpallas-bytes>)
  - [func (s *ScalarPallas) Clone() Scalar](<#func-scalarpallas-clone>)
  - [func (s *ScalarPallas) Cmp(rhs Scalar) int](<#func-scalarpallas-cmp>)
  - [func (s *ScalarPallas) Cube() Scalar](<#func-scalarpallas-cube>)
  - [func (s *ScalarPallas) Div(rhs Scalar) Scalar](<#func-scalarpallas-div>)
  - [func (s *ScalarPallas) Double() Scalar](<#func-scalarpallas-double>)
  - [func (s *ScalarPallas) GetFq() *fq.Fq](<#func-scalarpallas-getfq>)
  - [func (s *ScalarPallas) Hash(bytes []byte) Scalar](<#func-scalarpallas-hash>)
  - [func (s *ScalarPallas) Invert() (Scalar, error)](<#func-scalarpallas-invert>)
  - [func (s *ScalarPallas) IsEven() bool](<#func-scalarpallas-iseven>)
  - [func (s *ScalarPallas) IsOdd() bool](<#func-scalarpallas-isodd>)
  - [func (s *ScalarPallas) IsOne() bool](<#func-scalarpallas-isone>)
  - [func (s *ScalarPallas) IsZero() bool](<#func-scalarpallas-iszero>)
  - [func (s *ScalarPallas) MarshalBinary() ([]byte, error)](<#func-scalarpallas-marshalbinary>)
  - [func (s *ScalarPallas) MarshalJSON() ([]byte, error)](<#func-scalarpallas-marshaljson>)
  - [func (s *ScalarPallas) MarshalText() ([]byte, error)](<#func-scalarpallas-marshaltext>)
  - [func (s *ScalarPallas) Mul(rhs Scalar) Scalar](<#func-scalarpallas-mul>)
  - [func (s *ScalarPallas) MulAdd(y, z Scalar) Scalar](<#func-scalarpallas-muladd>)
  - [func (s *ScalarPallas) Neg() Scalar](<#func-scalarpallas-neg>)
  - [func (s *ScalarPallas) New(value int) Scalar](<#func-scalarpallas-new>)
  - [func (s *ScalarPallas) One() Scalar](<#func-scalarpallas-one>)
  - [func (s *ScalarPallas) Point() Point](<#func-scalarpallas-point>)
  - [func (s *ScalarPallas) Random(reader io.Reader) Scalar](<#func-scalarpallas-random>)
  - [func (s *ScalarPallas) SetBigInt(v *big.Int) (Scalar, error)](<#func-scalarpallas-setbigint>)
  - [func (s *ScalarPallas) SetBytes(bytes []byte) (Scalar, error)](<#func-scalarpallas-setbytes>)
  - [func (s *ScalarPallas) SetBytesWide(bytes []byte) (Scalar, error)](<#func-scalarpallas-setbyteswide>)
  - [func (s *ScalarPallas) SetFq(fq *fq.Fq) *ScalarPallas](<#func-scalarpallas-setfq>)
  - [func (s *ScalarPallas) Sqrt() (Scalar, error)](<#func-scalarpallas-sqrt>)
  - [func (s *ScalarPallas) Square() Scalar](<#func-scalarpallas-square>)
  - [func (s *ScalarPallas) Sub(rhs Scalar) Scalar](<#func-scalarpallas-sub>)
  - [func (s *ScalarPallas) UnmarshalBinary(input []byte) error](<#func-scalarpallas-unmarshalbinary>)
  - [func (s *ScalarPallas) UnmarshalJSON(input []byte) error](<#func-scalarpallas-unmarshaljson>)
  - [func (s *ScalarPallas) UnmarshalText(input []byte) error](<#func-scalarpallas-unmarshaltext>)
  - [func (s *ScalarPallas) Zero() Scalar](<#func-scalarpallas-zero>)


## Constants

```go
const (
    K256Name       = "secp256k1"
    BLS12381G1Name = "BLS12381G1"
    BLS12381G2Name = "BLS12381G2"
    BLS12831Name   = "BLS12831"
    P256Name       = "P-256"
    ED25519Name    = "ed25519"
    PallasName     = "pallas"
    BLS12377G1Name = "BLS12377G1"
    BLS12377G2Name = "BLS12377G2"
    BLS12377Name   = "BLS12377"
)
```

## func [Ed25519Order](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L267>)

```go
func Ed25519Order() *big.Int
```

SubgroupOrder returns the order of the Ed25519 base Point\.

## func [VerifyEcdsa](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ecdsa.go#L30>)

```go
func VerifyEcdsa(pk *EcPoint, hash []byte, sig *EcdsaSignature) bool
```

Verifies ECDSA signature using core types\.

## type [Bls12381Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L171>)

```go
type Bls12381Scalar struct{}
```

### func [NewBls12381Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L176>)

```go
func NewBls12381Scalar() *Bls12381Scalar
```

### func \(Bls12381Scalar\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L180>)

```go
func (k Bls12381Scalar) Add(x, y *big.Int) *big.Int
```

### func \(Bls12381Scalar\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L232>)

```go
func (k Bls12381Scalar) Bytes(x *big.Int) []byte
```

### func \(Bls12381Scalar\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L207>)

```go
func (k Bls12381Scalar) Div(x, y *big.Int) *big.Int
```

### func \(Bls12381Scalar\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L213>)

```go
func (k Bls12381Scalar) Hash(input []byte) *big.Int
```

### func \(Bls12381Scalar\) [IsValid](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L238>)

```go
func (k Bls12381Scalar) IsValid(x *big.Int) bool
```

### func \(Bls12381Scalar\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L200>)

```go
func (k Bls12381Scalar) Mul(x, y *big.Int) *big.Int
```

### func \(Bls12381Scalar\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L194>)

```go
func (k Bls12381Scalar) Neg(x *big.Int) *big.Int
```

### func \(Bls12381Scalar\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L217>)

```go
func (k Bls12381Scalar) Random() (*big.Int, error)
```

### func \(Bls12381Scalar\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L187>)

```go
func (k Bls12381Scalar) Sub(x, y *big.Int) *big.Int
```

## type [Curve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L382-L386>)

Curve represents a named elliptic curve with a scalar field and point group

```go
type Curve struct {
    Scalar Scalar
    Point  Point
    Name   string
}
```

### func [BLS12377G1](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L537>)

```go
func BLS12377G1() *Curve
```

BLS12377G1 returns the BLS12\-377 curve with points in G1

### func [BLS12377G2](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L554>)

```go
func BLS12377G2() *Curve
```

BLS12377G2 returns the BLS12\-377 curve with points in G2

### func [BLS12381G1](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L484>)

```go
func BLS12381G1() *Curve
```

BLS12381G1 returns the BLS12\-381 curve with points in G1

### func [BLS12381G2](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L501>)

```go
func BLS12381G2() *Curve
```

BLS12381G2 returns the BLS12\-381 curve with points in G2

### func [ED25519](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L597>)

```go
func ED25519() *Curve
```

### func [GetCurveByName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L443>)

```go
func GetCurveByName(name string) *Curve
```

GetCurveByName returns the correct \`Curve\` given the name

### func [K256](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L571>)

```go
func K256() *Curve
```

K256 returns the secp256k1 curve

### func [P256](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L584>)

```go
func P256() *Curve
```

### func [PALLAS](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L610>)

```go
func PALLAS() *Curve
```

### func \(Curve\) [NewGeneratorPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L392>)

```go
func (c Curve) NewGeneratorPoint() Point
```

### func \(Curve\) [NewIdentityPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L396>)

```go
func (c Curve) NewIdentityPoint() Point
```

### func \(Curve\) [NewScalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L400>)

```go
func (c Curve) NewScalar() Scalar
```

### func \(Curve\) [ScalarBaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L388>)

```go
func (c Curve) ScalarBaseMult(sc Scalar) Point
```

## type [EcPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L45-L48>)

EcPoint represents an elliptic curve Point

```go
type EcPoint struct {
    Curve elliptic.Curve
    X, Y  *big.Int
}
```

### func [NewScalarBaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L190>)

```go
func NewScalarBaseMult(curve elliptic.Curve, k *big.Int) (*EcPoint, error)
```

NewScalarBaseMult creates a Point from the base Point multiplied by a field element

### func [PointFromBytesUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L216>)

```go
func PointFromBytesUncompressed(curve elliptic.Curve, b []byte) (*EcPoint, error)
```

PointFromBytesUncompressed outputs uncompressed X || Y similar to https://www.secg.org/sec1-v1.99.dif.pdf section 2\.2 and 2\.3

### func \(\*EcPoint\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L143>)

```go
func (a *EcPoint) Add(b *EcPoint) (*EcPoint, error)
```

Add performs elliptic curve addition on two points

### func \(EcPoint\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L205>)

```go
func (a EcPoint) Bytes() []byte
```

Bytes returns the bytes represented by this Point with x || y

### func \(EcPoint\) [Equals](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L119>)

```go
func (a EcPoint) Equals(b *EcPoint) bool
```

Equals return true if a \+ b have the same x\,y coordinates

### func \(EcPoint\) [IsBasePoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L130>)

```go
func (a EcPoint) IsBasePoint() bool
```

IsBasePoint returns true if this Point is curve's base Point

### func \(EcPoint\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L112>)

```go
func (a EcPoint) IsIdentity() bool
```

IsIdentity returns true if this Point is the Point at infinity

### func \(EcPoint\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L107>)

```go
func (a EcPoint) IsOnCurve() bool
```

### func \(EcPoint\) [IsValid](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L103>)

```go
func (a EcPoint) IsValid() bool
```

### func \(\*EcPoint\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L82>)

```go
func (a *EcPoint) MarshalBinary() ([]byte, error)
```

### func \(EcPoint\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L59>)

```go
func (a EcPoint) MarshalJSON() ([]byte, error)
```

MarshalJSON serializes

### func \(\*EcPoint\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L161>)

```go
func (a *EcPoint) Neg() (*EcPoint, error)
```

Neg returns the negation of a Weierstrass Point\.

### func \(\*EcPoint\) [ScalarMult](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L175>)

```go
func (a *EcPoint) ScalarMult(k *big.Int) (*EcPoint, error)
```

ScalarMult multiplies this Point by a Scalar

### func \(\*EcPoint\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L93>)

```go
func (a *EcPoint) UnmarshalBinary(data []byte) error
```

### func \(\*EcPoint\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L67>)

```go
func (a *EcPoint) UnmarshalJSON(bytes []byte) error
```

## type [EcPointJson](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_point.go#L53-L56>)

EcPointJson encapsulates the data that is serialized to JSON used internally and not for external use\. Public so other pieces can use for serialization

```go
type EcPointJson struct {
    CurveName string
    X, Y      *big.Int
}
```

## type [EcScalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L25-L35>)

```go
type EcScalar interface {
    Add(x, y *big.Int) *big.Int
    Sub(x, y *big.Int) *big.Int
    Neg(x *big.Int) *big.Int
    Mul(x, y *big.Int) *big.Int
    Hash(input []byte) *big.Int
    Div(x, y *big.Int) *big.Int
    Random() (*big.Int, error)
    IsValid(x *big.Int) bool
    Bytes(x *big.Int) []byte // fixed-length byte array
}
```

## type [EcdsaSignature](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ecdsa.go#L21-L24>)

EcdsaSignature represents a \(composite\) digital signature

```go
type EcdsaSignature struct {
    V    int
    R, S *big.Int
}
```

## type [EcdsaVerify](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ecdsa.go#L18>)

EcdsaVerify runs a curve\- or algorithm\-specific ECDSA verification function on input an ECDSA public \(verification\) key\, a message digest\, and an ECDSA signature\. It must return true if all the parameters are sane and the ECDSA signature is valid\, and false otherwise

```go
type EcdsaVerify func(pubKey *EcPoint, hash []byte, signature *EcdsaSignature) bool
```

## type [Ed25519Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L246>)

```go
type Ed25519Scalar struct{}
```

### func [NewEd25519Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L251>)

```go
func NewEd25519Scalar() *Ed25519Scalar
```

### func \(Ed25519Scalar\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L255>)

```go
func (k Ed25519Scalar) Add(x, y *big.Int) *big.Int
```

### func \(Ed25519Scalar\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L324>)

```go
func (k Ed25519Scalar) Bytes(x *big.Int) []byte
```

### func \(Ed25519Scalar\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L303>)

```go
func (k Ed25519Scalar) Div(x, y *big.Int) *big.Int
```

### func \(Ed25519Scalar\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L317>)

```go
func (k Ed25519Scalar) Hash(input []byte) *big.Int
```

### func \(Ed25519Scalar\) [IsValid](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L355>)

```go
func (k Ed25519Scalar) IsValid(x *big.Int) bool
```

### func \(Ed25519Scalar\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L290>)

```go
func (k Ed25519Scalar) Mul(x, y *big.Int) *big.Int
```

### func \(Ed25519Scalar\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L281>)

```go
func (k Ed25519Scalar) Neg(x *big.Int) *big.Int
```

### func \(Ed25519Scalar\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L332>)

```go
func (k Ed25519Scalar) Random() (*big.Int, error)
```

### func \(Ed25519Scalar\) [RandomWithReader](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L336>)

```go
func (k Ed25519Scalar) RandomWithReader(r io.Reader) (*big.Int, error)
```

### func \(Ed25519Scalar\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L268>)

```go
func (k Ed25519Scalar) Sub(x, y *big.Int) *big.Int
```

## type [Element](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L28-L31>)

Element is a group element within a finite field\.

```go
type Element struct {
    Modulus *Field   `json:"modulus"`
    Value   *big.Int `json:"value"`
}
```

### func \(Element\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L174>)

```go
func (x Element) Add(y *Element) *Element
```

Add returns the sum x\+y

### func \(Element\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L233>)

```go
func (x Element) BigInt() *big.Int
```

BigInt returns value as a big\.Int

### func \(Element\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L238>)

```go
func (x Element) Bytes() []byte
```

Bytes returns the value as bytes

### func \(Element\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L252>)

```go
func (x Element) Clone() *Element
```

Clone returns a new copy of the element

### func \(Element\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L208>)

```go
func (x Element) Div(y *Element) *Element
```

Div returns the quotient x/y

### func \(Element\) [Field](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L169>)

```go
func (x Element) Field() *Field
```

### func \(Element\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L224>)

```go
func (x Element) Invert() *Element
```

### func \(Element\) [IsEqual](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L243>)

```go
func (x Element) IsEqual(y *Element) bool
```

IsEqual returns x == y

### func \(\*Element\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L42>)

```go
func (x *Element) MarshalJSON() ([]byte, error)
```

Marshal Element to JSON

### func \(Element\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L199>)

```go
func (x Element) Mul(y *Element) *Element
```

Mul returns the product x\*y

### func \(Element\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L192>)

```go
func (x Element) Neg() *Element
```

Neg returns the field negation

### func \(Element\) [Pow](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L218>)

```go
func (x Element) Pow(y *Element) *Element
```

Pow computes x^y reduced by the modulus

### func \(Element\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L228>)

```go
func (x Element) Sqrt() *Element
```

### func \(Element\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L183>)

```go
func (x Element) Sub(y *Element) *Element
```

Sub returns the difference x\-y

### func \(\*Element\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L49>)

```go
func (x *Element) UnmarshalJSON(bytes []byte) error
```

## type [ElementJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L36-L39>)

ElementJSON is used in JSON\<\>Element conversions\. For years\, big\.Int hasn't properly supported JSON unmarshaling https://github.com/golang/go/issues/28154

```go
type ElementJSON struct {
    Modulus string `json:"modulus"`
    Value   string `json:"value"`
}
```

## type [Ep](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L687-L691>)

```go
type Ep struct {
    // contains filtered or unexported fields
}
```

### func \(\*Ep\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L772>)

```go
func (p *Ep) Add(lhs *Ep, rhs *Ep) *Ep
```

### func \(\*Ep\) [CMove](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L1010>)

```go
func (p *Ep) CMove(lhs, rhs *Ep, condition int) *Ep
```

### func \(Ep\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L965>)

```go
func (p Ep) CurveName() string
```

### func \(\*Ep\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L736>)

```go
func (p *Ep) Double(other *Ep) *Ep
```

### func \(\*Ep\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L847>)

```go
func (p *Ep) Equal(other *Ep) bool
```

### func \(\*Ep\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L906>)

```go
func (p *Ep) FromAffineCompressed(bytes []byte) (*Ep, error)
```

### func \(\*Ep\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L936>)

```go
func (p *Ep) FromAffineUncompressed(bytes []byte) (*Ep, error)
```

### func \(\*Ep\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L725>)

```go
func (p *Ep) Generator() *Ep
```

### func \(\*Ep\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L699>)

```go
func (p *Ep) Hash(bytes []byte) *Ep
```

### func \(\*Ep\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L718>)

```go
func (p *Ep) Identity() *Ep
```

### func \(\*Ep\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L732>)

```go
func (p *Ep) IsIdentity() bool
```

### func \(\*Ep\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L993>)

```go
func (p *Ep) IsOnCurve() bool
```

### func \(\*Ep\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L826>)

```go
func (p *Ep) Mul(point *Ep, scalar *fq.Fq) *Ep
```

### func \(\*Ep\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L765>)

```go
func (p *Ep) Neg(other *Ep) *Ep
```

### func \(\*Ep\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L693>)

```go
func (p *Ep) Random(reader io.Reader) *Ep
```

### func \(\*Ep\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L859>)

```go
func (p *Ep) Set(other *Ep) *Ep
```

### func \(\*Ep\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L822>)

```go
func (p *Ep) Sub(lhs, rhs *Ep) *Ep
```

### func \(Ep\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L969>)

```go
func (p Ep) SumOfProducts(points []*Ep, scalars []Scalar) *Ep
```

### func \(\*Ep\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L885>)

```go
func (p *Ep) ToAffineCompressed() []byte
```

### func \(\*Ep\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L898>)

```go
func (p *Ep) ToAffineUncompressed() []byte
```

### func \(\*Ep\) [X](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L981>)

```go
func (p *Ep) X() *fp.Fp
```

### func \(\*Ep\) [Y](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L987>)

```go
func (p *Ep) Y() *fp.Fp
```

## type [Field](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L23-L25>)

Field is a finite field\.

```go
type Field struct {
    *big.Int
}
```

### func [NewField](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L74>)

```go
func NewField(modulus *big.Int) *Field
```

New is a constructor for a Field\.

### func \(Field\) [ElementFromBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L134>)

```go
func (f Field) ElementFromBytes(bytes []byte) *Element
```

ElementFromBytes initializes a new field element from big\-endian bytes

### func \(Field\) [IsValid](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L93>)

```go
func (f Field) IsValid(value *big.Int) bool
```

IsValid returns whether or not the value is within \[0\, modulus\)

### func \(Field\) [NewElement](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L98>)

```go
func (f Field) NewElement(value *big.Int) *Element
```

### func \(Field\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L106>)

```go
func (f Field) One() *Element
```

### func \(Field\) [RandomElement](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L110>)

```go
func (f Field) RandomElement(r io.Reader) (*Element, error)
```

### func \(Field\) [ReducedElementFromBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L163>)

```go
func (f Field) ReducedElementFromBytes(bytes []byte) *Element
```

ReducedElementFromBytes initializes a new field element from big\-endian bytes and reduces it by the modulus of the field\.

WARNING: If this is used with cryptographic constructions which rely on a uniform distribution of values\, this may introduce a bias to the value of the returned field element\. This happens when the integer range of the provided bytes is not an integer multiple of the field order\.

Assume we are working in field which a modulus of 3 and the range of the uniform random bytes we provide as input is 5\. Thus\, the set of field elements is \{0\, 1\, 2\} and the set of integer values for the input bytes is: \{0\, 1\, 2\, 3\, 4\}\. What is the distribution of the output values produced by this function?

```
ReducedElementFromBytes(0) => 0
ReducedElementFromBytes(1) => 1
ReducedElementFromBytes(2) => 2
ReducedElementFromBytes(3) => 0
ReducedElementFromBytes(4) => 1
```

For a value space V and random value v\, a uniform distribution is defined as P\[V = v\] = 1/|V| where |V| is to the order of the field\. Using the results from above\, we see that P\[v = 0\] = 2/5\, P\[v = 1\] = 2/5\, and P\[v = 2\] = 1/5\. For a uniform distribution we would expect these to each be equal to 1/3\. As they do not\, this does not return uniform output for that example\.

To see why this is okay if the range is a multiple of the field order\, change the input range to 6 and notice that now each output has a probability of 2/6 = 1/3\, and the output is uniform\.

### func \(Field\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/field.go#L102>)

```go
func (f Field) Zero() *Element
```

## type [K256Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L37>)

```go
type K256Scalar struct{}
```

### func [NewK256Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L44>)

```go
func NewK256Scalar() *K256Scalar
```

### func \(K256Scalar\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L48>)

```go
func (k K256Scalar) Add(x, y *big.Int) *big.Int
```

### func \(K256Scalar\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L99>)

```go
func (k K256Scalar) Bytes(x *big.Int) []byte
```

### func \(K256Scalar\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L72>)

```go
func (k K256Scalar) Div(x, y *big.Int) *big.Int
```

### func \(K256Scalar\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L77>)

```go
func (k K256Scalar) Hash(input []byte) *big.Int
```

### func \(K256Scalar\) [IsValid](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L95>)

```go
func (k K256Scalar) IsValid(x *big.Int) bool
```

### func \(K256Scalar\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L66>)

```go
func (k K256Scalar) Mul(x, y *big.Int) *big.Int
```

### func \(K256Scalar\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L60>)

```go
func (k K256Scalar) Neg(x *big.Int) *big.Int
```

### func \(K256Scalar\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L81>)

```go
func (k K256Scalar) Random() (*big.Int, error)
```

### func \(K256Scalar\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L54>)

```go
func (k K256Scalar) Sub(x, y *big.Int) *big.Int
```

## type [P256Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L105>)

```go
type P256Scalar struct{}
```

### func [NewP256Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L110>)

```go
func NewP256Scalar() *P256Scalar
```

### func \(P256Scalar\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L114>)

```go
func (k P256Scalar) Add(x, y *big.Int) *big.Int
```

### func \(P256Scalar\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L165>)

```go
func (k P256Scalar) Bytes(x *big.Int) []byte
```

### func \(P256Scalar\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L138>)

```go
func (k P256Scalar) Div(x, y *big.Int) *big.Int
```

### func \(P256Scalar\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L143>)

```go
func (k P256Scalar) Hash(input []byte) *big.Int
```

### func \(P256Scalar\) [IsValid](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L161>)

```go
func (k P256Scalar) IsValid(x *big.Int) bool
```

### func \(P256Scalar\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L132>)

```go
func (k P256Scalar) Mul(x, y *big.Int) *big.Int
```

### func \(P256Scalar\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L126>)

```go
func (k P256Scalar) Neg(x *big.Int) *big.Int
```

### func \(P256Scalar\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L147>)

```go
func (k P256Scalar) Random() (*big.Int, error)
```

### func \(P256Scalar\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ec_scalar.go#L120>)

```go
func (k P256Scalar) Sub(x, y *big.Int) *big.Int
```

## type [PairingCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L406-L412>)

PairingCurve represents a named elliptic curve that supports pairings

```go
type PairingCurve struct {
    Scalar  PairingScalar
    PointG1 PairingPoint
    PointG2 PairingPoint
    GT      Scalar
    Name    string
}
```

### func [BLS12381](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L517>)

```go
func BLS12381(preferredPoint Point) *PairingCurve
```

### func [GetPairingCurveByName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L470>)

```go
func GetPairingCurveByName(name string) *PairingCurve
```

### func \(PairingCurve\) [NewG1GeneratorPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L422>)

```go
func (c PairingCurve) NewG1GeneratorPoint() PairingPoint
```

### func \(PairingCurve\) [NewG1IdentityPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L430>)

```go
func (c PairingCurve) NewG1IdentityPoint() PairingPoint
```

### func \(PairingCurve\) [NewG2GeneratorPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L426>)

```go
func (c PairingCurve) NewG2GeneratorPoint() PairingPoint
```

### func \(PairingCurve\) [NewG2IdentityPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L434>)

```go
func (c PairingCurve) NewG2IdentityPoint() PairingPoint
```

### func \(PairingCurve\) [NewScalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L438>)

```go
func (c PairingCurve) NewScalar() PairingScalar
```

### func \(PairingCurve\) [ScalarG1BaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L414>)

```go
func (c PairingCurve) ScalarG1BaseMult(sc Scalar) PairingPoint
```

### func \(PairingCurve\) [ScalarG2BaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L418>)

```go
func (c PairingCurve) ScalarG2BaseMult(sc Scalar) PairingPoint
```

## type [PairingPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L274-L279>)

```go
type PairingPoint interface {
    Point
    OtherGroup() PairingPoint
    Pairing(rhs PairingPoint) Scalar
    MultiPairing(...PairingPoint) Scalar
}
```

## type [PairingScalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L137-L140>)

```go
type PairingScalar interface {
    Scalar
    SetPoint(p Point) PairingScalar
}
```

## type [PallasCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L52-L54>)

```go
type PallasCurve struct {
    *elliptic.CurveParams
}
```

### func [Pallas](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L78>)

```go
func Pallas() *PallasCurve
```

### func \(\*PallasCurve\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L96>)

```go
func (curve *PallasCurve) Add(x1, y1, x2, y2 *big.Int) (*big.Int, *big.Int)
```

### func \(\*PallasCurve\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L117>)

```go
func (curve *PallasCurve) Double(x1, y1 *big.Int) (*big.Int, *big.Int)
```

### func \(\*PallasCurve\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L87>)

```go
func (curve *PallasCurve) IsOnCurve(x, y *big.Int) bool
```

### func \(\*PallasCurve\) [Params](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L83>)

```go
func (curve *PallasCurve) Params() *elliptic.CurveParams
```

### func \(\*PallasCurve\) [ScalarBaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L147>)

```go
func (curve *PallasCurve) ScalarBaseMult(k []byte) (*big.Int, *big.Int)
```

### func \(\*PallasCurve\) [ScalarMult](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L130>)

```go
func (curve *PallasCurve) ScalarMult(Bx, By *big.Int, k []byte) (*big.Int, *big.Int)
```

## type [PallasScalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L159>)

PallasScalar \- Old interface

```go
type PallasScalar struct{}
```

### func [NewPallasScalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L161>)

```go
func NewPallasScalar() *PallasScalar
```

### func \(PallasScalar\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L165>)

```go
func (k PallasScalar) Add(x, y *big.Int) *big.Int
```

### func \(PallasScalar\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L195>)

```go
func (k PallasScalar) Bytes(x *big.Int) []byte
```

### func \(PallasScalar\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L185>)

```go
func (k PallasScalar) Div(x, y *big.Int) *big.Int
```

### func \(PallasScalar\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L191>)

```go
func (k PallasScalar) Hash(input []byte) *big.Int
```

### func \(PallasScalar\) [IsValid](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L204>)

```go
func (k PallasScalar) IsValid(x *big.Int) bool
```

### func \(PallasScalar\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L180>)

```go
func (k PallasScalar) Mul(x, y *big.Int) *big.Int
```

### func \(PallasScalar\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L175>)

```go
func (k PallasScalar) Neg(x *big.Int) *big.Int
```

### func \(PallasScalar\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L199>)

```go
func (k PallasScalar) Random() (*big.Int, error)
```

### func \(PallasScalar\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L170>)

```go
func (k PallasScalar) Sub(x, y *big.Int) *big.Int
```

## type [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L244-L272>)

Point represents an elliptic curve point

```go
type Point interface {
    encoding.BinaryMarshaler
    encoding.BinaryUnmarshaler
    encoding.TextMarshaler
    encoding.TextUnmarshaler
    json.Marshaler
    json.Unmarshaler
    Random(reader io.Reader) Point
    Hash(bytes []byte) Point
    Identity() Point
    Generator() Point
    IsIdentity() bool
    IsNegative() bool
    IsOnCurve() bool
    Double() Point
    Scalar() Scalar
    Neg() Point
    Add(rhs Point) Point
    Sub(rhs Point) Point
    Mul(rhs Scalar) Point
    Equal(rhs Point) bool
    Set(x, y *big.Int) (Point, error)
    ToAffineCompressed() []byte
    ToAffineUncompressed() []byte
    FromAffineCompressed(bytes []byte) (Point, error)
    FromAffineUncompressed(bytes []byte) (Point, error)
    CurveName() string
    SumOfProducts(points []Point, scalars []Scalar) Point
}
```

## type [PointBls12377G1](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L33-L35>)

```go
type PointBls12377G1 struct {
    // contains filtered or unexported fields
}
```

### func \(\*PointBls12377G1\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L405>)

```go
func (p *PointBls12377G1) Add(rhs Point) Point
```

### func \(\*PointBls12377G1\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L503>)

```go
func (p *PointBls12377G1) CurveName() string
```

### func \(\*PointBls12377G1\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L384>)

```go
func (p *PointBls12377G1) Double() Point
```

### func \(\*PointBls12377G1\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L444>)

```go
func (p *PointBls12377G1) Equal(rhs Point) bool
```

### func \(\*PointBls12377G1\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L479>)

```go
func (p *PointBls12377G1) FromAffineCompressed(bytes []byte) (Point, error)
```

### func \(\*PointBls12377G1\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L491>)

```go
func (p *PointBls12377G1) FromAffineUncompressed(bytes []byte) (Point, error)
```

### func \(\*PointBls12377G1\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L361>)

```go
func (p *PointBls12377G1) Generator() Point
```

### func \(\*PointBls12377G1\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L345>)

```go
func (p *PointBls12377G1) Hash(bytes []byte) Point
```

### func \(\*PointBls12377G1\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L354>)

```go
func (p *PointBls12377G1) Identity() Point
```

### func \(\*PointBls12377G1\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L369>)

```go
func (p *PointBls12377G1) IsIdentity() bool
```

### func \(\*PointBls12377G1\) [IsNegative](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L373>)

```go
func (p *PointBls12377G1) IsNegative() bool
```

### func \(\*PointBls12377G1\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L380>)

```go
func (p *PointBls12377G1) IsOnCurve() bool
```

### func \(\*PointBls12377G1\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L562>)

```go
func (p *PointBls12377G1) MarshalBinary() ([]byte, error)
```

### func \(\*PointBls12377G1\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L596>)

```go
func (p *PointBls12377G1) MarshalJSON() ([]byte, error)
```

### func \(\*PointBls12377G1\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L579>)

```go
func (p *PointBls12377G1) MarshalText() ([]byte, error)
```

### func \(\*PointBls12377G1\) [Modulus](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L558>)

```go
func (p *PointBls12377G1) Modulus() *big.Int
```

### func \(\*PointBls12377G1\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L431>)

```go
func (p *PointBls12377G1) Mul(rhs Scalar) Point
```

### func \(\*PointBls12377G1\) [MultiPairing](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L544>)

```go
func (p *PointBls12377G1) MultiPairing(points ...PairingPoint) Scalar
```

### func \(\*PointBls12377G1\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L399>)

```go
func (p *PointBls12377G1) Neg() Point
```

### func \(\*PointBls12377G1\) [OtherGroup](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L519>)

```go
func (p *PointBls12377G1) OtherGroup() PairingPoint
```

### func \(\*PointBls12377G1\) [Pairing](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L523>)

```go
func (p *PointBls12377G1) Pairing(rhs PairingPoint) Scalar
```

### func \(\*PointBls12377G1\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L339>)

```go
func (p *PointBls12377G1) Random(reader io.Reader) Point
```

### func \(\*PointBls12377G1\) [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L392>)

```go
func (p *PointBls12377G1) Scalar() Scalar
```

### func \(\*PointBls12377G1\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L453>)

```go
func (p *PointBls12377G1) Set(x, y *big.Int) (Point, error)
```

### func \(\*PointBls12377G1\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L418>)

```go
func (p *PointBls12377G1) Sub(rhs Point) Point
```

### func \(\*PointBls12377G1\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L507>)

```go
func (p *PointBls12377G1) SumOfProducts(points []Point, scalars []Scalar) Point
```

### func \(\*PointBls12377G1\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L469>)

```go
func (p *PointBls12377G1) ToAffineCompressed() []byte
```

### func \(\*PointBls12377G1\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L474>)

```go
func (p *PointBls12377G1) ToAffineUncompressed() []byte
```

### func \(\*PointBls12377G1\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L566>)

```go
func (p *PointBls12377G1) UnmarshalBinary(input []byte) error
```

### func \(\*PointBls12377G1\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L600>)

```go
func (p *PointBls12377G1) UnmarshalJSON(input []byte) error
```

### func \(\*PointBls12377G1\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L583>)

```go
func (p *PointBls12377G1) UnmarshalText(input []byte) error
```

### func \(\*PointBls12377G1\) [X](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L548>)

```go
func (p *PointBls12377G1) X() *big.Int
```

### func \(\*PointBls12377G1\) [Y](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L553>)

```go
func (p *PointBls12377G1) Y() *big.Int
```

## type [PointBls12377G2](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L37-L39>)

```go
type PointBls12377G2 struct {
    // contains filtered or unexported fields
}
```

### func \(\*PointBls12377G2\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L678>)

```go
func (p *PointBls12377G2) Add(rhs Point) Point
```

### func \(\*PointBls12377G2\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L776>)

```go
func (p *PointBls12377G2) CurveName() string
```

### func \(\*PointBls12377G2\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L657>)

```go
func (p *PointBls12377G2) Double() Point
```

### func \(\*PointBls12377G2\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L717>)

```go
func (p *PointBls12377G2) Equal(rhs Point) bool
```

### func \(\*PointBls12377G2\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L752>)

```go
func (p *PointBls12377G2) FromAffineCompressed(bytes []byte) (Point, error)
```

### func \(\*PointBls12377G2\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L764>)

```go
func (p *PointBls12377G2) FromAffineUncompressed(bytes []byte) (Point, error)
```

### func \(\*PointBls12377G2\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L635>)

```go
func (p *PointBls12377G2) Generator() Point
```

### func \(\*PointBls12377G2\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L619>)

```go
func (p *PointBls12377G2) Hash(bytes []byte) Point
```

### func \(\*PointBls12377G2\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L628>)

```go
func (p *PointBls12377G2) Identity() Point
```

### func \(\*PointBls12377G2\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L643>)

```go
func (p *PointBls12377G2) IsIdentity() bool
```

### func \(\*PointBls12377G2\) [IsNegative](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L647>)

```go
func (p *PointBls12377G2) IsNegative() bool
```

### func \(\*PointBls12377G2\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L653>)

```go
func (p *PointBls12377G2) IsOnCurve() bool
```

### func \(\*PointBls12377G2\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L835>)

```go
func (p *PointBls12377G2) MarshalBinary() ([]byte, error)
```

### func \(\*PointBls12377G2\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L869>)

```go
func (p *PointBls12377G2) MarshalJSON() ([]byte, error)
```

### func \(\*PointBls12377G2\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L852>)

```go
func (p *PointBls12377G2) MarshalText() ([]byte, error)
```

### func \(\*PointBls12377G2\) [Modulus](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L831>)

```go
func (p *PointBls12377G2) Modulus() *big.Int
```

### func \(\*PointBls12377G2\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L704>)

```go
func (p *PointBls12377G2) Mul(rhs Scalar) Point
```

### func \(\*PointBls12377G2\) [MultiPairing](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L817>)

```go
func (p *PointBls12377G2) MultiPairing(points ...PairingPoint) Scalar
```

### func \(\*PointBls12377G2\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L672>)

```go
func (p *PointBls12377G2) Neg() Point
```

### func \(\*PointBls12377G2\) [OtherGroup](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L792>)

```go
func (p *PointBls12377G2) OtherGroup() PairingPoint
```

### func \(\*PointBls12377G2\) [Pairing](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L796>)

```go
func (p *PointBls12377G2) Pairing(rhs PairingPoint) Scalar
```

### func \(\*PointBls12377G2\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L613>)

```go
func (p *PointBls12377G2) Random(reader io.Reader) Point
```

### func \(\*PointBls12377G2\) [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L665>)

```go
func (p *PointBls12377G2) Scalar() Scalar
```

### func \(\*PointBls12377G2\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L726>)

```go
func (p *PointBls12377G2) Set(x, y *big.Int) (Point, error)
```

### func \(\*PointBls12377G2\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L691>)

```go
func (p *PointBls12377G2) Sub(rhs Point) Point
```

### func \(\*PointBls12377G2\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L780>)

```go
func (p *PointBls12377G2) SumOfProducts(points []Point, scalars []Scalar) Point
```

### func \(\*PointBls12377G2\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L742>)

```go
func (p *PointBls12377G2) ToAffineCompressed() []byte
```

### func \(\*PointBls12377G2\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L747>)

```go
func (p *PointBls12377G2) ToAffineUncompressed() []byte
```

### func \(\*PointBls12377G2\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L839>)

```go
func (p *PointBls12377G2) UnmarshalBinary(input []byte) error
```

### func \(\*PointBls12377G2\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L873>)

```go
func (p *PointBls12377G2) UnmarshalJSON(input []byte) error
```

### func \(\*PointBls12377G2\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L856>)

```go
func (p *PointBls12377G2) UnmarshalText(input []byte) error
```

### func \(\*PointBls12377G2\) [X](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L821>)

```go
func (p *PointBls12377G2) X() *big.Int
```

### func \(\*PointBls12377G2\) [Y](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L826>)

```go
func (p *PointBls12377G2) Y() *big.Int
```

## type [PointBls12381G1](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L31-L33>)

```go
type PointBls12381G1 struct {
    // contains filtered or unexported fields
}
```

### func \(\*PointBls12381G1\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L396>)

```go
func (p *PointBls12381G1) Add(rhs Point) Point
```

### func \(\*PointBls12381G1\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L487>)

```go
func (p *PointBls12381G1) CurveName() string
```

### func \(\*PointBls12381G1\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L379>)

```go
func (p *PointBls12381G1) Double() Point
```

### func \(\*PointBls12381G1\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L435>)

```go
func (p *PointBls12381G1) Equal(rhs Point) bool
```

### func \(\*PointBls12381G1\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L471>)

```go
func (p *PointBls12381G1) FromAffineCompressed(bytes []byte) (Point, error)
```

### func \(\*PointBls12381G1\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L479>)

```go
func (p *PointBls12381G1) FromAffineUncompressed(bytes []byte) (Point, error)
```

### func \(\*PointBls12381G1\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L359>)

```go
func (p *PointBls12381G1) Generator() Point
```

### func \(\*PointBls12381G1\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L344>)

```go
func (p *PointBls12381G1) Hash(bytes []byte) Point
```

### func \(\*PointBls12381G1\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L353>)

```go
func (p *PointBls12381G1) Identity() Point
```

### func \(\*PointBls12381G1\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L365>)

```go
func (p *PointBls12381G1) IsIdentity() bool
```

### func \(\*PointBls12381G1\) [IsNegative](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L369>)

```go
func (p *PointBls12381G1) IsNegative() bool
```

### func \(\*PointBls12381G1\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L375>)

```go
func (p *PointBls12381G1) IsOnCurve() bool
```

### func \(\*PointBls12381G1\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L563>)

```go
func (p *PointBls12381G1) MarshalBinary() ([]byte, error)
```

### func \(\*PointBls12381G1\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L597>)

```go
func (p *PointBls12381G1) MarshalJSON() ([]byte, error)
```

### func \(\*PointBls12381G1\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L580>)

```go
func (p *PointBls12381G1) MarshalText() ([]byte, error)
```

### func \(\*PointBls12381G1\) [Modulus](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L559>)

```go
func (p *PointBls12381G1) Modulus() *big.Int
```

### func \(\*PointBls12381G1\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L422>)

```go
func (p *PointBls12381G1) Mul(rhs Scalar) Point
```

### func \(\*PointBls12381G1\) [MultiPairing](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L545>)

```go
func (p *PointBls12381G1) MultiPairing(points ...PairingPoint) Scalar
```

### func \(\*PointBls12381G1\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L391>)

```go
func (p *PointBls12381G1) Neg() Point
```

### func \(\*PointBls12381G1\) [OtherGroup](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L516>)

```go
func (p *PointBls12381G1) OtherGroup() PairingPoint
```

### func \(\*PointBls12381G1\) [Pairing](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L520>)

```go
func (p *PointBls12381G1) Pairing(rhs PairingPoint) Scalar
```

### func \(\*PointBls12381G1\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L338>)

```go
func (p *PointBls12381G1) Random(reader io.Reader) Point
```

### func \(\*PointBls12381G1\) [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L384>)

```go
func (p *PointBls12381G1) Scalar() Scalar
```

### func \(\*PointBls12381G1\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L444>)

```go
func (p *PointBls12381G1) Set(x, y *big.Int) (Point, error)
```

### func \(\*PointBls12381G1\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L409>)

```go
func (p *PointBls12381G1) Sub(rhs Point) Point
```

### func \(\*PointBls12381G1\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L491>)

```go
func (p *PointBls12381G1) SumOfProducts(points []Point, scalars []Scalar) Point
```

### func \(\*PointBls12381G1\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L459>)

```go
func (p *PointBls12381G1) ToAffineCompressed() []byte
```

### func \(\*PointBls12381G1\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L463>)

```go
func (p *PointBls12381G1) ToAffineUncompressed() []byte
```

### func \(\*PointBls12381G1\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L567>)

```go
func (p *PointBls12381G1) UnmarshalBinary(input []byte) error
```

### func \(\*PointBls12381G1\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L601>)

```go
func (p *PointBls12381G1) UnmarshalJSON(input []byte) error
```

### func \(\*PointBls12381G1\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L584>)

```go
func (p *PointBls12381G1) UnmarshalText(input []byte) error
```

### func \(\*PointBls12381G1\) [X](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L549>)

```go
func (p *PointBls12381G1) X() *big.Int
```

### func \(\*PointBls12381G1\) [Y](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L554>)

```go
func (p *PointBls12381G1) Y() *big.Int
```

## type [PointBls12381G2](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L35-L37>)

```go
type PointBls12381G2 struct {
    // contains filtered or unexported fields
}
```

### func \(\*PointBls12381G2\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L672>)

```go
func (p *PointBls12381G2) Add(rhs Point) Point
```

### func \(\*PointBls12381G2\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L763>)

```go
func (p *PointBls12381G2) CurveName() string
```

### func \(\*PointBls12381G2\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L655>)

```go
func (p *PointBls12381G2) Double() Point
```

### func \(\*PointBls12381G2\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L711>)

```go
func (p *PointBls12381G2) Equal(rhs Point) bool
```

### func \(\*PointBls12381G2\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L747>)

```go
func (p *PointBls12381G2) FromAffineCompressed(bytes []byte) (Point, error)
```

### func \(\*PointBls12381G2\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L755>)

```go
func (p *PointBls12381G2) FromAffineUncompressed(bytes []byte) (Point, error)
```

### func \(\*PointBls12381G2\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L635>)

```go
func (p *PointBls12381G2) Generator() Point
```

### func \(\*PointBls12381G2\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L620>)

```go
func (p *PointBls12381G2) Hash(bytes []byte) Point
```

### func \(\*PointBls12381G2\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L629>)

```go
func (p *PointBls12381G2) Identity() Point
```

### func \(\*PointBls12381G2\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L641>)

```go
func (p *PointBls12381G2) IsIdentity() bool
```

### func \(\*PointBls12381G2\) [IsNegative](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L645>)

```go
func (p *PointBls12381G2) IsNegative() bool
```

### func \(\*PointBls12381G2\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L651>)

```go
func (p *PointBls12381G2) IsOnCurve() bool
```

### func \(\*PointBls12381G2\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L839>)

```go
func (p *PointBls12381G2) MarshalBinary() ([]byte, error)
```

### func \(\*PointBls12381G2\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L873>)

```go
func (p *PointBls12381G2) MarshalJSON() ([]byte, error)
```

### func \(\*PointBls12381G2\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L856>)

```go
func (p *PointBls12381G2) MarshalText() ([]byte, error)
```

### func \(\*PointBls12381G2\) [Modulus](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L835>)

```go
func (p *PointBls12381G2) Modulus() *big.Int
```

### func \(\*PointBls12381G2\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L698>)

```go
func (p *PointBls12381G2) Mul(rhs Scalar) Point
```

### func \(\*PointBls12381G2\) [MultiPairing](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L821>)

```go
func (p *PointBls12381G2) MultiPairing(points ...PairingPoint) Scalar
```

### func \(\*PointBls12381G2\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L667>)

```go
func (p *PointBls12381G2) Neg() Point
```

### func \(\*PointBls12381G2\) [OtherGroup](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L792>)

```go
func (p *PointBls12381G2) OtherGroup() PairingPoint
```

### func \(\*PointBls12381G2\) [Pairing](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L796>)

```go
func (p *PointBls12381G2) Pairing(rhs PairingPoint) Scalar
```

### func \(\*PointBls12381G2\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L614>)

```go
func (p *PointBls12381G2) Random(reader io.Reader) Point
```

### func \(\*PointBls12381G2\) [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L660>)

```go
func (p *PointBls12381G2) Scalar() Scalar
```

### func \(\*PointBls12381G2\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L720>)

```go
func (p *PointBls12381G2) Set(x, y *big.Int) (Point, error)
```

### func \(\*PointBls12381G2\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L685>)

```go
func (p *PointBls12381G2) Sub(rhs Point) Point
```

### func \(\*PointBls12381G2\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L767>)

```go
func (p *PointBls12381G2) SumOfProducts(points []Point, scalars []Scalar) Point
```

### func \(\*PointBls12381G2\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L735>)

```go
func (p *PointBls12381G2) ToAffineCompressed() []byte
```

### func \(\*PointBls12381G2\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L739>)

```go
func (p *PointBls12381G2) ToAffineUncompressed() []byte
```

### func \(\*PointBls12381G2\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L843>)

```go
func (p *PointBls12381G2) UnmarshalBinary(input []byte) error
```

### func \(\*PointBls12381G2\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L877>)

```go
func (p *PointBls12381G2) UnmarshalJSON(input []byte) error
```

### func \(\*PointBls12381G2\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L860>)

```go
func (p *PointBls12381G2) UnmarshalText(input []byte) error
```

### func \(\*PointBls12381G2\) [X](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L825>)

```go
func (p *PointBls12381G2) X() *big.Int
```

### func \(\*PointBls12381G2\) [Y](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L830>)

```go
func (p *PointBls12381G2) Y() *big.Int
```

## type [PointEd25519](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L27-L29>)

```go
type PointEd25519 struct {
    // contains filtered or unexported fields
}
```

### func \(\*PointEd25519\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L416>)

```go
func (p *PointEd25519) Add(rhs Point) Point
```

### func \(\*PointEd25519\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L606>)

```go
func (p *PointEd25519) CurveName() string
```

### func \(\*PointEd25519\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L404>)

```go
func (p *PointEd25519) Double() Point
```

### func \(\*PointEd25519\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L468>)

```go
func (p *PointEd25519) Equal(rhs Point) bool
```

### func \(\*PointEd25519\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L574>)

```go
func (p *PointEd25519) FromAffineCompressed(inBytes []byte) (Point, error)
```

### func \(\*PointEd25519\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L582>)

```go
func (p *PointEd25519) FromAffineUncompressed(inBytes []byte) (Point, error)
```

### func \(\*PointEd25519\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L384>)

```go
func (p *PointEd25519) Generator() Point
```

### func \(\*PointEd25519\) [GetEdwardsPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L699>)

```go
func (p *PointEd25519) GetEdwardsPoint() *edwards25519.Point
```

### func \(\*PointEd25519\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L363>)

```go
func (p *PointEd25519) Hash(bytes []byte) Point
```

### func \(\*PointEd25519\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L378>)

```go
func (p *PointEd25519) Identity() Point
```

### func \(\*PointEd25519\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L390>)

```go
func (p *PointEd25519) IsIdentity() bool
```

### func \(\*PointEd25519\) [IsNegative](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L394>)

```go
func (p *PointEd25519) IsNegative() bool
```

### func \(\*PointEd25519\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L399>)

```go
func (p *PointEd25519) IsOnCurve() bool
```

### func \(\*PointEd25519\) [MangleScalarBitsAndMulByBasepointToProducePublicKey](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L458>)

```go
func (p *PointEd25519) MangleScalarBitsAndMulByBasepointToProducePublicKey(rhs *ScalarEd25519) *PointEd25519
```

MangleScalarBitsAndMulByBasepointToProducePublicKey is a function for mangling the bits of a \(formerly mathematically well\-defined\) "scalar" and multiplying it to produce a public key\.

### func \(\*PointEd25519\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L648>)

```go
func (p *PointEd25519) MarshalBinary() ([]byte, error)
```

### func \(\*PointEd25519\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L682>)

```go
func (p *PointEd25519) MarshalJSON() ([]byte, error)
```

### func \(\*PointEd25519\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L665>)

```go
func (p *PointEd25519) MarshalText() ([]byte, error)
```

### func \(\*PointEd25519\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L441>)

```go
func (p *PointEd25519) Mul(rhs Scalar) Point
```

### func \(\*PointEd25519\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L412>)

```go
func (p *PointEd25519) Neg() Point
```

### func \(\*PointEd25519\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L357>)

```go
func (p *PointEd25519) Random(reader io.Reader) Point
```

### func \(\*PointEd25519\) [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L408>)

```go
func (p *PointEd25519) Scalar() Scalar
```

### func \(\*PointEd25519\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L488>)

```go
func (p *PointEd25519) Set(x, y *big.Int) (Point, error)
```

### func \(\*PointEd25519\) [SetEdwardsPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L703>)

```go
func (p *PointEd25519) SetEdwardsPoint(pt *edwards25519.Point) *PointEd25519
```

### func \(\*PointEd25519\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L428>)

```go
func (p *PointEd25519) Sub(rhs Point) Point
```

### func \(\*PointEd25519\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L610>)

```go
func (p *PointEd25519) SumOfProducts(points []Point, scalars []Scalar) Point
```

### func \(\*PointEd25519\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L559>)

```go
func (p *PointEd25519) ToAffineCompressed() []byte
```

### func \(\*PointEd25519\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L563>)

```go
func (p *PointEd25519) ToAffineUncompressed() []byte
```

### func \(\*PointEd25519\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L652>)

```go
func (p *PointEd25519) UnmarshalBinary(input []byte) error
```

### func \(\*PointEd25519\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L686>)

```go
func (p *PointEd25519) UnmarshalJSON(input []byte) error
```

### func \(\*PointEd25519\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L669>)

```go
func (p *PointEd25519) UnmarshalText(input []byte) error
```

### func \(\*PointEd25519\) [VarTimeDoubleScalarBaseMult](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L631>)

```go
func (p *PointEd25519) VarTimeDoubleScalarBaseMult(a Scalar, A Point, b Scalar) Point
```

## type [PointK256](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L24-L26>)

```go
type PointK256 struct {
    // contains filtered or unexported fields
}
```

### func \(\*PointK256\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L367>)

```go
func (p *PointK256) Add(rhs Point) Point
```

### func \(\*PointK256\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L489>)

```go
func (p *PointK256) CurveName() string
```

### func \(\*PointK256\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L352>)

```go
func (p *PointK256) Double() Point
```

### func \(\*PointK256\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L406>)

```go
func (p *PointK256) Equal(rhs Point) bool
```

### func \(\*PointK256\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L447>)

```go
func (p *PointK256) FromAffineCompressed(bytes []byte) (Point, error)
```

### func \(\*PointK256\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L477>)

```go
func (p *PointK256) FromAffineUncompressed(bytes []byte) (Point, error)
```

### func \(\*PointK256\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L330>)

```go
func (p *PointK256) Generator() Point
```

### func \(\*PointK256\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L298>)

```go
func (p *PointK256) Hash(bytes []byte) Point
```

### func \(\*PointK256\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L324>)

```go
func (p *PointK256) Identity() Point
```

### func \(\*PointK256\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L338>)

```go
func (p *PointK256) IsIdentity() bool
```

### func \(\*PointK256\) [IsNegative](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L344>)

```go
func (p *PointK256) IsNegative() bool
```

### func \(\*PointK256\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L348>)

```go
func (p *PointK256) IsOnCurve() bool
```

### func \(\*PointK256\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L517>)

```go
func (p *PointK256) MarshalBinary() ([]byte, error)
```

### func \(\*PointK256\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L553>)

```go
func (p *PointK256) MarshalJSON() ([]byte, error)
```

### func \(\*PointK256\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L535>)

```go
func (p *PointK256) MarshalText() ([]byte, error)
```

### func \(\*PointK256\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L393>)

```go
func (p *PointK256) Mul(rhs Scalar) Point
```

### func \(\*PointK256\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L361>)

```go
func (p *PointK256) Neg() Point
```

### func \(\*PointK256\) [Params](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L513>)

```go
func (p *PointK256) Params() *elliptic.CurveParams
```

### func \(\*PointK256\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L292>)

```go
func (p *PointK256) Random(reader io.Reader) Point
```

### func \(\*PointK256\) [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L357>)

```go
func (p *PointK256) Scalar() Scalar
```

### func \(\*PointK256\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L417>)

```go
func (p *PointK256) Set(x, y *big.Int) (Point, error)
```

### func \(\*PointK256\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L380>)

```go
func (p *PointK256) Sub(rhs Point) Point
```

### func \(\*PointK256\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L493>)

```go
func (p *PointK256) SumOfProducts(points []Point, scalars []Scalar) Point
```

### func \(\*PointK256\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L431>)

```go
func (p *PointK256) ToAffineCompressed() []byte
```

### func \(\*PointK256\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L439>)

```go
func (p *PointK256) ToAffineUncompressed() []byte
```

### func \(\*PointK256\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L521>)

```go
func (p *PointK256) UnmarshalBinary(input []byte) error
```

### func \(\*PointK256\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L557>)

```go
func (p *PointK256) UnmarshalJSON(input []byte) error
```

### func \(\*PointK256\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L539>)

```go
func (p *PointK256) UnmarshalText(input []byte) error
```

### func \(\*PointK256\) [X](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L505>)

```go
func (p *PointK256) X() *big.Int
```

### func \(\*PointK256\) [Y](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L509>)

```go
func (p *PointK256) Y() *big.Int
```

## type [PointP256](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L23-L25>)

```go
type PointP256 struct {
    // contains filtered or unexported fields
}
```

### func \(\*PointP256\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L365>)

```go
func (p *PointP256) Add(rhs Point) Point
```

### func \(\*PointP256\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L487>)

```go
func (p *PointP256) CurveName() string
```

### func \(\*PointP256\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L349>)

```go
func (p *PointP256) Double() Point
```

### func \(\*PointP256\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L404>)

```go
func (p *PointP256) Equal(rhs Point) bool
```

### func \(\*PointP256\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L445>)

```go
func (p *PointP256) FromAffineCompressed(bytes []byte) (Point, error)
```

### func \(\*PointP256\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L475>)

```go
func (p *PointP256) FromAffineUncompressed(bytes []byte) (Point, error)
```

### func \(\*PointP256\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L327>)

```go
func (p *PointP256) Generator() Point
```

### func \(\*PointP256\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L297>)

```go
func (p *PointP256) Hash(bytes []byte) Point
```

### func \(\*PointP256\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L321>)

```go
func (p *PointP256) Identity() Point
```

### func \(\*PointP256\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L335>)

```go
func (p *PointP256) IsIdentity() bool
```

### func \(\*PointP256\) [IsNegative](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L341>)

```go
func (p *PointP256) IsNegative() bool
```

### func \(\*PointP256\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L345>)

```go
func (p *PointP256) IsOnCurve() bool
```

### func \(\*PointP256\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L515>)

```go
func (p *PointP256) MarshalBinary() ([]byte, error)
```

### func \(\*PointP256\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L551>)

```go
func (p *PointP256) MarshalJSON() ([]byte, error)
```

### func \(\*PointP256\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L533>)

```go
func (p *PointP256) MarshalText() ([]byte, error)
```

### func \(\*PointP256\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L391>)

```go
func (p *PointP256) Mul(rhs Scalar) Point
```

### func \(\*PointP256\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L359>)

```go
func (p *PointP256) Neg() Point
```

### func \(\*PointP256\) [Params](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L511>)

```go
func (p *PointP256) Params() *elliptic.CurveParams
```

### func \(\*PointP256\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L291>)

```go
func (p *PointP256) Random(reader io.Reader) Point
```

### func \(\*PointP256\) [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L355>)

```go
func (p *PointP256) Scalar() Scalar
```

### func \(\*PointP256\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L415>)

```go
func (p *PointP256) Set(x, y *big.Int) (Point, error)
```

### func \(\*PointP256\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L378>)

```go
func (p *PointP256) Sub(rhs Point) Point
```

### func \(\*PointP256\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L491>)

```go
func (p *PointP256) SumOfProducts(points []Point, scalars []Scalar) Point
```

### func \(\*PointP256\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L429>)

```go
func (p *PointP256) ToAffineCompressed() []byte
```

### func \(\*PointP256\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L437>)

```go
func (p *PointP256) ToAffineUncompressed() []byte
```

### func \(\*PointP256\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L519>)

```go
func (p *PointP256) UnmarshalBinary(input []byte) error
```

### func \(\*PointP256\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L555>)

```go
func (p *PointP256) UnmarshalJSON(input []byte) error
```

### func \(\*PointP256\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L537>)

```go
func (p *PointP256) UnmarshalText(input []byte) error
```

### func \(\*PointP256\) [X](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L503>)

```go
func (p *PointP256) X() *big.Int
```

### func \(\*PointP256\) [Y](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L507>)

```go
func (p *PointP256) Y() *big.Int
```

## type [PointPallas](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L487-L489>)

```go
type PointPallas struct {
    // contains filtered or unexported fields
}
```

### func \(\*PointPallas\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L531>)

```go
func (p *PointPallas) Add(rhs Point) Point
```

### func \(\*PointPallas\) [CurveName](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L607>)

```go
func (p *PointPallas) CurveName() string
```

### func \(\*PointPallas\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L519>)

```go
func (p *PointPallas) Double() Point
```

### func \(\*PointPallas\) [Equal](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L555>)

```go
func (p *PointPallas) Equal(rhs Point) bool
```

### func \(\*PointPallas\) [FromAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L591>)

```go
func (p *PointPallas) FromAffineCompressed(bytes []byte) (Point, error)
```

### func \(\*PointPallas\) [FromAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L599>)

```go
func (p *PointPallas) FromAffineUncompressed(bytes []byte) (Point, error)
```

### func \(\*PointPallas\) [Generator](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L503>)

```go
func (p *PointPallas) Generator() Point
```

### func \(\*PointPallas\) [GetEp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L683>)

```go
func (p *PointPallas) GetEp() *Ep
```

### func \(\*PointPallas\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L495>)

```go
func (p *PointPallas) Hash(bytes []byte) Point
```

### func \(\*PointPallas\) [Identity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L499>)

```go
func (p *PointPallas) Identity() Point
```

### func \(\*PointPallas\) [IsIdentity](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L507>)

```go
func (p *PointPallas) IsIdentity() bool
```

### func \(\*PointPallas\) [IsNegative](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L511>)

```go
func (p *PointPallas) IsNegative() bool
```

### func \(\*PointPallas\) [IsOnCurve](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L515>)

```go
func (p *PointPallas) IsOnCurve() bool
```

### func \(\*PointPallas\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L624>)

```go
func (p *PointPallas) MarshalBinary() ([]byte, error)
```

### func \(\*PointPallas\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L658>)

```go
func (p *PointPallas) MarshalJSON() ([]byte, error)
```

### func \(\*PointPallas\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L641>)

```go
func (p *PointPallas) MarshalText() ([]byte, error)
```

### func \(\*PointPallas\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L547>)

```go
func (p *PointPallas) Mul(rhs Scalar) Point
```

### func \(\*PointPallas\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L527>)

```go
func (p *PointPallas) Neg() Point
```

### func \(\*PointPallas\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L491>)

```go
func (p *PointPallas) Random(reader io.Reader) Point
```

### func \(\*PointPallas\) [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L523>)

```go
func (p *PointPallas) Scalar() Scalar
```

### func \(\*PointPallas\) [Set](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L563>)

```go
func (p *PointPallas) Set(x, y *big.Int) (Point, error)
```

### func \(\*PointPallas\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L539>)

```go
func (p *PointPallas) Sub(rhs Point) Point
```

### func \(\*PointPallas\) [SumOfProducts](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L611>)

```go
func (p *PointPallas) SumOfProducts(points []Point, scalars []Scalar) Point
```

### func \(\*PointPallas\) [ToAffineCompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L583>)

```go
func (p *PointPallas) ToAffineCompressed() []byte
```

### func \(\*PointPallas\) [ToAffineUncompressed](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L587>)

```go
func (p *PointPallas) ToAffineUncompressed() []byte
```

### func \(\*PointPallas\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L628>)

```go
func (p *PointPallas) UnmarshalBinary(input []byte) error
```

### func \(\*PointPallas\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L662>)

```go
func (p *PointPallas) UnmarshalJSON(input []byte) error
```

### func \(\*PointPallas\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L645>)

```go
func (p *PointPallas) UnmarshalText(input []byte) error
```

### func \(\*PointPallas\) [X](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L675>)

```go
func (p *PointPallas) X() *fp.Fp
```

### func \(\*PointPallas\) [Y](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L679>)

```go
func (p *PointPallas) Y() *fp.Fp
```

## type [Scalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/curve.go#L66-L135>)

Scalar represents an element of the scalar field \\mathbb\{F\}\_q of the elliptic curve construction\.

```go
type Scalar interface {
    encoding.BinaryMarshaler
    encoding.BinaryUnmarshaler
    encoding.TextMarshaler
    encoding.TextUnmarshaler
    json.Marshaler
    json.Unmarshaler
    // Random returns a random scalar using the provided reader
    // to retrieve bytes
    Random(reader io.Reader) Scalar
    // Hash the specific bytes in a manner to yield a
    // uniformly distributed scalar
    Hash(bytes []byte) Scalar
    // Zero returns the additive identity element
    Zero() Scalar
    // One returns the multiplicative identity element
    One() Scalar
    // IsZero returns true if this element is the additive identity element
    IsZero() bool
    // IsOne returns true if this element is the multiplicative identity element
    IsOne() bool
    // IsOdd returns true if this element is odd
    IsOdd() bool
    // IsEven returns true if this element is even
    IsEven() bool
    // New returns an element with the value equal to `value`
    New(value int) Scalar
    // Cmp returns
    // -2 if this element is in a different field than rhs
    // -1 if this element is less than rhs
    // 0 if this element is equal to rhs
    // 1 if this element is greater than rhs
    Cmp(rhs Scalar) int
    // Square returns element*element
    Square() Scalar
    // Double returns element+element
    Double() Scalar
    // Invert returns element^-1 mod p
    Invert() (Scalar, error)
    // Sqrt computes the square root of this element if it exists.
    Sqrt() (Scalar, error)
    // Cube returns element*element*element
    Cube() Scalar
    // Add returns element+rhs
    Add(rhs Scalar) Scalar
    // Sub returns element-rhs
    Sub(rhs Scalar) Scalar
    // Mul returns element*rhs
    Mul(rhs Scalar) Scalar
    // MulAdd returns element * y + z mod p
    MulAdd(y, z Scalar) Scalar
    // Div returns element*rhs^-1 mod p
    Div(rhs Scalar) Scalar
    // Neg returns -element mod p
    Neg() Scalar
    // SetBigInt returns this element set to the value of v
    SetBigInt(v *big.Int) (Scalar, error)
    // BigInt returns this element as a big integer
    BigInt() *big.Int
    // Point returns the associated point for this scalar
    Point() Point
    // Bytes returns the canonical byte representation of this scalar
    Bytes() []byte
    // SetBytes creates a scalar from the canonical representation expecting the exact number of bytes needed to represent the scalar
    SetBytes(bytes []byte) (Scalar, error)
    // SetBytesWide creates a scalar expecting double the exact number of bytes needed to represent the scalar which is reduced by the modulus
    SetBytesWide(bytes []byte) (Scalar, error)
    // Clone returns a cloned Scalar of this value
    Clone() Scalar
}
```

## type [ScalarBls12377](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L28-L31>)

```go
type ScalarBls12377 struct {
    // contains filtered or unexported fields
}
```

### func \(\*ScalarBls12377\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L152>)

```go
func (s *ScalarBls12377) Add(rhs Scalar) Scalar
```

### func \(\*ScalarBls12377\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L231>)

```go
func (s *ScalarBls12377) BigInt() *big.Int
```

### func \(\*ScalarBls12377\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L235>)

```go
func (s *ScalarBls12377) Bytes() []byte
```

### func \(\*ScalarBls12377\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L268>)

```go
func (s *ScalarBls12377) Clone() Scalar
```

### func \(\*ScalarBls12377\) [Cmp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L107>)

```go
func (s *ScalarBls12377) Cmp(rhs Scalar) int
```

### func \(\*ScalarBls12377\) [Cube](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L145>)

```go
func (s *ScalarBls12377) Cube() Scalar
```

### func \(\*ScalarBls12377\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L195>)

```go
func (s *ScalarBls12377) Div(rhs Scalar) Scalar
```

### func \(\*ScalarBls12377\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L123>)

```go
func (s *ScalarBls12377) Double() Scalar
```

### func \(\*ScalarBls12377\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L54>)

```go
func (s *ScalarBls12377) Hash(bytes []byte) Scalar
```

### func \(\*ScalarBls12377\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L131>)

```go
func (s *ScalarBls12377) Invert() (Scalar, error)
```

### func \(\*ScalarBls12377\) [IsEven](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L92>)

```go
func (s *ScalarBls12377) IsEven() bool
```

### func \(\*ScalarBls12377\) [IsOdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L88>)

```go
func (s *ScalarBls12377) IsOdd() bool
```

### func \(\*ScalarBls12377\) [IsOne](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L84>)

```go
func (s *ScalarBls12377) IsOne() bool
```

### func \(\*ScalarBls12377\) [IsZero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L80>)

```go
func (s *ScalarBls12377) IsZero() bool
```

### func \(\*ScalarBls12377\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L286>)

```go
func (s *ScalarBls12377) MarshalBinary() ([]byte, error)
```

### func \(\*ScalarBls12377\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L322>)

```go
func (s *ScalarBls12377) MarshalJSON() ([]byte, error)
```

### func \(\*ScalarBls12377\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L304>)

```go
func (s *ScalarBls12377) MarshalText() ([]byte, error)
```

### func \(\*ScalarBls12377\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L178>)

```go
func (s *ScalarBls12377) Mul(rhs Scalar) Scalar
```

### func \(\*ScalarBls12377\) [MulAdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L191>)

```go
func (s *ScalarBls12377) MulAdd(y, z Scalar) Scalar
```

### func \(\*ScalarBls12377\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L209>)

```go
func (s *ScalarBls12377) Neg() Scalar
```

### func \(\*ScalarBls12377\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L96>)

```go
func (s *ScalarBls12377) New(value int) Scalar
```

### func \(\*ScalarBls12377\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L73>)

```go
func (s *ScalarBls12377) One() Scalar
```

### func \(\*ScalarBls12377\) [Order](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L282>)

```go
func (s *ScalarBls12377) Order() *big.Int
```

### func \(\*ScalarBls12377\) [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L264>)

```go
func (s *ScalarBls12377) Point() Point
```

### func \(\*ScalarBls12377\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L45>)

```go
func (s *ScalarBls12377) Random(reader io.Reader) Scalar
```

### func \(\*ScalarBls12377\) [SetBigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L217>)

```go
func (s *ScalarBls12377) SetBigInt(v *big.Int) (Scalar, error)
```

### func \(\*ScalarBls12377\) [SetBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L240>)

```go
func (s *ScalarBls12377) SetBytes(bytes []byte) (Scalar, error)
```

### func \(\*ScalarBls12377\) [SetBytesWide](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L252>)

```go
func (s *ScalarBls12377) SetBytesWide(bytes []byte) (Scalar, error)
```

### func \(\*ScalarBls12377\) [SetPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L275>)

```go
func (s *ScalarBls12377) SetPoint(p Point) PairingScalar
```

### func \(\*ScalarBls12377\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L138>)

```go
func (s *ScalarBls12377) Sqrt() (Scalar, error)
```

### func \(\*ScalarBls12377\) [Square](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L116>)

```go
func (s *ScalarBls12377) Square() Scalar
```

### func \(\*ScalarBls12377\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L165>)

```go
func (s *ScalarBls12377) Sub(rhs Scalar) Scalar
```

### func \(\*ScalarBls12377\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L290>)

```go
func (s *ScalarBls12377) UnmarshalBinary(input []byte) error
```

### func \(\*ScalarBls12377\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L326>)

```go
func (s *ScalarBls12377) UnmarshalJSON(input []byte) error
```

### func \(\*ScalarBls12377\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L308>)

```go
func (s *ScalarBls12377) UnmarshalText(input []byte) error
```

### func \(\*ScalarBls12377\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L66>)

```go
func (s *ScalarBls12377) Zero() Scalar
```

## type [ScalarBls12377Gt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L41-L43>)

```go
type ScalarBls12377Gt struct {
    // contains filtered or unexported fields
}
```

### func \(\*ScalarBls12377Gt\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1097>)

```go
func (s *ScalarBls12377Gt) Add(rhs Scalar) Scalar
```

### func \(\*ScalarBls12377Gt\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1168>)

```go
func (s *ScalarBls12377Gt) BigInt() *big.Int
```

### func \(\*ScalarBls12377Gt\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1178>)

```go
func (s *ScalarBls12377Gt) Bytes() []byte
```

### func \(\*ScalarBls12377Gt\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1211>)

```go
func (s *ScalarBls12377Gt) Clone() Scalar
```

### func \(\*ScalarBls12377Gt\) [Cmp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1053>)

```go
func (s *ScalarBls12377Gt) Cmp(rhs Scalar) int
```

### func \(\*ScalarBls12377Gt\) [Cube](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1088>)

```go
func (s *ScalarBls12377Gt) Cube() Scalar
```

### func \(\*ScalarBls12377Gt\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1137>)

```go
func (s *ScalarBls12377Gt) Div(rhs Scalar) Scalar
```

### func \(\*ScalarBls12377Gt\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1069>)

```go
func (s *ScalarBls12377Gt) Double() Scalar
```

### func \(\*ScalarBls12377Gt\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L939>)

```go
func (s *ScalarBls12377Gt) Hash(bytes []byte) Scalar
```

### func \(\*ScalarBls12377Gt\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1076>)

```go
func (s *ScalarBls12377Gt) Invert() (Scalar, error)
```

### func \(\*ScalarBls12377Gt\) [IsEven](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1033>)

```go
func (s *ScalarBls12377Gt) IsEven() bool
```

### func \(\*ScalarBls12377Gt\) [IsOdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1028>)

```go
func (s *ScalarBls12377Gt) IsOdd() bool
```

### func \(\*ScalarBls12377Gt\) [IsOne](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L972>)

```go
func (s *ScalarBls12377Gt) IsOne() bool
```

### func \(\*ScalarBls12377Gt\) [IsZero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L963>)

```go
func (s *ScalarBls12377Gt) IsZero() bool
```

### func \(\*ScalarBls12377Gt\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L977>)

```go
func (s *ScalarBls12377Gt) MarshalBinary() ([]byte, error)
```

### func \(\*ScalarBls12377Gt\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1011>)

```go
func (s *ScalarBls12377Gt) MarshalJSON() ([]byte, error)
```

### func \(\*ScalarBls12377Gt\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L994>)

```go
func (s *ScalarBls12377Gt) MarshalText() ([]byte, error)
```

### func \(\*ScalarBls12377Gt\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1121>)

```go
func (s *ScalarBls12377Gt) Mul(rhs Scalar) Scalar
```

### func \(\*ScalarBls12377Gt\) [MulAdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1133>)

```go
func (s *ScalarBls12377Gt) MulAdd(y, z Scalar) Scalar
```

### func \(\*ScalarBls12377Gt\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1151>)

```go
func (s *ScalarBls12377Gt) Neg() Scalar
```

### func \(\*ScalarBls12377Gt\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1038>)

```go
func (s *ScalarBls12377Gt) New(input int) Scalar
```

### func \(\*ScalarBls12377Gt\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L958>)

```go
func (s *ScalarBls12377Gt) One() Scalar
```

### func \(\*ScalarBls12377Gt\) [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1173>)

```go
func (s *ScalarBls12377Gt) Point() Point
```

### func \(\*ScalarBls12377Gt\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L919>)

```go
func (s *ScalarBls12377Gt) Random(reader io.Reader) Scalar
```

### func \(\*ScalarBls12377Gt\) [SetBigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1162>)

```go
func (s *ScalarBls12377Gt) SetBigInt(v *big.Int) (Scalar, error)
```

### func \(\*ScalarBls12377Gt\) [SetBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1183>)

```go
func (s *ScalarBls12377Gt) SetBytes(bytes []byte) (Scalar, error)
```

### func \(\*ScalarBls12377Gt\) [SetBytesWide](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1192>)

```go
func (s *ScalarBls12377Gt) SetBytesWide(bytes []byte) (Scalar, error)
```

### func \(\*ScalarBls12377Gt\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1083>)

```go
func (s *ScalarBls12377Gt) Sqrt() (Scalar, error)
```

### func \(\*ScalarBls12377Gt\) [Square](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1062>)

```go
func (s *ScalarBls12377Gt) Square() Scalar
```

### func \(\*ScalarBls12377Gt\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1109>)

```go
func (s *ScalarBls12377Gt) Sub(rhs Scalar) Scalar
```

### func \(\*ScalarBls12377Gt\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L981>)

```go
func (s *ScalarBls12377Gt) UnmarshalBinary(input []byte) error
```

### func \(\*ScalarBls12377Gt\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L1015>)

```go
func (s *ScalarBls12377Gt) UnmarshalJSON(input []byte) error
```

### func \(\*ScalarBls12377Gt\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L998>)

```go
func (s *ScalarBls12377Gt) UnmarshalText(input []byte) error
```

### func \(\*ScalarBls12377Gt\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12377_curve.go#L948>)

```go
func (s *ScalarBls12377Gt) Zero() Scalar
```

## type [ScalarBls12381](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L26-L29>)

```go
type ScalarBls12381 struct {
    // contains filtered or unexported fields
}
```

### func \(\*ScalarBls12381\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L150>)

```go
func (s *ScalarBls12381) Add(rhs Scalar) Scalar
```

### func \(\*ScalarBls12381\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L230>)

```go
func (s *ScalarBls12381) BigInt() *big.Int
```

### func \(\*ScalarBls12381\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L234>)

```go
func (s *ScalarBls12381) Bytes() []byte
```

### func \(\*ScalarBls12381\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L267>)

```go
func (s *ScalarBls12381) Clone() Scalar
```

### func \(\*ScalarBls12381\) [Cmp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L105>)

```go
func (s *ScalarBls12381) Cmp(rhs Scalar) int
```

### func \(\*ScalarBls12381\) [Cube](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L143>)

```go
func (s *ScalarBls12381) Cube() Scalar
```

### func \(\*ScalarBls12381\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L193>)

```go
func (s *ScalarBls12381) Div(rhs Scalar) Scalar
```

### func \(\*ScalarBls12381\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L121>)

```go
func (s *ScalarBls12381) Double() Scalar
```

### func \(\*ScalarBls12381\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L52>)

```go
func (s *ScalarBls12381) Hash(bytes []byte) Scalar
```

### func \(\*ScalarBls12381\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L129>)

```go
func (s *ScalarBls12381) Invert() (Scalar, error)
```

### func \(\*ScalarBls12381\) [IsEven](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L90>)

```go
func (s *ScalarBls12381) IsEven() bool
```

### func \(\*ScalarBls12381\) [IsOdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L86>)

```go
func (s *ScalarBls12381) IsOdd() bool
```

### func \(\*ScalarBls12381\) [IsOne](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L82>)

```go
func (s *ScalarBls12381) IsOne() bool
```

### func \(\*ScalarBls12381\) [IsZero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L78>)

```go
func (s *ScalarBls12381) IsZero() bool
```

### func \(\*ScalarBls12381\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L285>)

```go
func (s *ScalarBls12381) MarshalBinary() ([]byte, error)
```

### func \(\*ScalarBls12381\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L321>)

```go
func (s *ScalarBls12381) MarshalJSON() ([]byte, error)
```

### func \(\*ScalarBls12381\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L303>)

```go
func (s *ScalarBls12381) MarshalText() ([]byte, error)
```

### func \(\*ScalarBls12381\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L176>)

```go
func (s *ScalarBls12381) Mul(rhs Scalar) Scalar
```

### func \(\*ScalarBls12381\) [MulAdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L189>)

```go
func (s *ScalarBls12381) MulAdd(y, z Scalar) Scalar
```

### func \(\*ScalarBls12381\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L208>)

```go
func (s *ScalarBls12381) Neg() Scalar
```

### func \(\*ScalarBls12381\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L94>)

```go
func (s *ScalarBls12381) New(value int) Scalar
```

### func \(\*ScalarBls12381\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L71>)

```go
func (s *ScalarBls12381) One() Scalar
```

### func \(\*ScalarBls12381\) [Order](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L281>)

```go
func (s *ScalarBls12381) Order() *big.Int
```

### func \(\*ScalarBls12381\) [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L263>)

```go
func (s *ScalarBls12381) Point() Point
```

### func \(\*ScalarBls12381\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L43>)

```go
func (s *ScalarBls12381) Random(reader io.Reader) Scalar
```

### func \(\*ScalarBls12381\) [SetBigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L216>)

```go
func (s *ScalarBls12381) SetBigInt(v *big.Int) (Scalar, error)
```

### func \(\*ScalarBls12381\) [SetBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L239>)

```go
func (s *ScalarBls12381) SetBytes(bytes []byte) (Scalar, error)
```

### func \(\*ScalarBls12381\) [SetBytesWide](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L251>)

```go
func (s *ScalarBls12381) SetBytesWide(bytes []byte) (Scalar, error)
```

### func \(\*ScalarBls12381\) [SetPoint](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L274>)

```go
func (s *ScalarBls12381) SetPoint(p Point) PairingScalar
```

### func \(\*ScalarBls12381\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L136>)

```go
func (s *ScalarBls12381) Sqrt() (Scalar, error)
```

### func \(\*ScalarBls12381\) [Square](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L114>)

```go
func (s *ScalarBls12381) Square() Scalar
```

### func \(\*ScalarBls12381\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L163>)

```go
func (s *ScalarBls12381) Sub(rhs Scalar) Scalar
```

### func \(\*ScalarBls12381\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L289>)

```go
func (s *ScalarBls12381) UnmarshalBinary(input []byte) error
```

### func \(\*ScalarBls12381\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L325>)

```go
func (s *ScalarBls12381) UnmarshalJSON(input []byte) error
```

### func \(\*ScalarBls12381\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L307>)

```go
func (s *ScalarBls12381) UnmarshalText(input []byte) error
```

### func \(\*ScalarBls12381\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L64>)

```go
func (s *ScalarBls12381) Zero() Scalar
```

## type [ScalarBls12381Gt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L39-L41>)

```go
type ScalarBls12381Gt struct {
    // contains filtered or unexported fields
}
```

### func \(\*ScalarBls12381Gt\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1115>)

```go
func (s *ScalarBls12381Gt) Add(rhs Scalar) Scalar
```

### func \(\*ScalarBls12381Gt\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1186>)

```go
func (s *ScalarBls12381Gt) BigInt() *big.Int
```

### func \(\*ScalarBls12381Gt\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1194>)

```go
func (s *ScalarBls12381Gt) Bytes() []byte
```

### func \(\*ScalarBls12381Gt\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1223>)

```go
func (s *ScalarBls12381Gt) Clone() Scalar
```

### func \(\*ScalarBls12381Gt\) [Cmp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1068>)

```go
func (s *ScalarBls12381Gt) Cmp(rhs Scalar) int
```

### func \(\*ScalarBls12381Gt\) [Cube](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1106>)

```go
func (s *ScalarBls12381Gt) Cube() Scalar
```

### func \(\*ScalarBls12381Gt\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1158>)

```go
func (s *ScalarBls12381Gt) Div(rhs Scalar) Scalar
```

### func \(\*ScalarBls12381Gt\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1085>)

```go
func (s *ScalarBls12381Gt) Double() Scalar
```

### func \(\*ScalarBls12381Gt\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L940>)

```go
func (s *ScalarBls12381Gt) Hash(bytes []byte) Scalar
```

### func \(\*ScalarBls12381Gt\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1093>)

```go
func (s *ScalarBls12381Gt) Invert() (Scalar, error)
```

### func \(\*ScalarBls12381Gt\) [IsEven](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1049>)

```go
func (s *ScalarBls12381Gt) IsEven() bool
```

### func \(\*ScalarBls12381Gt\) [IsOdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1044>)

```go
func (s *ScalarBls12381Gt) IsOdd() bool
```

### func \(\*ScalarBls12381Gt\) [IsOne](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L989>)

```go
func (s *ScalarBls12381Gt) IsOne() bool
```

### func \(\*ScalarBls12381Gt\) [IsZero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L985>)

```go
func (s *ScalarBls12381Gt) IsZero() bool
```

### func \(\*ScalarBls12381Gt\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L993>)

```go
func (s *ScalarBls12381Gt) MarshalBinary() ([]byte, error)
```

### func \(\*ScalarBls12381Gt\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1027>)

```go
func (s *ScalarBls12381Gt) MarshalJSON() ([]byte, error)
```

### func \(\*ScalarBls12381Gt\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1010>)

```go
func (s *ScalarBls12381Gt) MarshalText() ([]byte, error)
```

### func \(\*ScalarBls12381Gt\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1141>)

```go
func (s *ScalarBls12381Gt) Mul(rhs Scalar) Scalar
```

### func \(\*ScalarBls12381Gt\) [MulAdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1154>)

```go
func (s *ScalarBls12381Gt) MulAdd(y, z Scalar) Scalar
```

### func \(\*ScalarBls12381Gt\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1172>)

```go
func (s *ScalarBls12381Gt) Neg() Scalar
```

### func \(\*ScalarBls12381Gt\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1054>)

```go
func (s *ScalarBls12381Gt) New(input int) Scalar
```

### func \(\*ScalarBls12381Gt\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L981>)

```go
func (s *ScalarBls12381Gt) One() Scalar
```

### func \(\*ScalarBls12381Gt\) [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1190>)

```go
func (s *ScalarBls12381Gt) Point() Point
```

### func \(\*ScalarBls12381Gt\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L921>)

```go
func (s *ScalarBls12381Gt) Random(reader io.Reader) Scalar
```

### func \(\*ScalarBls12381Gt\) [SetBigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1180>)

```go
func (s *ScalarBls12381Gt) SetBigInt(v *big.Int) (Scalar, error)
```

### func \(\*ScalarBls12381Gt\) [SetBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1198>)

```go
func (s *ScalarBls12381Gt) SetBytes(bytes []byte) (Scalar, error)
```

### func \(\*ScalarBls12381Gt\) [SetBytesWide](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1206>)

```go
func (s *ScalarBls12381Gt) SetBytesWide(bytes []byte) (Scalar, error)
```

### func \(\*ScalarBls12381Gt\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1101>)

```go
func (s *ScalarBls12381Gt) Sqrt() (Scalar, error)
```

### func \(\*ScalarBls12381Gt\) [Square](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1077>)

```go
func (s *ScalarBls12381Gt) Square() Scalar
```

### func \(\*ScalarBls12381Gt\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1128>)

```go
func (s *ScalarBls12381Gt) Sub(rhs Scalar) Scalar
```

### func \(\*ScalarBls12381Gt\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L997>)

```go
func (s *ScalarBls12381Gt) UnmarshalBinary(input []byte) error
```

### func \(\*ScalarBls12381Gt\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1031>)

```go
func (s *ScalarBls12381Gt) UnmarshalJSON(input []byte) error
```

### func \(\*ScalarBls12381Gt\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L1014>)

```go
func (s *ScalarBls12381Gt) UnmarshalText(input []byte) error
```

### func \(\*ScalarBls12381Gt\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/bls12381_curve.go#L977>)

```go
func (s *ScalarBls12381Gt) Zero() Scalar
```

## type [ScalarEd25519](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L23-L25>)

```go
type ScalarEd25519 struct {
    // contains filtered or unexported fields
}
```

### func \(\*ScalarEd25519\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L152>)

```go
func (s *ScalarEd25519) Add(rhs Scalar) Scalar
```

### func \(\*ScalarEd25519\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L233>)

```go
func (s *ScalarEd25519) BigInt() *big.Int
```

### func \(\*ScalarEd25519\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L239>)

```go
func (s *ScalarEd25519) Bytes() []byte
```

### func \(\*ScalarEd25519\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L292>)

```go
func (s *ScalarEd25519) Clone() Scalar
```

### func \(\*ScalarEd25519\) [Cmp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L113>)

```go
func (s *ScalarEd25519) Cmp(rhs Scalar) int
```

### func \(\*ScalarEd25519\) [Cube](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L146>)

```go
func (s *ScalarEd25519) Cube() Scalar
```

### func \(\*ScalarEd25519\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L197>)

```go
func (s *ScalarEd25519) Div(rhs Scalar) Scalar
```

### func \(\*ScalarEd25519\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L127>)

```go
func (s *ScalarEd25519) Double() Scalar
```

### func \(\*ScalarEd25519\) [GetEdwardsScalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L332>)

```go
func (s *ScalarEd25519) GetEdwardsScalar() *edwards25519.Scalar
```

### func \(\*ScalarEd25519\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L42>)

```go
func (s *ScalarEd25519) Hash(bytes []byte) Scalar
```

### func \(\*ScalarEd25519\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L133>)

```go
func (s *ScalarEd25519) Invert() (Scalar, error)
```

### func \(\*ScalarEd25519\) [IsEven](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L86>)

```go
func (s *ScalarEd25519) IsEven() bool
```

### func \(\*ScalarEd25519\) [IsOdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L82>)

```go
func (s *ScalarEd25519) IsOdd() bool
```

### func \(\*ScalarEd25519\) [IsOne](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L73>)

```go
func (s *ScalarEd25519) IsOne() bool
```

### func \(\*ScalarEd25519\) [IsZero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L65>)

```go
func (s *ScalarEd25519) IsZero() bool
```

### func \(\*ScalarEd25519\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L298>)

```go
func (s *ScalarEd25519) MarshalBinary() ([]byte, error)
```

### func \(\*ScalarEd25519\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L340>)

```go
func (s *ScalarEd25519) MarshalJSON() ([]byte, error)
```

### func \(\*ScalarEd25519\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L315>)

```go
func (s *ScalarEd25519) MarshalText() ([]byte, error)
```

### func \(\*ScalarEd25519\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L174>)

```go
func (s *ScalarEd25519) Mul(rhs Scalar) Scalar
```

### func \(\*ScalarEd25519\) [MulAdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L185>)

```go
func (s *ScalarEd25519) MulAdd(y, z Scalar) Scalar
```

### func \(\*ScalarEd25519\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L208>)

```go
func (s *ScalarEd25519) Neg() Scalar
```

### func \(\*ScalarEd25519\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L90>)

```go
func (s *ScalarEd25519) New(input int) Scalar
```

### func \(\*ScalarEd25519\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L59>)

```go
func (s *ScalarEd25519) One() Scalar
```

### func \(\*ScalarEd25519\) [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L288>)

```go
func (s *ScalarEd25519) Point() Point
```

### func \(\*ScalarEd25519\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L33>)

```go
func (s *ScalarEd25519) Random(reader io.Reader) Scalar
```

### func \(\*ScalarEd25519\) [SetBigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L214>)

```go
func (s *ScalarEd25519) SetBigInt(x *big.Int) (Scalar, error)
```

### func \(\*ScalarEd25519\) [SetBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L245>)

```go
func (s *ScalarEd25519) SetBytes(input []byte) (Scalar, error)
```

SetBytes takes input a 32\-byte long array and returns a ed25519 scalar\. The input must be 32\-byte long and must be a reduced bytes\.

### func \(\*ScalarEd25519\) [SetBytesCanonical](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L284>)

```go
func (s *ScalarEd25519) SetBytesCanonical(bytes []byte) (Scalar, error)
```

SetBytesCanonical uses SetCanonicalBytes of fillipo\.io/edwards25519\. https://github.com/FiloSottile/edwards25519/blob/v1.0.0-rc.1/scalar.go#L98 This function takes an input x and sets s = x\, where x is a 32\-byte little\-endian encoding of s\, then it returns the corresponding ed25519 scalar\. If the input is not a canonical encoding of s\, it returns nil and an error\.

### func \(\*ScalarEd25519\) [SetBytesClamping](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L271>)

```go
func (s *ScalarEd25519) SetBytesClamping(bytes []byte) (Scalar, error)
```

SetBytesClamping uses SetBytesWithClamping of fillipo\.io/edwards25519\- https://github.com/FiloSottile/edwards25519/blob/v1.0.0-rc.1/scalar.go#L135 which applies the buffer pruning described in RFC 8032\, Section 5\.1\.5 \(also known as clamping\) and sets bytes to the result\. The input must be 32\-byte long\, and it is not modified\. If bytes is not of the right length\, SetBytesWithClamping returns nil and an error\, and the receiver is unchanged\.

### func \(\*ScalarEd25519\) [SetBytesWide](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L259>)

```go
func (s *ScalarEd25519) SetBytesWide(bytes []byte) (Scalar, error)
```

SetBytesWide takes input a 64\-byte long byte array\, reduce it and return an ed25519 scalar\. It uses SetUniformBytes of fillipo\.io/edwards25519 \- https://github.com/FiloSottile/edwards25519/blob/v1.0.0-rc.1/scalar.go#L85 If bytes is not of the right length\, it returns nil and an error

### func \(\*ScalarEd25519\) [SetEdwardsScalar](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L336>)

```go
func (s *ScalarEd25519) SetEdwardsScalar(sc *edwards25519.Scalar) *ScalarEd25519
```

### func \(\*ScalarEd25519\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L139>)

```go
func (s *ScalarEd25519) Sqrt() (Scalar, error)
```

### func \(\*ScalarEd25519\) [Square](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L122>)

```go
func (s *ScalarEd25519) Square() Scalar
```

### func \(\*ScalarEd25519\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L163>)

```go
func (s *ScalarEd25519) Sub(rhs Scalar) Scalar
```

### func \(\*ScalarEd25519\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L302>)

```go
func (s *ScalarEd25519) UnmarshalBinary(input []byte) error
```

### func \(\*ScalarEd25519\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L344>)

```go
func (s *ScalarEd25519) UnmarshalJSON(input []byte) error
```

### func \(\*ScalarEd25519\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L319>)

```go
func (s *ScalarEd25519) UnmarshalText(input []byte) error
```

### func \(\*ScalarEd25519\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/ed25519_curve.go#L53>)

```go
func (s *ScalarEd25519) Zero() Scalar
```

## type [ScalarK256](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L20-L22>)

```go
type ScalarK256 struct {
    // contains filtered or unexported fields
}
```

### func \(\*ScalarK256\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L126>)

```go
func (s *ScalarK256) Add(rhs Scalar) Scalar
```

### func \(\*ScalarK256\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L200>)

```go
func (s *ScalarK256) BigInt() *big.Int
```

### func \(\*ScalarK256\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L204>)

```go
func (s *ScalarK256) Bytes() []byte
```

### func \(\*ScalarK256\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L235>)

```go
func (s *ScalarK256) Clone() Scalar
```

### func \(\*ScalarK256\) [Cmp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L86>)

```go
func (s *ScalarK256) Cmp(rhs Scalar) int
```

### func \(\*ScalarK256\) [Cube](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L120>)

```go
func (s *ScalarK256) Cube() Scalar
```

### func \(\*ScalarK256\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L166>)

```go
func (s *ScalarK256) Div(rhs Scalar) Scalar
```

### func \(\*ScalarK256\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L101>)

```go
func (s *ScalarK256) Double() Scalar
```

### func \(\*ScalarK256\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L37>)

```go
func (s *ScalarK256) Hash(bytes []byte) Scalar
```

### func \(\*ScalarK256\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L108>)

```go
func (s *ScalarK256) Invert() (Scalar, error)
```

### func \(\*ScalarK256\) [IsEven](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L72>)

```go
func (s *ScalarK256) IsEven() bool
```

### func \(\*ScalarK256\) [IsOdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L68>)

```go
func (s *ScalarK256) IsOdd() bool
```

### func \(\*ScalarK256\) [IsOne](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L64>)

```go
func (s *ScalarK256) IsOne() bool
```

### func \(\*ScalarK256\) [IsZero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L60>)

```go
func (s *ScalarK256) IsZero() bool
```

### func \(\*ScalarK256\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L241>)

```go
func (s *ScalarK256) MarshalBinary() ([]byte, error)
```

### func \(\*ScalarK256\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L275>)

```go
func (s *ScalarK256) MarshalJSON() ([]byte, error)
```

### func \(\*ScalarK256\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L258>)

```go
func (s *ScalarK256) MarshalText() ([]byte, error)
```

### func \(\*ScalarK256\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L150>)

```go
func (s *ScalarK256) Mul(rhs Scalar) Scalar
```

### func \(\*ScalarK256\) [MulAdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L162>)

```go
func (s *ScalarK256) MulAdd(y, z Scalar) Scalar
```

### func \(\*ScalarK256\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L180>)

```go
func (s *ScalarK256) Neg() Scalar
```

### func \(\*ScalarK256\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L76>)

```go
func (s *ScalarK256) New(value int) Scalar
```

### func \(\*ScalarK256\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L54>)

```go
func (s *ScalarK256) One() Scalar
```

### func \(\*ScalarK256\) [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L231>)

```go
func (s *ScalarK256) Point() Point
```

### func \(\*ScalarK256\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L28>)

```go
func (s *ScalarK256) Random(reader io.Reader) Scalar
```

### func \(\*ScalarK256\) [SetBigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L187>)

```go
func (s *ScalarK256) SetBigInt(v *big.Int) (Scalar, error)
```

### func \(\*ScalarK256\) [SetBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L209>)

```go
func (s *ScalarK256) SetBytes(bytes []byte) (Scalar, error)
```

### func \(\*ScalarK256\) [SetBytesWide](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L220>)

```go
func (s *ScalarK256) SetBytesWide(bytes []byte) (Scalar, error)
```

### func \(\*ScalarK256\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L114>)

```go
func (s *ScalarK256) Sqrt() (Scalar, error)
```

### func \(\*ScalarK256\) [Square](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L95>)

```go
func (s *ScalarK256) Square() Scalar
```

### func \(\*ScalarK256\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L138>)

```go
func (s *ScalarK256) Sub(rhs Scalar) Scalar
```

### func \(\*ScalarK256\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L245>)

```go
func (s *ScalarK256) UnmarshalBinary(input []byte) error
```

### func \(\*ScalarK256\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L279>)

```go
func (s *ScalarK256) UnmarshalJSON(input []byte) error
```

### func \(\*ScalarK256\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L262>)

```go
func (s *ScalarK256) UnmarshalText(input []byte) error
```

### func \(\*ScalarK256\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/k256_curve.go#L48>)

```go
func (s *ScalarK256) Zero() Scalar
```

## type [ScalarP256](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L19-L21>)

```go
type ScalarP256 struct {
    // contains filtered or unexported fields
}
```

### func \(\*ScalarP256\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L125>)

```go
func (s *ScalarP256) Add(rhs Scalar) Scalar
```

### func \(\*ScalarP256\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L199>)

```go
func (s *ScalarP256) BigInt() *big.Int
```

### func \(\*ScalarP256\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L203>)

```go
func (s *ScalarP256) Bytes() []byte
```

### func \(\*ScalarP256\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L234>)

```go
func (s *ScalarP256) Clone() Scalar
```

### func \(\*ScalarP256\) [Cmp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L85>)

```go
func (s *ScalarP256) Cmp(rhs Scalar) int
```

### func \(\*ScalarP256\) [Cube](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L119>)

```go
func (s *ScalarP256) Cube() Scalar
```

### func \(\*ScalarP256\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L165>)

```go
func (s *ScalarP256) Div(rhs Scalar) Scalar
```

### func \(\*ScalarP256\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L100>)

```go
func (s *ScalarP256) Double() Scalar
```

### func \(\*ScalarP256\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L36>)

```go
func (s *ScalarP256) Hash(bytes []byte) Scalar
```

### func \(\*ScalarP256\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L107>)

```go
func (s *ScalarP256) Invert() (Scalar, error)
```

### func \(\*ScalarP256\) [IsEven](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L71>)

```go
func (s *ScalarP256) IsEven() bool
```

### func \(\*ScalarP256\) [IsOdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L67>)

```go
func (s *ScalarP256) IsOdd() bool
```

### func \(\*ScalarP256\) [IsOne](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L63>)

```go
func (s *ScalarP256) IsOne() bool
```

### func \(\*ScalarP256\) [IsZero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L59>)

```go
func (s *ScalarP256) IsZero() bool
```

### func \(\*ScalarP256\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L240>)

```go
func (s *ScalarP256) MarshalBinary() ([]byte, error)
```

### func \(\*ScalarP256\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L274>)

```go
func (s *ScalarP256) MarshalJSON() ([]byte, error)
```

### func \(\*ScalarP256\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L257>)

```go
func (s *ScalarP256) MarshalText() ([]byte, error)
```

### func \(\*ScalarP256\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L149>)

```go
func (s *ScalarP256) Mul(rhs Scalar) Scalar
```

### func \(\*ScalarP256\) [MulAdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L161>)

```go
func (s *ScalarP256) MulAdd(y, z Scalar) Scalar
```

### func \(\*ScalarP256\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L179>)

```go
func (s *ScalarP256) Neg() Scalar
```

### func \(\*ScalarP256\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L75>)

```go
func (s *ScalarP256) New(value int) Scalar
```

### func \(\*ScalarP256\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L53>)

```go
func (s *ScalarP256) One() Scalar
```

### func \(\*ScalarP256\) [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L230>)

```go
func (s *ScalarP256) Point() Point
```

### func \(\*ScalarP256\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L27>)

```go
func (s *ScalarP256) Random(reader io.Reader) Scalar
```

### func \(\*ScalarP256\) [SetBigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L186>)

```go
func (s *ScalarP256) SetBigInt(v *big.Int) (Scalar, error)
```

### func \(\*ScalarP256\) [SetBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L208>)

```go
func (s *ScalarP256) SetBytes(bytes []byte) (Scalar, error)
```

### func \(\*ScalarP256\) [SetBytesWide](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L219>)

```go
func (s *ScalarP256) SetBytesWide(bytes []byte) (Scalar, error)
```

### func \(\*ScalarP256\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L113>)

```go
func (s *ScalarP256) Sqrt() (Scalar, error)
```

### func \(\*ScalarP256\) [Square](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L94>)

```go
func (s *ScalarP256) Square() Scalar
```

### func \(\*ScalarP256\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L137>)

```go
func (s *ScalarP256) Sub(rhs Scalar) Scalar
```

### func \(\*ScalarP256\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L244>)

```go
func (s *ScalarP256) UnmarshalBinary(input []byte) error
```

### func \(\*ScalarP256\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L278>)

```go
func (s *ScalarP256) UnmarshalJSON(input []byte) error
```

### func \(\*ScalarP256\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L261>)

```go
func (s *ScalarP256) UnmarshalText(input []byte) error
```

### func \(\*ScalarP256\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/p256_curve.go#L47>)

```go
func (s *ScalarP256) Zero() Scalar
```

## type [ScalarPallas](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L209-L211>)

ScalarPallas \- New interface

```go
type ScalarPallas struct {
    // contains filtered or unexported fields
}
```

### func \(\*ScalarPallas\) [Add](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L319>)

```go
func (s *ScalarPallas) Add(rhs Scalar) Scalar
```

### func \(\*ScalarPallas\) [BigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L382>)

```go
func (s *ScalarPallas) BigInt() *big.Int
```

### func \(\*ScalarPallas\) [Bytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L386>)

```go
func (s *ScalarPallas) Bytes() []byte
```

### func \(\*ScalarPallas\) [Clone](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L421>)

```go
func (s *ScalarPallas) Clone() Scalar
```

### func \(\*ScalarPallas\) [Cmp](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L270>)

```go
func (s *ScalarPallas) Cmp(rhs Scalar) int
```

### func \(\*ScalarPallas\) [Cube](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L311>)

```go
func (s *ScalarPallas) Cube() Scalar
```

### func \(\*ScalarPallas\) [Div](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L356>)

```go
func (s *ScalarPallas) Div(rhs Scalar) Scalar
```

### func \(\*ScalarPallas\) [Double](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L285>)

```go
func (s *ScalarPallas) Double() Scalar
```

### func \(\*ScalarPallas\) [GetFq](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L427>)

```go
func (s *ScalarPallas) GetFq() *fq.Fq
```

### func \(\*ScalarPallas\) [Hash](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L222>)

```go
func (s *ScalarPallas) Hash(bytes []byte) Scalar
```

### func \(\*ScalarPallas\) [Invert](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L291>)

```go
func (s *ScalarPallas) Invert() (Scalar, error)
```

### func \(\*ScalarPallas\) [IsEven](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L259>)

```go
func (s *ScalarPallas) IsEven() bool
```

### func \(\*ScalarPallas\) [IsOdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L255>)

```go
func (s *ScalarPallas) IsOdd() bool
```

### func \(\*ScalarPallas\) [IsOne](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L251>)

```go
func (s *ScalarPallas) IsOne() bool
```

### func \(\*ScalarPallas\) [IsZero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L247>)

```go
func (s *ScalarPallas) IsZero() bool
```

### func \(\*ScalarPallas\) [MarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L436>)

```go
func (s *ScalarPallas) MarshalBinary() ([]byte, error)
```

### func \(\*ScalarPallas\) [MarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L470>)

```go
func (s *ScalarPallas) MarshalJSON() ([]byte, error)
```

### func \(\*ScalarPallas\) [MarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L453>)

```go
func (s *ScalarPallas) MarshalText() ([]byte, error)
```

### func \(\*ScalarPallas\) [Mul](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L341>)

```go
func (s *ScalarPallas) Mul(rhs Scalar) Scalar
```

### func \(\*ScalarPallas\) [MulAdd](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L352>)

```go
func (s *ScalarPallas) MulAdd(y, z Scalar) Scalar
```

### func \(\*ScalarPallas\) [Neg](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L370>)

```go
func (s *ScalarPallas) Neg() Scalar
```

### func \(\*ScalarPallas\) [New](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L263>)

```go
func (s *ScalarPallas) New(value int) Scalar
```

### func \(\*ScalarPallas\) [One](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L241>)

```go
func (s *ScalarPallas) One() Scalar
```

### func \(\*ScalarPallas\) [Point](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L417>)

```go
func (s *ScalarPallas) Point() Point
```

### func \(\*ScalarPallas\) [Random](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L213>)

```go
func (s *ScalarPallas) Random(reader io.Reader) Scalar
```

### func \(\*ScalarPallas\) [SetBigInt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L376>)

```go
func (s *ScalarPallas) SetBigInt(v *big.Int) (Scalar, error)
```

### func \(\*ScalarPallas\) [SetBytes](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L391>)

```go
func (s *ScalarPallas) SetBytes(bytes []byte) (Scalar, error)
```

### func \(\*ScalarPallas\) [SetBytesWide](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L406>)

```go
func (s *ScalarPallas) SetBytesWide(bytes []byte) (Scalar, error)
```

### func \(\*ScalarPallas\) [SetFq](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L431>)

```go
func (s *ScalarPallas) SetFq(fq *fq.Fq) *ScalarPallas
```

### func \(\*ScalarPallas\) [Sqrt](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L301>)

```go
func (s *ScalarPallas) Sqrt() (Scalar, error)
```

### func \(\*ScalarPallas\) [Square](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L279>)

```go
func (s *ScalarPallas) Square() Scalar
```

### func \(\*ScalarPallas\) [Sub](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L330>)

```go
func (s *ScalarPallas) Sub(rhs Scalar) Scalar
```

### func \(\*ScalarPallas\) [UnmarshalBinary](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L440>)

```go
func (s *ScalarPallas) UnmarshalBinary(input []byte) error
```

### func \(\*ScalarPallas\) [UnmarshalJSON](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L474>)

```go
func (s *ScalarPallas) UnmarshalJSON(input []byte) error
```

### func \(\*ScalarPallas\) [UnmarshalText](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L457>)

```go
func (s *ScalarPallas) UnmarshalText(input []byte) error
```

### func \(\*ScalarPallas\) [Zero](<https://github.com/coinbase/kryptology/blob/master/pkg/core/curves/pallas_curve.go#L235>)

```go
func (s *ScalarPallas) Zero() Scalar
```



Generated by [gomarkdoc](<https://github.com/princjef/gomarkdoc>)
